/*
 * MONGO READ  - simple possible program to read a file - suitable for benchmarking FS read performance
 */

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <malloc.h>
#include <unistd.h>

int main (int argc, char ** argv)
{
  int fd, rd;
  char * buf;
  int bufsize=4096;

  if (argc < 2) {
    printf ("\nUsage: %s filename [buffer_size]\n\n", argv[0]);
    return 0;
  }
  if (argc == 3)
     bufsize = atoi(argv[2]);
  buf = (char *)malloc (bufsize);
  if (buf == 0) {
    printf ("Malloc failed on %d\n", bufsize);
    return 0;
  }

  fd = open (argv[1], O_RDONLY);
  if (fd == -1) {
    printf ("Open failed (%s)\n", strerror (errno));
    return 0;
  }

  while ((rd = read (fd, buf, bufsize)) == bufsize)
    ;

  free (buf);
  if (rd == -1) {
    printf ("Read failed (%s)\n", strerror (errno));
    return 0;
  }

  return 0;
}
