/********************************************************************************
 *                  QLOGIC LINUX SOFTWARE
 *
 * QLogic ISP2x00 device driver for Linux 2.3.x (redhat 6.X).
 *
 * COPYRIGHT (C) 1999-2000 QLOGIC CORPORATION    
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Qlogic's Linux Software License. See below.
 *
 * This program is WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistribution's or source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 ********************************************************************************/
 
/*****************************************************************************************
			QLOGIC CORPORATION SOFTWARE
           "GNU" GENERAL PUBLIC LICENSE
    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION
                 AND MODIFICATION

This GNU General Public License ("License") applies solely to QLogic Linux 
Software ("Software") and may be distributed under the terms of this License.  
 
1. You may copy and distribute verbatim copies of the Software's source code as 
you receive it, in any medium, provided that you conspicuously and appropriately 
publish on each copy an appropriate copyright notice and disclaimer of warranty;
keep intact all the notices that refer to this License and to the absence of any
warranty; and give any other recipients of the Software a copy of this License along
with the Software. 

You may charge a fee for the physical act of transferring a copy, and you may at your
option offer warranty protection in exchange for a fee.
 
2. You may modify your copy or copies of the Software or any portion of it, thus forming
a work based on the Software, and copy and distribute such modifications or work under
the terms of Section 1 above, provided that you also meet all of these conditions:
 
* a) You must cause the modified files to carry prominent notices stating that you
changed the files and the date of any change. 

* b) You must cause any work that you distribute or publish that in whole or in part
contains or is derived from the Software or any part thereof, to be licensed as a
whole at no charge to all third parties under the terms of this License. 

* c) If the modified Software normally reads commands interactively when run, you
must cause it, when started running for such interactive use in the most ordinary way,
to print or display an announcement including an appropriate copyright notice and a 
notice that there is no warranty (or else, saying that you provide a warranty) and that
users may redistribute the Software under these conditions, and telling the user how to
view a copy of this License. (Exception:if the Software itself is interactive but does 
not normally print such an announcement, your work based on the Software is not required
to print an announcement.) 

These requirements apply to the modified work as a whole. If identifiable sections of
that work are not derived from the Software, and can be reasonably considered independent
and separate works in themselves, then this License, and its terms, do not apply to those
sections when you distribute them as separate works. But when you distribute the same
sections as part of a whole which is a work based on the Software, the distribution of the
whole must be on the terms of this License, whose permissions for other licensees extend
to the entire whole, and thus to each and every part regardless of who wrote it. 

3. You may copy and distribute the Software (or a work based on it, under Section 2) in 
object code or executable form under the terms of Sections 1 and 2 above provided that
you also do one of the following: 

* a) Accompany it with the complete corresponding machine-readable source code, which must
be distributed under the terms of Sections 1 and 2 above on a medium customarily used for
software interchange; or, 

* b) Accompany it with a written offer, valid for at least three years, to give any third
party, for a charge no more than your cost of physically performing source distribution,
a complete machine-readable copy of the corresponding source code, to be distributed under
the terms of Sections 1 and 2 above on a medium customarily used for software interchange;
or,

* c) Accompany it with the information you received as to the offer to distribute 
corresponding source code. (This alternative is allowed only for noncommercial distribution
and only if you received the Software in object code or executable form with such an offer,
in accord with Subsection b above.) 

The source code for a work means the preferred form of the work for making modifications
to it. For an executable work, complete source code means all the source code for all 
modules it contains, plus any associated interface definition files, plus the scripts used
to control compilation and installation of the executable.     

If distribution of executable or object code is made by offering access to copy from a 
designated place, then offering equivalent access to copy the source code from the same
place counts as distribution of the source code, even though third parties are not 
compelled to copy the source along with the object code. 

4. You may not copy, modify, sublicense, or distribute the Software except as expressly 
provided under this License. Any attempt otherwise to copy, modify, sublicense or 
distribute the Software is void, and will automatically terminate your rights under this
License. However, parties who have received copies, or rights, from you under this License
will not have their licenses terminated so long as such parties remain in full compliance. 

5. This license grants you world wide, royalty free non-exclusive rights to modify or 
distribute the Software or its derivative works. These actions are prohibited by law 
if you do not accept this License. Therefore, by modifying or distributing the Software
(or any work based on the Software), you indicate your acceptance of this License to do
so, and all its terms and conditions for copying, distributing or modifying the Software
or works based on it.
 
6. Each time you redistribute the Software (or any work based on the Software), the 
recipient automatically receives a license from the original licensor to copy, distribute
or modify the Software subject to these terms and conditions. You may not impose any 
further restrictions on the recipients' exercise of the rights granted herein. You are
not responsible for enforcing compliance by third parties to this License.
 
7. If, as a consequence of a court judgment or allegation of patent infringement or for
any other reason (not limited to patent issues), conditions are imposed on you 
(whether by court order, agreement or otherwise) that contradict the conditions of this
License, they do not excuse you from the conditions of this License. If you cannot 
distribute so as to satisfy simultaneously your obligations under this License 
and any other pertinent obligations, then as a consequence you may not distribute the
Software at all.    

If any portion of this section is held invalid or unenforceable under any particular 
circumstance, the balance of the section is intended to apply and the section as a whole
is intended to apply in other circumstances. 
NO WARRANTY

11. THE SOFTWARE IS PROVIDEDWITHOUT A WARRANTY OF ANY KIND. THERE IS NO 
WARRANTY FOR THE SOFTWARE, TO THE EXTENT PERMITTED BY APPLICABLE LAW. 
EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR 
OTHER PARTIES PROVIDE THE SOFTWARE "AS IS" WITHOUT WARRANTY OF ANY KIND, 
EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE 
ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOFTWARE IS WITH YOU. 
SHOULD THE SOFTWARE PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL 
NECESSARY SERVICING, REPAIR OR CORRECTION.
 
12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR 
REDISTRIBUTE THE SOFTWARE AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE SOFTWARE (INCLUDING 
BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR 
LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE SOFTWARE TO 
OPERATE WITH ANY OTHER SOFTWARES), EVEN IF SUCH HOLDER OR OTHER PARTY HAS 
BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 
END OF TERMS AND CONDITIONS 

****************************************************************************************/ 

/****************************************************************************
    Revision History:
    Rev. 3.02       March 15 , 2000      BJ
         - Firmware update
    Rev. 3.01       Feb 11, 2000      DG & Bjnima
         - Changed hiwait to execution_throttle value in nvram. The scsi layer
           will allocate that number of cmd structs per lun.
         - Added additional changes for 64-bit support.
         - Code compilable in kernel version 2.2.x
		 - Set version to 3.01-Alpha
    Rev. 3.00       Jan 17, 1999      DG
         - Added changes for 64-bit and kernel 2.3.x
    Rev. 2.10       Oct 31, 1999      DG
        - Fixed issue of not releasing requests if port is down (DPC issue).
        - Ignore BIOS setting for MAX number of luns unless USE_BIOS_MAX_LUNS
          is set.
    Rev. 2.09       Oct 30, 1999      DG
         - Fixed panic that occurs when a port is remove and init. The target
           ID assigning code did not check for PORT_AVAILABLE.
    Rev. 2.08       Oct 15, 1999      DG
         - Fixed timeout logic for dealing with LIPs.
    Rev. 2.07       Oct 14, 1999      DG
         - Fixed the issue of /proc/scsi/qla displaying garbage.
           qla2100_proc_info always returns zero.
    Rev. 2.06       Oct 14, 1999      DG
         - Fixed the issue of not setting the SCSI request sense bit in the 
           the driver_byte when the host_byte was good.
    Rev. 2.05       Oct 12, 1999      DG
         - Replace RISC code version 2.0.31 to 2.0.40 for QLA2200 Adapters.
         - Added logic to always set the tag attribute byte, no matter if the
           device has tags enabled or not. Some devices will check FCMND for
           a tag attribute byte.
    Rev. 2.04       Sept 30, 1999      DG
         - Replace RISC code version 1.17.26 to 1.17.30 for QLA2100 Adapters.
         - Replace RISC code version 2.0.27 to 2.0.31 for QLA2200 Adapters.
         - Added option to use unique firmware array names. The latest 
           firmware source files already include unique array names.  
         - The firmware include file for 2100 have been change from isp_fw.h
           to 2100ef.h
         - The firmware include files for 2200 have been change from isp1_fw.h 
           to 2200ef.h
    Rev. 2.03       Sept 16, 1999      DG
         - Added option to use the portname instead of nodename to identify the port.
         - Fixed timeout cause by multiple luns. Requests were setting in the input queue
           because of a limited number of RISC requests queues.
    Rev. 2.02       Sept 13, 1999      DG
         - The code that wait for LIP was not functioning properly. Since some
           devices take a long time to complete the LIP. 
    Rev. 2.01       Sept 9, 1999      DG
	  - Fixed system crash when mid-level issues a device reset that requires
	    aborting the LU_Q queues.
	  - Added handling for Overflow detection and FCP_STATUS errors. 
         - Cleanup code.
    Rev. 2.00       Aug 27, 1999      DG
		Changes to load as static driver linked with Redhat release 6.0
		kernel (2.2.5).
        - Moved the Linux SCSI host template.
        - Moved the SCSI Driver Interface Prototypes.
      - Fixed recovery logic for error code 0x28. The qla2100_timer routine
        needed to purge the retry queue whenever the port timeout expires.
      - Fixed issue of using the wrong timeout value for the 
        qla2100_timer routine.  The  2.2.x kernel uses a different 
        timeout mechmism to timeout commands. It now adds a seperate
        timeout entry for each command instead of having its own list.
	  - Eliminate the mapping of target number and luns.
	  - Convert to the new PCI routines as part of kernel 2.2.5 changes.
	  - Removing interrupt disable/enable - not necessary with locks. 
	  - Eliminate the spurious interrupts. 
	  - Added logic to select the appropriate F/W depending on the board type 
	    we are using 2100, 2100A or 2200.
    Rev. 1.21       June 8, 1999      DG
       - Added 2200 support.
    Rev. 1.20       June 8, 1999      DG
         Changes to support RedHat release 6.0 (kernel 2.2.5).  
       - Added SCSI exclusive access lock (io_request_lock) when accessing the adapter.
       - Added the new LINUX interface template. Some new error handling routines have been 
         added to the template, but for now we will use the old ones.

    Rev. 1.00       January 30, 1999  DG 
    -   Initial Release.  
*****************************************************************************/

#include <linux/config.h>
#include <linux/version.h>
#ifdef MODULE
#include <linux/module.h>
#endif

#ifndef KERNEL_VERSION
#  define KERNEL_VERSION(x,y,z) (((x)<<16)+((y)<<8)+(z))
#endif

#define QLA2100_VERSION      " 3.02-Alpha"
#define UNIQUE_FW_NAME       /* unique F/W array names */

#include <stdarg.h>
#include <asm/io.h>
#include <asm/irq.h>
#include <asm/segment.h>
#include <asm/byteorder.h>
#include <linux/types.h>
#include <linux/string.h>
#include <linux/errno.h>
#include <linux/kernel.h>
#include <linux/ioport.h>
#include <linux/delay.h>
#include <linux/timer.h>
#include <linux/sched.h>
#include <linux/pci.h>
#include <linux/proc_fs.h>
#include <linux/blk.h>
#include <linux/tqueue.h>
#include <linux/interrupt.h>
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
# include <linux/bios32.h>
#else
#include <linux/spinlock.h>

#define __KERNEL_SYSCALLS__

#include <linux/unistd.h>
#include <linux/smp_lock.h>

#include <asm/system.h>
#define SHUTDOWN_SIGS	(sigmask(SIGKILL)|sigmask(SIGINT)|sigmask(SIGTERM))
#endif
#include "sd.h"
#include "scsi.h"
#include "hosts.h"
#include "qla2100.h"
#ifdef UNIQUE_FW_NAME
#include "ql2100_fw.h"                     /* ISP RISC code */
#include "ql2200_fw.h"                     /* ISP RISC 2200 code */
#else
#include "isp_fw.h"                     /* ISP RISC code */
#include "isp1_fw.h"                     /* ISP RISC 2200 code */
#endif
#include <linux/stat.h>
#include <linux/malloc.h>        /* for kmalloc() */


/*
 * Compile time Options: 
 *            0 - Disable and 1 - Enable 
 */
#define  QLA2100_64BIT_SUPPORT         1   /* 64-bit Support */
#define  QL2100_TARGET_MODE_SUPPORT    0   /* Target mode support */
#define  MEMORY_MAPPED_IO              0
#define  DEBUG_QLA2100_INTR            0
#define  USE_NVRAM_DEFAULTS	       0
#define  DEBUG_PRINT_NVRAM             0
#define  LOADING_RISC_ACTIVITY         0
#define  AUTO_ESCALATE_RESET           0   /* Automatically escalate resets */
#define  AUTO_ESCALATE_ABORT           0   /* Automatically escalate aborts */
#define  STOP_ON_ERROR                 0   /* Stop on aborts and resets  */
#define  STOP_ON_RESET                 0 
#define  STOP_ON_ABORT                 0 
#define  QLA2100_COMTRACE              0    /* One char tracing  */
#define  DEBUG_QLA2100                 0    /* Debugging  */
#define  WATCH_THREADS_SIZ             0    /* watch size of pending queue */
#define  USE_PORTNAME                  1    /* option to use portnames to distinch with target we are talking too */
#undef   TRACECODE                          /* include tracing code in watchdog routines */

/* Always set */
#define  QLA2100_OS_TIMER              1

/*
 * These macros to assist programming
 */

#define  BZERO(ptr, amt)		memset((ptr), 0, amt)
#define  BCOPY(src, dst, amt)	memcpy((dst), src, amt)
#define  KMALLOC(siz)	kmalloc((siz), GFP_ATOMIC | GFP_DMA)
#define  KMFREE(ip,siz)	kfree((ip))
#define  SYS_DELAY(x)		udelay(x);barrier()
#define  QLA2100_DELAY(sec)  mdelay(sec * HZ)
#define  VIRT_TO_BUS(a) virt_to_bus((a))

#if  QLA2100_64BIT_SUPPORT
#if  BITS_PER_LONG <= 32
#define  VIRT_TO_BUS_LOW(a) (uint32_t)virt_to_bus((a))
#define  VIRT_TO_BUS_HIGH(a) (uint32_t)(0x0)
#else
#define  VIRT_TO_BUS_LOW(a) (uint32_t)(0xffffffff & virt_to_bus((a)))
#define  VIRT_TO_BUS_HIGH(a) (uint32_t)(0xffffffff & (virt_to_bus((a))>>32))
#endif
#endif  /* QLA2100_64BIT_SUPPORT */
            
#define  CACHE_FLUSH(a) (RD_REG_WORD(a))
#define  INVALID_HANDLE    (MAX_OUTSTANDING_COMMANDS+1)

#define  STATIC     
#define  MSW(x)          (uint16_t)((uint32_t)(x) >> 16)
#define  LSW(x)          (uint16_t)(x)
#define  MSB(x)          (uint8_t)((uint16_t)(x) >> 8)
#define  LSB(x)          (uint8_t)(x)

#if  BITS_PER_LONG <= 32
#define  LS_64BITS(x) (uint32_t)(x)
#define  MS_64BITS(x) (uint32_t)(0x0)
#define  QL21_64BITS_3RDWD(x)   ((uint16_t) 0)
#define  QL21_64BITS_4THWD(x)   ((uint16_t) 0)
#else
#define  LS_64BITS(x) (uint32_t)(0xffffffff & (x))
#define  MS_64BITS(x) (uint32_t)(0xffffffff & ((x)>>32) )
#define  QL21_64BITS_3RDWD(x)   ((uint16_t) (x >> 32) & 0xffff)
#define  QL21_64BITS_4THWD(x)   ((uint16_t) (x >> 48) & 0xffff)
#endif

#define  OFFSET(w)   (((uint32_t) &w) & 0xFFFF)                  /* 256 byte offsets */

#define  SCSI_BUS_32(scp)   ((scp)->channel)
#define  SCSI_TCN_32(scp)    ((scp)->target)
#define  SCSI_LUN_32(scp)    ((scp)->lun)

/*
 * TIMER MACROS
 */
#define  QLA2100_TIMER_LOCK(ap)   spin_lock_irqsave(&(ap)->retry_lock, cpu_flags);
#define  QLA2100_TIMER_UNLOCK(ap) spin_unlock_irqrestore(&(ap)->retry_lock, cpu_flags);

#define	WATCH_INTERVAL		1       /* number of seconds */
#define	START_TIMER(f, h, w)	\
	{ \
		init_timer(&(h)->timer); \
		(h)->timer.expires = jiffies + w * HZ;\
		(h)->timer.data = (unsigned long) h; \
		(h)->timer.function = (void (*)(unsigned long))f; \
        (h)->flags.start_timer = FALSE; \
		add_timer(&(h)->timer); \
		(h)->timer_active = 1;\
	}
	
#define	RESTART_TIMER(f, h, w)	\
	{ \
		(h)->timer.expires = jiffies + w * HZ;\
        (h)->flags.start_timer = FALSE; \
		add_timer(&(h)->timer); \
	}

#define	STOP_TIMER(f, h)	\
	{ \
		del_timer(&(h)->timer); \
		(h)->timer_active = 0;\
	}

#define NVRAM_DELAY() udelay(500) /* 2 microsecond delay */

typedef unsigned long paddr32_t;

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,3,18)
#define DECLARE_MUTEX_LOCKED(sem)   struct semaphore sem = MUTEX_LOCKED
#endif

/*
 *  Qlogic Driver support Function Prototypes.
 */
STATIC uint8_t  qla2100_register_with_Linux(scsi_qla_host_t *ha, uint8_t maxchannels);
STATIC void   qla2100_done(scsi_qla_host_t *, srb_t **, srb_t **),
              qla2100_next(scsi_qla_host_t *, scsi_lu_t *),
              qla2100_select_queue_depth(struct Scsi_Host *, Scsi_Device *);
                 
STATIC void      qla2100_done_q_put(srb_t *, srb_t **, srb_t **),
                 qla2100_putq_b(scsi_lu_t *, srb_t *),
                 qla2100_putq_t(scsi_lu_t *, srb_t *),
                 qla2100_removeq(scsi_lu_t *, srb_t *),
                 qla2100_timer(scsi_qla_host_t *),
                 qla2100_timeout_insert(scsi_qla_host_t *, srb_t *),
                 qla2100_timeout_remove(scsi_qla_host_t *, srb_t *),
                 *qla2100_alloc_phys(int, u_long *phy_addr);
STATIC uint8_t   qla2100_mem_alloc(scsi_qla_host_t *);
                 
static void qla2100_dump_regs(struct Scsi_Host *host);
#if  STOP_ON_ERROR 
static void qla2100_panic(char *, struct Scsi_Host *host);
#endif
void qla2100_print_scsi_cmd(Scsi_Cmnd *cmd);
STATIC void qla2100_abort_queue_single(scsi_qla_host_t *,uint32_t,uint32_t,uint32_t,uint32_t);

STATIC int qla2100_return_status( sts_entry_t *sts, Scsi_Cmnd       *cp);
STATIC void qla2100_removeq(scsi_lu_t *q, srb_t *sp);
STATIC void qla2100_mem_free(scsi_qla_host_t *ha);
void qla2100_do_dpc(void *p);
#ifdef  QLA2100_UNUSED 
static void qla2100_set_flags(char * s);
#endif

static inline void qla2100_callback(scsi_qla_host_t *ha, srb_t *sp, uint8_t dec),
                   qla2100_tgt_dealloc(scsi_qla_host_t *, tgt_t *),
                   qla2100_lun_dealloc(scsi_lu_t *);
static inline tgt_t     *qla2100_tgt_alloc(scsi_qla_host_t *);
static inline scsi_lu_t *qla2100_lun_alloc(void);

static inline void qla2100_enable_intrs(scsi_qla_host_t *);
static inline void qla2100_disable_intrs(scsi_qla_host_t *);
static char	*qla2100_get_token(char *, char *);

/*
 *  QLogic ISP2100 Hardware Support Function Prototypes.
 */
STATIC  uint8_t  qla2100_initialize_adapter(scsi_qla_host_t *),
                 qla2100_isp_firmware(scsi_qla_host_t *),
                 qla2100_pci_config(scsi_qla_host_t *),
                 qla2100_set_cache_line(scsi_qla_host_t *),
                 qla2100_chip_diag(scsi_qla_host_t *),
                 qla2100_setup_chip(scsi_qla_host_t *),
                 qla2100_init_rings(scsi_qla_host_t *),
                 qla2100_fw_ready(scsi_qla_host_t *),
                 qla2100_nvram_config(scsi_qla_host_t *),
                 qla2200_nvram_config(scsi_qla_host_t *),
                 qla2100_mailbox_command(scsi_qla_host_t *, u_char, uint16_t *),
                 qla2100_update_device(scsi_qla_host_t *, device_data_t *, u_char),
                 qla2100_sns_device(scsi_qla_host_t *, u_char),
                 qla2100_update_fc_db(scsi_qla_host_t *, u_char),
                 qla2100_map_targets(scsi_qla_host_t *),
                 qla2100_get_database(scsi_qla_host_t *),
                 qla2100_save_database(scsi_qla_host_t *),
                 qla2100_program_flash_address(scsi_qla_host_t *, uint32_t, u_char),
                 qla2100_erase_flash_sector(scsi_qla_host_t *, uint32_t),
                 qla2100_poll_flash(scsi_qla_host_t *, uint32_t, u_char),
                 qla2100_loop_reset(scsi_qla_host_t *),
                 qla2100_device_reset(scsi_qla_host_t *, uint32_t, uint32_t),
                 qla2100_abort_device(scsi_qla_host_t *, uint32_t, uint32_t, uint32_t),
                 qla2100_abort_command(scsi_qla_host_t *, srb_t *),
#if  QLA2100_64BIT_SUPPORT
                 qla2100_64bit_start_scsi(scsi_qla_host_t *, srb_t *),
#endif  /* QLA2100_64BIT_SUPPORT */
                 qla2100_32bit_start_scsi(scsi_qla_host_t *, srb_t *),
                 qla2100_abort_isp(scsi_qla_host_t *),
                 qla2100_loop_resync(scsi_qla_host_t *);

STATIC void      qla2100_nv_write(scsi_qla_host_t *, uint16_t),
                 qla2100_nv_delay(void),
                 qla2100_poll(scsi_qla_host_t *),
                 qla2100_init_fc_db(scsi_qla_host_t *),
                 qla2100_init_tgt_map(scsi_qla_host_t *),
                 qla2100_flash_enable(scsi_qla_host_t *),
                 qla2100_flash_disable(scsi_qla_host_t *),
                 qla2100_write_flash_byte(scsi_qla_host_t *, uint32_t, u_char),
                 qla2100_reset_adapter(scsi_qla_host_t *),
                 qla2100_marker(scsi_qla_host_t *, uint32_t, uint32_t, uint32_t,
                                u_char),
                 qla2100_enable_lun(scsi_qla_host_t *),
                 qla2100_notify_ack(scsi_qla_host_t *, notify_entry_t *),
#if  QLA2100_64BIT_SUPPORT
                 qla2100_64bit_continue_io(scsi_qla_host_t *, atio_entry_t *,
                                           uint32_t, u_long *),
#endif  /* QLA2100_64BIT_SUPPORT */
                 qla2100_32bit_continue_io(scsi_qla_host_t *, atio_entry_t *,
                                           uint32_t, u_long *),
                 qla2100_isp_cmd(scsi_qla_host_t *),
                 qla2100_isr(scsi_qla_host_t *, srb_t **, srb_t **),
                 qla2100_rst_aen(scsi_qla_host_t *),
                 qla2100_atio_entry(scsi_qla_host_t *, atio_entry_t *),
                 qla2100_status_entry(scsi_qla_host_t *, sts_entry_t *, srb_t **,
                                      srb_t **),
                 qla2100_error_entry(scsi_qla_host_t *, response_t *, srb_t **,
                                     srb_t **),
                 qla2100_restart_queues(scsi_qla_host_t *, uint8_t),
                 qla2100_abort_queues(scsi_qla_host_t *, uint8_t);

STATIC uint16_t  qla2100_get_nvram_word(scsi_qla_host_t *, uint32_t),
                 qla2100_nvram_request(scsi_qla_host_t *, uint32_t),
                 qla2100_read_flash_byte(scsi_qla_host_t *, uint32_t),
                 qla2100_debounce_register(volatile uint16_t *);

STATIC request_t *qla2100_req_pkt(scsi_qla_host_t *);
uint8_t          qla2100_update_config(scsi_qla_host_t *ha);
STATIC uint8_t qla2100_configure_hba(scsi_qla_host_t *ha);
STATIC uint8_t qla2100_configure_loop(scsi_qla_host_t *ha, uint8_t );
STATIC void qla2100_reset_chip(scsi_qla_host_t *ha);
#if QL2100_TARGET_MODE_SUPPORT
                 qla2100_enable_lun(scsi_qla_host_t *, uint8_t, uint32_t),
                 qla2100_notify_ack(scsi_qla_host_t *, notify_entry_t *),
                 qla2100_immed_notify(scsi_qla_host_t *, notify_entry_t *),
                 qla2100_accept_io(scsi_qla_host_t *, ctio_ret_entry_t *),
#if  QLA2100_64BIT_SUPPORT
                 qla2100_64bit_continue_io(scsi_qla_host_t *, atio_entry_t *, uint32_t,
                                     u_long *),
#endif
                 qla2100_32bit_continue_io(scsi_qla_host_t *, atio_entry_t *, uint32_t,
                                     u_long *),
                 qla2100_atio_entry(scsi_qla_host_t *, atio_entry_t *),
                 qla2100_notify_entry(scsi_qla_host_t *, notify_entry_t *),

#endif  /* QLA2100_TARGET_MODE_SUPPORT */
STATIC uint8_t qla2100_sns_get_name( scsi_qla_host_t *ha, device_data_t *device, uint8_t flag );

void qla2100_print_q_info(scsi_lu_t *q);

#ifdef QL_DEBUG_ROUTINES
/*
 *  Driver Debug Function Prototypes.
 */
STATIC uint8_t  qla2100_getbyte(uint8_t *);
STATIC uint16_t qla2100_getword(uint16_t *);
STATIC uint32_t qla2100_getdword(uint32_t *);
STATIC void     qla2100_putbyte(uint8_t *, uint8_t),
                qla2100_putword(uint16_t *, uint16_t),
                qla2100_putdword(uint32_t *, uint32_t),
                qla2100_print(int8_t *),
                qla2100_output_number(u_long, uint8_t),
                qla2100_putc(int8_t),
                qla2100_dump_buffer(uint8_t *, uint32_t);

/* Debug print buffer */

char          debug_buff[80];
#if DEBUG_QLA2100 
STATIC uint8_t ql_debug_print = 1;
#else
STATIC uint8_t ql_debug_print = 1;
#endif
#endif

/*
 * insmod needs to find the variable and make it point to something
 */
#ifdef MODULE
static char *options = NULL;
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,1,18)

/* insmod qla2100 options=verbose" */
MODULE_PARM(options, "s");  
#endif
/*
 * Just in case someone uses commas to separate items on the insmod
 * command line, we define a dummy buffer here to avoid having insmod
 * write wild stuff into our code segment
 */
static char dummy_buffer[60] = "Please don't add commas in your insmod command!!\n";

#endif

/* 
 * Macros to change names of OS remapping routines.
 */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,0)
#define ioremap vremap
#define iounmap vfree
#endif


/*********************************************************************** 
 * We use the Scsi_Pointer structure that's included with each command
 * SCSI_Cmnd as a scratchpad for our SRB. This allows us to accept
 * an unlimited number of commands.
 *
 * SCp will always point to the SRB structure (defined in qla2100.h).
 * It is defined as follows:
 *  - SCp.ptr  -- > pointer back to the cmd
 *  - SCp.this_residual --> used as forward pointer to next srb
 *  - SCp.buffer --> used as backward pointer to next srb
 *  - SCp.buffers_residual --> used as flags field
 *  - SCp.have_data_in --> not used
 *  - SCp.sent_command --> not used
 *  - SCp.phase --> not used
 ***********************************************************************/
#define	CMD_SP(Cmnd)		(&(Cmnd)->SCp)
#define	CMD_XFRLEN(Cmnd)	(Cmnd)->request_bufflen
#define	CMD_CDBLEN(Cmnd)	(Cmnd)->cmd_len
#define	CMD_CDBP(Cmnd)		(Cmnd)->cmnd
#define	CMD_SNSP(Cmnd)		(Cmnd)->sense_buffer
#define	CMD_SNSLEN(Cmnd)	(sizeof (Cmnd)->sense_buffer)
#define	CMD_RESULT(Cmnd)	((Cmnd)->result)
#define	CMD_HANDLE(Cmnd)	((Cmnd)->host_scribble)
#define	CMD_TIMEOUT(Cmnd)	((Cmnd)->timeout_per_command)

#define DID_RETRY		DID_ERROR


/*
 * Macros use for debugging the driver.
 */
#ifdef QL_DEBUG_LEVEL_3 
#define ENTER(x)	sprintf(debug_buff,"qla2100 : Entering %s()\n\r", x); \
                        qla2100_print(debug_buff);
#define LEAVE(x)	sprintf(debug_buff,"qla2100 : Leaving %s()\n\r", x); \
                        qla2100_print(debug_buff);
#define ENTER_INTR(x)	sprintf(debug_buff,"qla2100 : Entering %s()\n\r", x); \
                        qla2100_print(debug_buff);
#define LEAVE_INTR(x)	sprintf(debug_buff,"qla2100 : Leaving %s()\n\r", x); \
                        qla2100_print(debug_buff);
#define DEBUG3(x)	x
#else
#define ENTER(x)
#define LEAVE(x)
#define ENTER_INTR(x)
#define LEAVE_INTR(x)
#define DEBUG3(x)
#endif

#if  QLA2100_COMTRACE  
#define COMTRACE(x)     qla2100_putc(x);  
#else
#define COMTRACE(x)
#endif

#if  DEBUG_QLA2100  
#define DEBUG(x)	x
#define DEBUG4(x)
#else
#define DEBUG(x)
#define DEBUG4(x)
#endif

#ifdef QL_DEBUG_LEVEL_2 
#define DEBUG2(x)          x
#else
#define DEBUG2(x)
#endif
#ifdef QL_DEBUG_LEVEL_5 
#define DEBUG5(x)          x
#else
#define DEBUG5(x)
#endif


/****************************************************************************/
/*  LINUX -  Loadable Module Functions.                                     */
/****************************************************************************/
#define	PROC_BUF	(&qla2100_buffer[size])

/*****************************************/
/*   ISP Boards supported by this driver */
/*****************************************/
#define QLA2100_VENDOR_ID   0x1077
#define QLA2100_DEVICE_ID   0x2100
#define QLA2200_DEVICE_ID   0x2200
#define QLA2200A_DEVICE_ID  0x2200A
#define QLA2200A_RISC_ROM_VER  4
#define NUM_OF_ISP_DEVICES        3

typedef struct _qlaboards 
{
   unsigned char   bdName[9];       /* Board ID String             */
   unsigned long   device_id;       /* Device ID                   */
   int   numPorts;                  /* number of loops on adapter  */
   unsigned short   *fwcode;        /* pointer to FW array         */
   unsigned long    *fwlen;         /* number of words in array    */
   unsigned short   *fwstart;       /* start address for F/W       */
   unsigned char   *fwver;          /* Ptr to F/W version array    */
} qla_boards_t;

struct _qlaboards   QL2x00BoardTbl[NUM_OF_ISP_DEVICES] = 
{
   /* Name ,  Board PCI Device ID,         Number of ports */
  {"QLA2100 ", QLA2100_DEVICE_ID,           MAX_BUSES,  
               &fw2100ef_code01[0],  (unsigned long *)&fw2100ef_length01,&fw2100ef_addr01, &fw2100ef_version_str[0] },       
  {"QLA2200 ", QLA2200_DEVICE_ID,           MAX_BUSES, 
               &fw2200ef_code01[0],  (unsigned long *)&fw2200ef_length01, &fw2200ef_addr01, &fw2200ef_version_str[0] },       
  {"        ",                 0,           0}
};

static unsigned long qla2100_verbose = 1L;
static scsi_qla_host_t *qla2100_hostlist = NULL;


#ifdef QLA2100_PROFILE
static int qla2100_buffer_size = 0;
static char *qla2100_buffer = NULL;
#endif

/*************************************************************************
 *   qla2100_set_info
 *
 * Description:
 *   Set parameters for the driver from the /proc filesystem.
 *
 * Returns:
 *************************************************************************/
int
qla2100_set_info(char *buffer, int length, struct Scsi_Host *HBAptr) {
    return (-ENOSYS);  /* Currently this is a no-op */
}

/*************************************************************************
 * qla2100_proc_info
 *
 * Description:
 *   Return information to handle /proc support for the driver.
 *
 * buffer - ptrs to a page buffer
 *
 * Returns:
 *************************************************************************/
#define LUN_ID       ( ) 
int
qla2100_proc_info( char *buffer, char **start, off_t offset, int length, 
                    int hostno, int inout) {
#ifdef QLA2100_PROFILE
    struct Scsi_Host *host;
    scsi_qla_host_t *ha;
    int    size = 0;
    int  targ_lun;
    scsi_lu_t  *up;
    int   no_devices;

    printk("Entering proc_info 0x%x,0x%lx,0x%x,0x%x\n",(int)buffer,offset,length,hostno);
    host = NULL;
    /* find the host they want to look at */
    for( ha=qla2100_hostlist; (ha != NULL) && ha->host->host_no != hostno; ha=ha->next )
        ;

    if( !ha ) {
        size += sprintf(buffer, "Can't find adapter for host number %d\n", hostno);
        if( size > length ) {
            return (size);
        } else {
            return (length);
        }
    }

    host = ha->host;
    if( inout == TRUE ) /* Has data been written to the file? */
    {
        return (qla2100_set_info(buffer, length, host));
    }

    /* compute number of active devices */
    no_devices = 0;
    for( targ_lun = 0; targ_lun < 128; targ_lun++ ) {
        if( (up = ha->dev[targ_lun]) == NULL )
            continue;
        no_devices++;
    }
    /* size = 112 * no_devices; */
    size = 4096;
    /* round up to the next page */

    /* 
    * if our old buffer is the right size use it otherwise 
    * allocate a new one.
    */
    if( qla2100_buffer_size != size ) {
        /* deallocate this buffer and get a new one */
        if( qla2100_buffer != NULL ) {
            kfree(qla2100_buffer);
            qla2100_buffer_size = 0;
        }
        qla2100_buffer = kmalloc(size, GFP_KERNEL);
    }
    if( qla2100_buffer == NULL ) {
        size = sprintf(buffer, "qla2100 - kmalloc error at line %d\n",
            __LINE__);
        return size;
    }
    qla2100_buffer_size = size;

    size = 0;
    size += sprintf(PROC_BUF, "Qlogic 2100 Fiber driver version: ");   /* 34 bytes */
    size += sprintf(PROC_BUF, "%5s, ", QLA2100_VERSION);                         /* 5        */
    size += sprintf(PROC_BUF, "Qlogic Firmware version: ");                     /* 25       */
    size += sprintf(PROC_BUF, "%2d.%2d.%2d",ql12_firmware_version[0],           /* 8        */
        ql12_firmware_version[1],
        ql12_firmware_version[2]);
    size += sprintf(PROC_BUF, "\n");                                             /* 1       */

    size += sprintf(PROC_BUF, "SCSI Host Adapter Information: %s\n", QLBoardTbl[ha->devnum].bdName);
    size += sprintf(PROC_BUF, "Request Queue = 0x%lx, Response Queue = 0x%lx\n",
        ha->request_dma,
        ha->response_dma);
    size += sprintf(PROC_BUF, "Request Queue count= 0x%lx, Response Queue count= 0x%lx\n",
        REQUEST_ENTRY_CNT,
        RESPONSE_ENTRY_CNT);
    size += sprintf("Number of pending commands = 0x%lx\n", ha->actthreads);
    size += sprintf("Number of queued commands = 0x%lx\n", ha->qthreads);
    size += sprintf("Number of free request entries = %d\n",ha->req_q_cnt);
    size += sprintf(PROC_BUF, "\n");                                             /* 1       */

    size += sprintf(PROC_BUF, "SCSI device Information:\n");
    /* scan for all equipment stats */
    for( targ_lun = 0; targ_lun < 128; targ_lun++ ) {
        if( (up = ha->dev[targ_lun]) == NULL )
            continue;
        if( up->io_cnt == 0 ) {
            size += sprintf(PROC_BUF, "(%2d:%2d:%2d) No stats\n",LUN_ID);
            continue;
        }
        /* total reads since boot */
        /* total writes since boot */
        /* total requests since boot  */
        size += sprintf(PROC_BUF, "Total requests %ld,",up->io_cnt);
        /* current number of pending requests */
        size += sprintf(PROC_BUF, "(%2d:%2d:%2d) pending requests %d,",LUN_ID,up->q_outcnt);
        /* avg response time */
        size += sprintf(PROC_BUF, "Avg response time %d,",(up->resp_time/up->io_cnt)*100);

        /* avg active time */
        size += sprintf(PROC_BUF, "Avg active time %d\n",(up->act_time/up->io_cnt)*100);
    }

    if( size >= qla2100_buffer_size ) {
        printk(KERN_WARNING "qla2100: Overflow buffer in qla2100_proc.c\n");
    }

    if( offset > size - 1 ) {
        kfree(qla2100_buffer);
        qla2100_buffer = NULL;
        qla2100_buffer_size = length = 0;
        *start = NULL;
    } else {
        *start = &qla2100_buffer[offset];   /* Start of wanted data */
        if( size - offset < length ) {
            length = size - offset;
        }
    }
    return (length);
#else
    return (0);
#endif

}


/**************************************************************************
 * qla2100_detect
 *
 * Description:
 *    This routine will probe for Qlogic FC SCSI host adapters.
 *    It returns the number of host adapters of a particular
 *    type that were found.	 It also initialize all data necessary for 
 *    the driver.  It is passed-in the host number, so that it
 *    knows where its first entry is in the scsi_hosts[] array.
 *
 * Input:
 *     template - pointer to SCSI template
 *
 * Returns:
 *  num - number of host adapters found.  
 **************************************************************************/
int
qla2100_detect(Scsi_Host_Template *template) {
    int num_hosts = 0;
    struct Scsi_Host *host;
    scsi_qla_host_t *ha, *cur_ha;
    struct _qlaboards  *bdp;
    int i, j;
#if LINUX_VERSION_CODE <= KERNEL_VERSION(2,1,95)
    unsigned int piobase;
    unsigned char pci_bus, pci_devfn, pci_irq;
    config_reg_t   *cfgp = 0;
#endif
    device_reg_t   *reg;
    char   *cp;
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,1,95)
    struct pci_dev *pdev = NULL;
#else
    int index;
#endif
    DECLARE_MUTEX_LOCKED(sem);


    ENTER("qla2100_detect");

#ifdef CODECHECK
    if( sizeof(srb_t) > sizeof(Scsi_Pointer) ) {
        printk("Redefine SRB - its too big");
        return 0;
    }
#endif

#ifdef MODULE
    DEBUG(printk("DEBUG: qla2100_detect starts at address = %p\n",qla2100_detect);)
    DEBUG(sprintf(debug_buff,"DEBUG: qla2100_detect starts at address = 0x%8lx\n",(uint32_t)qla2100_detect);)
    DEBUG(qla2100_print(debug_buff);)
    /*
    * If we are called as a module, the qla2100 pointer may not be null
    * and it would point to our bootup string, just like on the lilo
    * command line.  IF not NULL, then process this config string with
    * qla2100_setup
    *
    * Boot time Options
    * To add options at boot time add a line to your lilo.conf file like:
    * append="qla2100=verbose,tag_info:{{32,32,32,32},{32,32,32,32}}"
    * which will result in the first four devices on the first two
    * controllers being set to a tagged queue depth of 32.
    */
    if( options )
        qla2100_setup(options, NULL);
    if( dummy_buffer[0] != 'P' )
        printk(KERN_WARNING "qla2100: Please read the file /usr/src/linux/drivers"
            "/scsi/README.qla2100\n"
            "qla2100: to see the proper way to specify options to the qla2100 "
            "module\n"
            "qla2100: Specifically, don't use any commas when passing arguments to\n"
            "qla2100: insmod or else it might trash certain memory areas.\n");
#endif

    if( (int) !pcibios_present() ) {
        printk("scsi: PCI not present\n");
        return 0;
    } /* end of IF */

    bdp = &QL2x00BoardTbl[0];
    qla2100_hostlist = NULL;
    template->proc_name = "qla2100";

    /* Try and find each different type of adapter we support */
    for( i=0; bdp->device_id != 0 && i < NUM_OF_ISP_DEVICES; i++, bdp++ ) {
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,1,95)
        while( (pdev = pci_find_device(QLA2100_VENDOR_ID,
            bdp->device_id, pdev) ) ) { 
            /* found a adapter */
#else
            while( !(pcibios_find_device(QLA2100_VENDOR_ID,
                bdp->device_id,
                index++, &pci_bus, &pci_devfn)) ) { 
                /* found a adapter */
#endif
                host = scsi_register(template, sizeof(scsi_qla_host_t)); 
                ha = (scsi_qla_host_t *) host->hostdata;
                /* Clear our data area */
                for( j =0, cp = (char *)ha;  j < sizeof(scsi_qla_host_t); j++ )
                    *cp++ = 0;   /* bug fix 01/19/00 */
                /* Sanitize the information from PCI BIOS.  */
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,1,95)
                host->irq = pdev->irq;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,3,18)
                host->io_port = (unsigned int) pdev->base_address[0];
#else
                host->io_port = pdev->resource[0].start;
#endif
                ha->pci_bus = pdev->bus->number;
                ha->pci_device_fn = pdev->devfn;
                ha->pdev = pdev;
#else
                pcibios_read_config_byte(pci_bus, pci_devfn, OFFSET(cfgp->interrupt_line), &pci_irq);
                pcibios_read_config_dword(pci_bus, pci_devfn, OFFSET(cfgp->base_port), &piobase);
                host->irq = pci_irq;
                host->io_port = (unsigned int) piobase;
                ha->pci_bus = pci_bus;
                ha->pci_device_fn = pci_devfn;
#endif
                ha->device_id = bdp->device_id;
                host->io_port &= PCI_BASE_ADDRESS_IO_MASK;
                ha->devnum = i;
                if( qla2100_verbose ) {
                    printk("(scsi): Found a %s @ bus %d, device %d, irq %d, iobase 0x%x\n",
                        bdp->bdName,ha->pci_bus, (ha->pci_device_fn & 0xf8) >> 3, host->irq,(int)host->io_port);
                }

                ha->iobase = (device_reg_t *) host->io_port;
                ha->host = host;

                if( qla2100_mem_alloc(ha) ) {
                    printk(KERN_INFO "qla2100: Failed to allocate memory for adapter\n");
                }
                ha->prev_topology = 0;
                ha->ports = bdp->numPorts; 
                ha->host_no = host->host_no;

                if( ha->device_id == QLA2100_DEVICE_ID )  
                    ha->max_targets = MAX_TARGETS_2100; 
                else
                    ha->max_targets = MAX_TARGETS_2200; 

                /* load the F/W, read paramaters, and init the H/W */
                if( qla2100_initialize_adapter(ha) ) {

                    printk(KERN_INFO "qla2100: Failed to initialized adapter\n");
                    qla2100_mem_free(ha);
                    scsi_unregister(host);
                    continue;
                }
                ha->instance = num_hosts;
                ha->next = NULL;
                /*  Mark preallocated Loop IDs in use. */
                ha->fabricid[SNS_FL_PORT].in_use = TRUE;
                ha->fabricid[FABRIC_CONTROLLER].in_use = TRUE;
                ha->fabricid[SIMPLE_NAME_SERVER].in_use = TRUE;

                /* Register our resources with Linux */
                if( qla2100_register_with_Linux(ha, bdp->numPorts-1) ) {
                    printk(KERN_INFO "qla2100: Failed to register our resources\n");
                    qla2100_mem_free(ha);
                    scsi_unregister(host);
                    continue;
                }

                reg = ha->iobase;
                /* Disable ISP interrupts. */
                qla2100_disable_intrs(ha);

                /*
                * Startup the kernel thread for this host adapter 
                */

                ha->dpc_notify = &sem;
                kernel_thread((int (*)(void *))qla2100_do_dpc,
                    (void *) ha, 0);

                /*
                * Now wait for the kernel dpc thread to initialize and go to sleep.
                */
                down(&sem);
                ha->dpc_notify = NULL;

                /* 
                * These locks are used to prevent more than one CPU from modifying the queue at
                * the same time. The higher level "io_request_lock" will reduce most contention 
                * for these locks.
                */
                ha->retry_lock = SPIN_LOCK_UNLOCKED;

                /* Insure mailbox registers are free. */
                WRT_REG_WORD(&reg->semaphore, 0);
                WRT_REG_WORD(&reg->host_cmd, HC_CLR_RISC_INT);
                WRT_REG_WORD(&reg->host_cmd, HC_CLR_HOST_INT);

                /* Enable chip interrupts. */
                qla2100_enable_intrs(ha);
                /* Insert new entry into the list of adapters */
                ha->next = NULL;
                if( qla2100_hostlist == NULL ) {
                    qla2100_hostlist = ha;
                } else {
                    cur_ha = qla2100_hostlist;
                    while( cur_ha->next != NULL )
                        cur_ha = cur_ha->next;
                    cur_ha->next = ha;
                }
                num_hosts++;
            }
        } /* end of FOR */

        LEAVE("qla2100_detect");
        return num_hosts; 
    }

    /**************************************************************************
    *   qla2100_register_with_Linux
    *
    * Description:
    *   Free the passed in Scsi_Host memory structures prior to unloading the
    *   module.
    *
    * Input:
    *     ha - pointer to host adapter structure
    *     maxchannels - MAX number of channels.
    *
    * Returns:
    *  0 - Sucessfully reserved resources.
    *  1 - Failed to reserved a resource.
    **************************************************************************/
    STATIC uint8_t  qla2100_register_with_Linux(scsi_qla_host_t *ha, uint8_t maxchannels) {

        struct Scsi_Host *host = ha->host;

        host->can_queue = 0xfffff;  /* unlimited  */
        host->cmd_per_lun = 1;
        host->select_queue_depths = qla2100_select_queue_depth;
        host->n_io_port = 0xFF;
        host->base = (unsigned char *) ha->mmpbase;
        host->max_channel = maxchannels; 
        /* fix: 07/31 host->max_lun = MAX_LUNS-1; */
        host->max_lun = ha->max_luns;
        host->unique_id = ha->instance;
        host->max_id = ha->max_targets; 

        /* set our host ID  (need to do something about our two IDs) */
        host->this_id = 255;

        /* Register the IRQ with Linux (sharable) */
        if( request_irq(host->irq, qla2100_intr_handler, SA_INTERRUPT| SA_SHIRQ, "qla2x00", ha) ) {
            printk("qla2100 : Failed to reserved interrupt %d already in use\n", host->irq);
            return 1;
        }

        /* Register the I/O space with Linux */
        if( check_region(host->io_port, 0xff) ) {
            printk("qla2100 : Failed to reserved i/o region 0x%04lx-0x%04lx already in use\n",
                host->io_port, host->io_port + 0xff);
            free_irq(host->irq, NULL);
            return 1;
        }

        request_region(host->io_port, 0xff, "qla2100");

#if QLA2100_OS_TIMER
        /* Initialized the timer */
        START_TIMER(qla2100_timer,ha,WATCH_INTERVAL); 
#endif

        return 0;
    }


    /**************************************************************************
    *   qla2100_release
    *
    * Description:
    *   Free the passed in Scsi_Host memory structures prior to unloading the
    *   module.
    *
    * Input:
    *     ha - pointer to host adapter structure
    *
    * Returns:
    *  0 - Always returns good status
    **************************************************************************/
    int
        qla2100_release(struct Scsi_Host *host) {
        scsi_qla_host_t *ha = (scsi_qla_host_t *) host->hostdata;

        ENTER("qla2100_release");
        /* if adpater is running and online */
        if( !ha->flags.online )
            return(0);

        /* turn-off interrupts on the card */
        qla2100_disable_intrs(ha);

        /* Detach interrupts */
        if( host->irq )
            free_irq(host->irq, ha);

        /* release io space registers  */
        if( host->io_port )
            release_region(host->io_port, 0xff);

        /* Disable timer */
        if( ha->timer_active )
            STOP_TIMER(qla2100_timer,ha)

            /* Kill the kernel thread for this host */
            if( ha->dpc_handler != NULL ) {
                DECLARE_MUTEX_LOCKED(sem);

                ha->dpc_notify = &sem;
                send_sig(SIGKILL, ha->dpc_handler, 1);
                down(&sem);
                ha->dpc_notify = NULL;
            }
            /* Move driver database to flash, if enabled. */
            if( ha->flags.enable_flash_db_update && ha->flags.updated_fc_db ) {
                ha->flags.updated_fc_db = FALSE;
                qla2100_save_database(ha);
            }
#if MEMORY_MAPPED_IO
            if( ha->mmpbase ) {
                iounmap((void *) (((unsigned long) ha->mmpbase) & PAGE_MASK));
            }
#endif /* MEMORY_MAPPED_IO */

            qla2100_mem_free(ha); 
            ha->flags.online = FALSE;

            LEAVE("qla2100_release");
            return(0);
    }

    /**************************************************************************
    *   qla2100_info
    *
    * Description:
    *
    * Input:
    *     host - pointer to Scsi host adapter structure
    *
    * Returns:
    *     Return a text string describing the driver.
    **************************************************************************/
    const char *
        qla2100_info(struct Scsi_Host *host) {
        static char qla2100_buffer[255];
        char *bp;
        scsi_qla_host_t *ha;
        qla_boards_t   *bdp; 

        bp = &qla2100_buffer[0];
        ha = (scsi_qla_host_t *)host->hostdata;
        bdp = &QL2x00BoardTbl[ha->devnum];
        memset(bp, 0, sizeof(qla2100_buffer));
        sprintf(bp,
            "QLogic %sPCI to Fibre Channel Host Adapter: bus %d device %d irq %d\n"
            "        Firmware version: %2d.%02d.%02d, Driver version %s",
            (char *)&bdp->bdName[0], ha->pci_bus, (ha->pci_device_fn & 0xf8) >> 3, host->irq,
            bdp->fwver[0], bdp->fwver[1], bdp->fwver[2], QLA2100_VERSION);
        return(bp);
    }

    /**************************************************************************
    *   qla1200_queuecommand
    *
    * Description:
    *     Queue a command to the controller.
    *
    * Input:
    *     cmd - pointer to Scsi cmd structure
    *     fn - pointer to Scsi done function
    *
    * Returns:
    *   0 - Always
    *
    * Note:
    * The mid-level driver tries to ensures that queuecommand never gets invoked
    * concurrently with itself or the interrupt handler (although the
    * interrupt handler may call this routine as part of request-completion
    * handling). 
    **************************************************************************/
    int
        qla2100_queuecommand(Scsi_Cmnd *cmd, void (*fn)(Scsi_Cmnd *)) {
        scsi_qla_host_t *ha;
        srb_t  *sp;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        unsigned long cpu_flags = 0;
#endif
        struct Scsi_Host *host;
        uint32_t        b, t, l;
        scsi_lu_t       *q;
        u_long          handle;

        ENTER("qla2100_queuecommand");
        COMTRACE('C')   

        host = cmd->host;
        ha = (scsi_qla_host_t *) host->hostdata;

        /* Get our SCSI request pointer
        * SCp always point to it - see definition in qla2100.h.
         */
        sp = (srb_t *) CMD_SP(cmd);
        sp->cmd =  cmd;
        cmd->scsi_done = fn;

        /* If we not trying to do a recovery procedure of some sort
        * then this is probably a new command.
        */
        if( cmd->flags == 0 && 
            cmd->retries == 0 ) 
            sp->flags = 0;

        DEBUG5(qla2100_print_scsi_cmd(cmd);)
        DEBUG5(sprintf(debug_buff,"qla2100_queuecmd: pid=%ld, opcode=%d, timeout=%d\n",cmd->pid,cmd->cmnd[0],CMD_TIMEOUT(cmd));)
        DEBUG5(qla2100_print(debug_buff);)

        /* Generate LU queue on bus, target, LUN */
        b = SCSI_BUS_32(cmd);
        t = SCSI_TCN_32(cmd);
        l = SCSI_LUN_32(cmd);

        /* 
        * We found all the devices at LIP time, and created a device
        * table for them, so we only need to check the table to see
        * if the device is present.
        */
        if( TGT_Q(ha,b,t) == NULL ||
            (TGT_Q(ha,b,t) && TGT_Q(ha,b,t)->loop_id > LAST_SNS_LOOP_ID) /* ||
            (ha->loop_down_timer == 0 &&  ha->flags.online) */) {
            DEBUG5(printk("scsi(%2ld:%2d:%2d:%2d): port unavailable\n",ha->host_no,b,t,l);)
            CMD_RESULT(sp->cmd) = DID_NO_CONNECT << 16;
            qla2100_callback(ha,sp,FALSE);
            LEAVE("qla2100_queuecommand");
            return(0);
        }  

        /* 
        * Allocate a LUN/DEVICE queue from this request if we haven't
        * already did it on a previous command.
        */
        if( (q = GET_LU_Q(ha, b, t,l)) == NULL ) {
            DRIVER_LOCK
            if( (q = qla2100_lun_alloc()) == NULL ) {
                CMD_RESULT(sp->cmd) = DID_RETRY << 16;
                qla2100_callback(ha,sp,FALSE);
                return(0);
            }
            LU_Q(ha, b, t, l) = q;
            DEBUG(sprintf(debug_buff,"Allocate new device queue 0x%x\n",q));
            DEBUG(qla2100_print(debug_buff));
            DRIVER_UNLOCK
        }

        /* Set an invalid handle until we issue the command to ISP */
        /* then we will set the real handle value.                 */
        handle = INVALID_HANDLE;  
        CMD_HANDLE(cmd) = (unsigned char *)handle;

        /* Bookkeeping information */
        sp->r_start = jiffies;       /* time the request was recieved */
        sp->u_start = 0;              

        /* 
        * SCSI Kluge
        * ========
        * Whenever, we need to wait for an event such as loop down
        * (i.e. loop_down_timer ) or port down (i.e. LUN request qeueue is
        * suspended) then we will recycle new commands back to the SCSI layer.
        * We do this because this is normally a temporary condition and we don't
        * want the mid-level scsi.c driver to get upset and start aborting
        * commands. 

        * The timeout value is extracted from the command minus 1-second 
        * and put on a retry queue (watchdog). Once the command timeout it 
        * is returned to the mid-level with a BUSY status, so the mid-level
        * will retry it. This process continues until the LOOP DOWN time
        * expires or the condition goes away. 
        */
        if( ha->loop_down_timer || 
            ha->loop_state ==  LOOP_DOWN ||
            ha->loop_state != LOOP_READY ||
            /* ha->loop_state ==  LOOP_UPDATE || */
            (q->q_flag & QLA2100_QSUSP) ) {
            /* Extend the timeout value */
            cmd->eh_timeout.expires = jiffies + PORT_RETRY_TIME;
            /* Insert command into watchdog queue */
            qla2100_timeout_insert(ha, sp);
            LEAVE("qla2100_queuecommand");
            return (0);
        }
        /* Set retry count if this is a new command */
        if( sp->flags == 0 && 
            !(q->q_flag & QLA2100_QSUSP) ) {
            sp->port_down_retry_count = ha->port_down_retry_count - 1;
            sp->retry_count = ha->retry_count; 
            DEBUG3(sprintf(debug_buff,"qla2100: Set retry counts =0x%x,0x%x\n\r",sp->port_down_retry_count,sp->retry_count));
            DEBUG3(qla2100_print(debug_buff));
        }

        /* No timeout necessary, because the upper layer is doing it for us */
        sp->wdg_time = 0;

        /* add the command to our queue */
        ha->qthreads++;
        qla2100_putq_t(q,sp); 

        DEBUG5(sprintf(debug_buff,"qla2100_queuecmd: queue pid=%ld, hndl=0x%lx\n\r",cmd->pid,handle));
        DEBUG5(qla2100_print(debug_buff));

        /* send command to adapter */
        /* qla2100_next(ha, q);  */
        /* if (q->q_outcnt == 0) */
           qla2100_restart_queues(ha,FALSE);

        COMTRACE('c')  
        LEAVE("qla2100_queuecommand");
        return (0);
    }

    /**************************************************************************
    *   qla1200_abort
    *
    * Description:
    *     Abort the specified SCSI command.
    *
    * Input:
    *     cmd - pointer to Scsi cmd structure
    *
    * Returns:
    **************************************************************************/
    int
        qla2100_abort(Scsi_Cmnd *cmd) {
        scsi_qla_host_t *ha;
        srb_t  *sp;
        srb_t  *rp, *rp_next;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        unsigned long cpu_flags = 0;
#endif
        struct Scsi_Host *host;
        uint32_t        b, t, l;
        scsi_lu_t       *q;
        int return_status = SCSI_ABORT_SUCCESS;
        int found = 0;
        int i;
        uint32_t     handle;
        uint16_t    data;

        ENTER("qla2100_abort");
        COMTRACE('A') 
        ha = (scsi_qla_host_t *) cmd->host->hostdata;
        host = cmd->host;
        DRIVER_LOCK
        /* Get the SCSI request ptr */
        sp = (srb_t *) CMD_SP(cmd);

        /* 
        * if the handle is NULL then we already completed the command.
        * We always give the handle a value of "INVALID_HANDLE" when 
        * we received it.  
        */
        if( (u_long) CMD_HANDLE(cmd) == 0L ) {
            DRIVER_UNLOCK
#if  STOP_ON_ABORT 
                qla2100_panic("qla2100_abort",ha->host);
#endif
            return(SCSI_ABORT_NOT_RUNNING);  /* no action - we don't have command */
        }

        /* Check for a pending interrupt. */
        data = qla2100_debounce_register(&ha->iobase->istatus);
        if( !(ha->flags.in_isr) && (data & RISC_INT) ) {
            /* Add any completed commands in the done queue */
            qla2100_isr(ha, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
        }

        /* 
        * if no LUN queue then something is very wrong!!! 
        */
        handle = (u_long) CMD_HANDLE(cmd);
        /* Generate LU queue on bus, target, LUN */
        b = SCSI_BUS_32(cmd);
        t = SCSI_TCN_32(cmd);
        l = SCSI_LUN_32(cmd);
        if( (q = GET_LU_Q(ha, b, t, l)) == NULL ) {
            COMTRACE('a')

            DRIVER_UNLOCK
            printk(KERN_WARNING "qla2100 (%d:%d:%d): No LUN queue for the specified device\n",(int)b,(int)t,(int)l);
            return(SCSI_ABORT_NOT_RUNNING);  /* no action - we don't have command */
        }

#if AUTO_ESCALATE_ABORT
        if( (sp->flags & SRB_ABORTED) ) {
            DRIVER_UNLOCK
            DEBUG(qla2100_print("qla2100_abort: Abort escalayted - returning SCSI_ABORT_SNOOZE.\n\r"));
            return(SCSI_ABORT_SNOOZE);
        }
#endif
        /*
        * if the command ahs a abort pending then tell the upper layer 
        */
        if( (sp->flags & SRB_ABORT_PENDING) ) {
            COMTRACE('a')
            DRIVER_UNLOCK
            if( qla2100_verbose )
                printk("scsi(): Command has a pending abort message - ABORT_PENDING.\n");
            DEBUG(qla2100_print("qla2100: Command has a pending abort message - ABORT_PENDING.\n\r"));
            return(SCSI_ABORT_PENDING);
        }

#if  STOP_ON_ABORT 
        DEBUG(sprintf(debug_buff,"ABORTing command= 0x%x\n",(int)cmd);)
        DEBUG(qla2100_print(debug_buff);)
        DEBUG(qla2100_print_scsi_cmd(cmd));
#endif

        for( rp = ha->retry_q_first; (rp); rp = rp_next ) {
             rp_next = rp->s_next;
            if( sp != rp )
               continue;
            qla2100_timeout_remove(ha, sp);
            CMD_RESULT(sp->cmd) = DID_BUS_BUSY << 16;
            CMD_HANDLE(sp->cmd) = (unsigned char *) NULL;
           qla2100_done_q_put(sp, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
            found++;
        }

        /*
        * Our SP pointer points at the command we want to remove from the
        * LUN queue providing we haven't already sent it to the adapter.
        */
        if( found )
            return_status = SCSI_ABORT_SUCCESS;
        else if( !(sp->flags&SRB_SENT) ) { 
            found++;
            DEBUG(sprintf(debug_buff,"qla2100: Cmd in LUN queue aborted pid %d.\n\r",sp->cmd->pid);)
            DEBUG(qla2100_print(debug_buff);)
            /* Remove srb from SCSI LU queue. */
            qla2100_removeq(q, sp);
            sp->flags |=  SRB_ABORTED;
            CMD_RESULT(cmd) = DID_ABORT << 16; 
            qla2100_done_q_put(sp, &ha->done_q_first, &ha->done_q_last);
            return_status = SCSI_ABORT_SUCCESS;
        } else {  /* find the command in our active list */
            for( i = 1; i < MAX_OUTSTANDING_COMMANDS; i++ ) {
                if( sp == ha->outstanding_cmds[i] ) {
                    found++;
                    DEBUG(sprintf(debug_buff,"qla2100: RISC aborting pid %d command.\n\r",sp->cmd->pid);)
                    DEBUG(qla2100_print(debug_buff);)
                    DEBUG(qla2100_print_scsi_cmd(cmd));
                    DEBUG(qla2100_print_q_info(q);)
                    if( qla2100_abort_command(ha,sp) )
                       return_status = SCSI_ABORT_NOT_RUNNING;  /* no action */
                    else
                       return_status = SCSI_ABORT_PENDING;
                    break;
                }
            }
        }

#if  STOP_ON_ABORT 
        qla2100_panic("qla2100_abort",ha->host);
#endif
        if( found == 0 )
            return_status = SCSI_ABORT_NOT_RUNNING;  /* no action */

        DEBUG(sprintf(debug_buff, "qla2100_abort: Aborted status returned = 0x%x.\n\r",return_status));
        DEBUG(qla2100_print(debug_buff));
        /*
        * Complete any commands 
        */
        if( ha->done_q_first )
            qla2100_done(ha, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);

        if( found ) {
            qla2100_restart_queues(ha,TRUE);
        }
        DRIVER_UNLOCK

        LEAVE("qla2100_abort");
        COMTRACE('a')
        return(return_status);
    }

    /**************************************************************************
    * qla1200_reset
    *
    * Description:
    *    The reset function will reset the SCSI bus and abort any executing
    *    commands. 
    *
    * Input:
    *      cmd = Linux SCSI command packet of the command that cause the
    *            bus reset.
    *      flags = SCSI bus reset option flags (see scsi.h)
    *
    * Returns:
    *      DID_RESET in cmd.host_byte of aborted command(s) 
    *
    * Note:
    *      Resetting the bus always succeeds - is has to, otherwise the
    *      kernel will panic! Try a surgical technique - sending a BUS
    *      DEVICE RESET message - on the offending target before pulling
    *      the SCSI bus reset line.
    **************************************************************************/
    int
        qla2100_reset(Scsi_Cmnd *cmd, unsigned int flags) {
        scsi_qla_host_t *ha;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        unsigned long cpu_flags = 0;
#endif
        uint32_t        b, t, l;
        srb_t  *sp;
        typedef enum {
            ABORT_DEVICE = 1, 
                DEVICE_RESET = 2, 
                BUS_RESET    = 3, 
                ADAPTER_RESET= 4,
                RESET_DELAYED= 5,
                FAIL         = 6
        } action_t;
        action_t     action = ADAPTER_RESET;
        uint16_t    data;
        scsi_lu_t       *q;
        int result;


        ENTER("qla2100_reset");
        COMTRACE('R')
        DEBUG(if( qla2100_verbose ))
            DEBUG(printk("scsi(): RESET Cmnd=0x%x, Handle=0x%lx, flags=0x%x\n",(int)cmd,(int32_t)CMD_HANDLE(cmd),flags));
        if( cmd == NULL ) {
            printk(KERN_WARNING "(scsi?:?:?:?) Reset called with NULL Scsi_Cmnd "
                "pointer, failing.\n");
            return(SCSI_RESET_SNOOZE);
        }
        ha = (scsi_qla_host_t *) cmd->host->hostdata;
        sp = (srb_t *) CMD_SP(cmd);

#if  STOP_ON_RESET 
        sprintf(debug_buff,"ABORTing command= 0x%x\n",(int)cmd);
        qla2100_print(debug_buff);
        qla2100_print_scsi_cmd(cmd);
        qla2100_panic("qla2100_reset",ha->host);
#endif 


        DRIVER_LOCK
        /* Check for pending interrupts. */
        data = qla2100_debounce_register(&ha->iobase->istatus);
        if( !(ha->flags.in_isr) && (data & RISC_INT) ) {
            qla2100_isr(ha, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
        }
        DRIVER_UNLOCK

        /*
        * Determine the suggested action that the mid-level driver wants
        * us to perform.
        */
        if( CMD_HANDLE(cmd) == (unsigned char *) 0 ) {
            /* 
            * if mid-level driver called reset with a orphan SCSI_Cmnd 
            * (i.e. a command that's not pending ), so perform the 
            * function specified.
            */
            if( (flags & SCSI_RESET_SUGGEST_HOST_RESET) )
                action = ADAPTER_RESET;
            else 
                action = BUS_RESET;
        } else { /* 
            * Mid-level driver has called reset with this SCSI_Cmnd and 
            * its pending.
            */
            if( flags & SCSI_RESET_SUGGEST_HOST_RESET )
                action = ADAPTER_RESET;
            else if( flags & SCSI_RESET_SUGGEST_BUS_RESET )
                action = BUS_RESET;
            else 
                action = DEVICE_RESET;
        }

        b = SCSI_BUS_32(cmd);
        t = SCSI_TCN_32(cmd);
        l = SCSI_LUN_32(cmd);
        q = GET_LU_Q(ha, b, t, l);

#if AUTO_ESCALATE_RESET
        if( (action & DEVICE_RESET) && (q->q_flag & QLA2100_QRESET) ) {
            printk(KERN_INFO "qla2100(%d): Bus device reset already sent to " "device, escalating.\n", (int)ha->host_no);
            action = BUS_RESET;
        }
        if( (action & DEVICE_RESET) && (sp->flags & SRB_ABORT_PENDING) ) {
            printk(KERN_INFO "qla2100(%d):Have already attempted to reach " "device with abort device\n", (int)ha->host_no);
            printk(KERN_INFO "qla2100(%d):message, will escalate to BUS " "RESET.\n",(int) ha->host_no);
            action = BUS_RESET;
        }
#endif

        /*
        *  By this point, we want to already know what we are going to do,
        *  so we only need to perform the course of action.
        */

        DRIVER_LOCK
            result = SCSI_RESET_ERROR;
        switch( action ) {
        case FAIL:
            break;

        case RESET_DELAYED:
            result = SCSI_RESET_PENDING;
            break;

        case ABORT_DEVICE:
            if( qla2100_verbose )
                printk(KERN_INFO "scsi(%d:%d:%d:%d): ABORT DEVICE ISSUED.\n", (int)ha->host_no,(int)b,(int)t,(int)l); 
            qla2100_abort_queue_single(ha,b,t,l,DID_ABORT);
            if( !ha->loop_down_timer )
                if( qla2100_abort_device(ha, b, t, l) == 0 )
                    result = SCSI_RESET_PENDING;
                break;

            case DEVICE_RESET:
                if( qla2100_verbose )
                    printk(KERN_INFO "scsi(%d:%d:%d:%d): DEVICE RESET ISSUED.\n",(int) ha->host_no,(int)b,(int)t,(int)l); 
                for( l = 0; l <  ha->max_luns; l++ )
                    qla2100_abort_queue_single(ha,b,t,l,DID_ABORT);
                if( !ha->loop_down_timer )
                    if( qla2100_device_reset(ha, b, t) == 0 ) 
                        result = SCSI_RESET_PENDING;
                    q->q_flag |= QLA2100_QRESET;
                    break;

                case BUS_RESET:
                    if( qla2100_verbose )
                        printk(KERN_INFO "scsi(%d:%d:%d:%d): LOOP RESET ISSUED.\n",(int) ha->host_no,(int)b,(int)t,(int)l); 
                    for( t = 0; t < ha->max_targets; t++ )
                        for( l = 0; l <  ha->max_luns; l++ )
                            qla2100_abort_queue_single(ha,b,t,l,DID_RESET);
                        if( !ha->loop_down_timer )
                            if( qla2100_loop_reset(ha) == 0 )
                                result = SCSI_RESET_SUCCESS | SCSI_RESET_BUS_RESET;
                            /*
                            * The reset loop routine returns all the outstanding commands back
                            * with "DID_RESET" in the status field. 
                            */
                            if( flags & SCSI_RESET_SYNCHRONOUS ) {
                                CMD_RESULT(cmd) = (int) (DID_BUS_BUSY << 16);
                                (*(cmd)->scsi_done)(cmd); 
                            }

                            /* ha->reset_start = jiffies; */
                            break;

                        case ADAPTER_RESET:
                        default:
                            if( qla2100_verbose ) {
                                printk(KERN_INFO "scsi(%d:%d:%d:%d): ADAPTER RESET ISSUED.\n",(int) ha->host_no,(int)b,(int)t,(int)l); 
                            }
                            ha->flags.reset_active = TRUE;
                            /* 
                            * We restarted all of the commands automatically, so the mid-level code can expect 
                            * completions momentitarily.
                            */
                            if( qla2100_abort_isp(ha) == 0 )
                                result = SCSI_RESET_SUCCESS | SCSI_RESET_HOST_RESET;

                            ha->flags.reset_active = FALSE;
        }

        if( ha->done_q_first ) 
            qla2100_done(ha, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
        qla2100_restart_queues(ha,TRUE);
        DRIVER_UNLOCK

        COMTRACE('r')
        LEAVE("qla2100_reset");
        return(result);
    }

    /**************************************************************************
    * qla1200_biosparam
    *
    * Description:
    *   Return the disk geometry for the given SCSI device.
    **************************************************************************/
    int
        qla2100_biosparam(Disk *disk, kdev_t dev, int geom[]) {
        int heads, sectors, cylinders;

        heads = 64;
        sectors = 32;
        cylinders = disk->capacity / (heads * sectors);
        if( cylinders > 1024 ) {
            heads = 255;
            sectors = 63;
            cylinders = disk->capacity / (heads * sectors);
            if( cylinders > 1023 )
                cylinders = 1023; 
        }

        geom[0] = heads;
        geom[1] = sectors;
        geom[2] = cylinders;

        return (0);
    }

    /**************************************************************************
    * qla2100_intr_handler
    *
    * Description:
    *   Handles the actual interrupt from the adapter.
    *
    * Context: Interrupt
    **************************************************************************/
    void 
        qla2100_intr_handler(int irq, void *dev_id, struct pt_regs *regs) {
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,1,95)
        unsigned long cpu_flags = 0;
#endif
        scsi_qla_host_t *ha;
        uint16_t    data;
        device_reg_t *reg;

        ENTER_INTR("qla2100_intr_handler");
        COMTRACE('I')  
        ha = (scsi_qla_host_t *) dev_id;
        if( !ha ) {
            printk(KERN_INFO "qla2100_intr_handler: NULL host ptr\n");
            COMTRACE('X')
            return;
        }
        ha->isr_count++;

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,1,95)
        /* Prevent concurrent access to adapters register */
            spin_lock_irqsave(&io_request_lock, cpu_flags);
        qla2100_disable_intrs(ha); 

        reg = ha->iobase;

        data = qla2100_debounce_register(&reg->istatus);
        /* Check for pending interrupts. */
        if( (data & RISC_INT) ) {
            qla2100_isr(ha, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
        }


        if( ha->done_q_first )
            qla2100_done(ha, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);

        spin_unlock_irqrestore(&io_request_lock, cpu_flags);
        qla2100_enable_intrs(ha);   

        /* Wakeup the DPC routine */
        if( (!ha->flags.mbox_busy && (ha->flags.isp_abort_needed   || 
            ha->flags.reset_marker       ||
            ha->flags.update_config_needed       ||  
            ( !ha->flags.loop_resync_active &&
            ha->flags.loop_resync_needed)  ) )
            && !ha->dpc_active ) {
            up(ha->dpc_wait);
        }

#else /* LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95) */

        /* Prevent concurrent access to istatus register */
        if( test_bit(QLA2100_IN_ISR_BIT, (int *)&ha->flags) ) {
            COMTRACE('X')
            DEBUG(printk("scsi%d: Already in interrupt - returning \n", (int)ha->host_no);)
            return;
        }
        set_bit(QLA2100_IN_ISR_BIT, (int *)&ha->flags);
        reg = ha->iobase;
        qla2100_disable_intrs(ha); 
        data = qla2100_debounce_register(&reg->istatus);
        /* Check for pending interrupts. */
        if( (data & RISC_INT) ) {
            qla2100_isr(ha, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
        }

        if( ha->done_q_first )
            qla2100_done(ha, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);


        /* Schedule the DPC routine */
        if( (ha->flags.isp_abort_needed   || 
            ha->flags.reset_marker       ||
            ( !ha->flags.loop_resync_active &&
            ha->flags.loop_resync_needed) ||
            ha->done_q_first ) && !ha->flags.dpc_sched ) {

            ha->run_qla_bh.data = (void *) ha;
            ha->run_qla_bh.routine = qla2100_do_dpc; 

            COMTRACE('P')  
            queue_task(&ha->run_qla_bh,&tq_scheduler); 
            ha->flags.dpc_sched = TRUE;
        }
        clear_bit(QLA2100_IN_ISR_BIT, (int *)&ha->flags);
        qla2100_enable_intrs(ha);  
#endif

        COMTRACE('i')  
        LEAVE_INTR("qla2100_intr_handler");
    }

    /**************************************************************************
    * qla2100_do_dpc
    *   This kernel thread is a task that is schedule by the interrupt handler 
    *   to perform the background processing for interrupts.  
    *
    * Notes:
    * This task always run in the context of a kernel thread.  It
    * is kick-off by the driver's detect code and starts up
    * up one per adapter. It immediately goes to sleep and waits for
    * some fibre event.  When either the interrupt handler or 
    * the timer routine detects a event it will one of the task
    * bits then wake us up. 
    **************************************************************************/
    void 
        qla2100_do_dpc(void *p) {
        scsi_qla_host_t *ha = (scsi_qla_host_t *) p;
        DECLARE_MUTEX_LOCKED(sem);
        unsigned long flags;
        srb_t *sp, *sp_next;
        uint32_t        b, t, l;
        scsi_lu_t       *q;

        lock_kernel();

        /*
         * If we were started as result of loading a module, close all of the
         * user space pages.  We don't need them, and if we didn't close them
         * they would be locked into memory.
         */
        exit_mm(current);


        current->session = 1;
        current->pgrp = 1;
        /*
        * FIXME(eric) this is still a child process of the one that did the insmod.
        * This needs to be attached to task[0] instead.
        */

        siginitsetinv(&current->blocked, SHUTDOWN_SIGS);
        current->fs->umask = 0;

        /*
         * Set the name of this process.
         */
        sprintf(current->comm, "qla2100_dpc_%ld", ha->host_no);
        ha->dpc_wait = &sem;
        ha->dpc_handler = current;

        unlock_kernel();

        /*
        * Wake up the thread that created us.
        */
        DEBUG(printk("qla2100_dpc: Wake up parent %d\n", ha->dpc_notify->count.counter));

        up(ha->dpc_notify);

        while( 1 ) {
            /*
                 * If we get a signal, it means we are supposed to go
                 * away and die.  This typically happens if the user is
                 * trying to unload a module.
                 */
            DEBUG(qla2100_print("qla2100: DPC handler sleeping\n"));
            down_interruptible(&sem);

            if( signal_pending(current) )
                break;   /* get out */

            DEBUG(qla2100_print("qla2100: DPC handler waking up\n");)

            spin_lock_irqsave(&io_request_lock, flags);
            ha->dpc_active = 1;

            /* Determine what action is necessary */

            /* Flush all commands in watchdog queue */
            if( ha->flags.port_restart_needed ) {
                DEBUG(qla2100_print("qla2100: DPC port restarting\n");)
                ha->flags.port_restart_needed = FALSE;
                for( sp = ha->retry_q_first; (sp != NULL); sp =  sp_next ) {
                    sp_next = sp->s_next;
                    b = SCSI_BUS_32(sp->cmd);
                    t = SCSI_TCN_32(sp->cmd);
                    l = SCSI_LUN_32(sp->cmd);
                    if( (q = GET_LU_Q(ha, b, t,l)) == NULL ||
                        !(q->q_flag & QLA2100_QSUSP) ) 
                        continue;
                    q->q_flag &= ~QLA2100_QSUSP;
                    qla2100_timeout_remove(ha, sp);
                    CMD_RESULT(sp->cmd) = DID_BUS_BUSY << 16;
                    CMD_HANDLE(sp->cmd) = (unsigned char *) NULL;
                    qla2100_done_q_put(sp, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
                }

                /* restart all commands in queue */
                qla2100_restart_queues(ha, FALSE);
            }

            /* Process any pending mailbox commands */
            if( !ha->flags.mbox_busy ) {
                if( ha->flags.isp_abort_needed ) {
                    qla2100_abort_isp(ha);
                    ha->flags.isp_abort_needed = FALSE;
                }

                if( ha->flags.reset_marker ) {
                    qla2100_rst_aen(ha);
                }

                if( ha->flags.update_config_needed ) {
                    qla2100_update_config(ha);
                    /* 10/29/99 - ha->flags.update_config_needed = FALSE; */
                }

                if( ha->flags.loop_resync_needed ) {
                    qla2100_loop_resync(ha);
                    /* 10/29/99 - ha->flags.loop_resync_needed = FALSE; */
                }

                if( ha->flags.restart_queues_needed ) {
                    qla2100_restart_queues(ha,FALSE);
                }

                if( ha->flags.abort_queue_needed ) {
                    qla2100_abort_queues(ha, FALSE);
                }
                if( !ha->interrupts_on )
                    qla2100_enable_intrs(ha);
            }

            if( ha->done_q_first ) {
                qla2100_done(ha, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
            }

            ha->dpc_active = 0;

            /* The spinlock is really needed up to this point. (DB) */
            spin_unlock_irqrestore(&io_request_lock, flags);
        }
        DEBUG(qla2100_print("dpc: DPC handler exiting\n");)

        /*
         * Make sure that nobody tries to wake us up again.
         */
        ha->dpc_wait = NULL;
        ha->dpc_handler = NULL;
        ha->dpc_active = 0;

        /*
         * If anyone is waiting for us to exit (i.e. someone trying to unload
         * a driver), then wake up that process to let them know we are on
         * the way out the door.  This may be overkill - I *think* that we
         * could probably just unload the driver and send the signal, and when
         * the error handling thread wakes up that it would just exit without
         * needing to touch any memory associated with the driver itself.
         */
        if( ha->dpc_notify != NULL )
            up(ha->dpc_notify);


    }



    /**************************************************************************
    * qla2100_device_queue_depth
    *   Determines the queue depth for a given device.  There are two ways
    *   a queue depth can be obtained for a tagged queueing device.  One
    *   way is the default queue depth which is determined by whether
    *   If it is defined, then it is used
    *   as the default queue depth.  Otherwise, we use either 4 or 8 as the
    *   default queue depth (dependent on the number of hardware SCBs).
    **************************************************************************/
    STATIC void qla2100_device_queue_depth(scsi_qla_host_t *p, Scsi_Device *device) {
        int default_depth = 3;

        device->queue_depth = default_depth;

        if( device->tagged_supported ) {
            device->tagged_queue = 1;
            device->current_tag = 0;
            if( p->hiwat > 255 )
                device->queue_depth = 255;
            else
                device->queue_depth = p->hiwat;  

            printk(KERN_INFO "scsi(%d:%d:%d:%d): Enabled tagged queuing, queue depth %d.\n",
                (int)p->host_no, device->channel, device->id,
                device->lun, device->queue_depth);
        } else {
            printk(KERN_WARNING "scsi(%d:%d:%d:%d):Device does not supoort tags queuing!!!.\n",
                (int)p->host_no, device->channel, device->id,
                device->lun);
        }

    }

    /**************************************************************************
    *   qla2100_select_queue_depth
    *
    * Description:
    *   Sets the queue depth for each SCSI device hanging off the input
    *   host adapter.  We use a queue depth of 2 for devices that do not
    *   support tagged queueing.
    **************************************************************************/
    STATIC void
        qla2100_select_queue_depth(struct Scsi_Host *host, Scsi_Device *scsi_devs) {
        Scsi_Device *device;
        scsi_qla_host_t  *p = (scsi_qla_host_t *) host->hostdata;

        ENTER("qla2100_select_queue_depth");
        for( device = scsi_devs; device != NULL; device = device->next ) {
            if( device->host == host )
                qla2100_device_queue_depth(p, device);
        }
        LEAVE("qla2100_select_queue_depth");
    }

    /**************************************************************************
    * ** Driver Support Routines ** 
    *
    * qla2100_enable_intrs
    * qla2100_disable_intrs
    **************************************************************************/
    static inline void qla2100_enable_intrs(scsi_qla_host_t *ha) {
        device_reg_t *reg;

        reg = ha->iobase;
        ha->interrupts_on = 1;
        /* enable risc and host interrupts */
        WRT_REG_WORD(&reg->ictrl, (ISP_EN_INT+ ISP_EN_RISC));
    }

    static inline void qla2100_disable_intrs(scsi_qla_host_t *ha) {
        device_reg_t *reg;

        reg = ha->iobase;
        ha->interrupts_on = 0;
        /* disable risc and host interrupts */
        WRT_REG_WORD(&reg->ictrl, 0);
    }

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,0)
    /**************************************************************************
    *  mdelay                   
    *     Delay in milliseconds 
    *                          
    **************************************************************************/
        STATIC inline void
        mdelay(int milliseconds) {
        int i;

        for( i=0; i<milliseconds; i++ ) {
            SYS_DELAY(HZ);
        }
    }
#endif

    /**************************************************************************
    * qla2100_done
    *      Process completed commands.
    *
    * Input:
    *      ha           = adapter block pointer.
    *      done_q_first = done queue first pointer.
    *      done_q_last  = done queue last pointer.
    *
    * Returns:
    *     None
    **************************************************************************/
    STATIC void
        qla2100_done(scsi_qla_host_t *ha, srb_t **done_q_first, srb_t **done_q_last) {
        srb_t           *sp;
        scsi_lu_t       *q;
        uint32_t        b, t, l;
        Scsi_Cmnd  *cmd;

        /* ENTER("qla2100_done"); */
        COMTRACE('D')  

        while( *done_q_first ) {
            /* remove command from done list */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
            DRIVER_LOCK 
#endif
                sp = *done_q_first;
            if( !(*done_q_first = sp->s_next) )
                *done_q_last = NULL;
            else
                (*done_q_first)->s_prev = NULL;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
            DRIVER_UNLOCK 
#endif
                cmd = sp->cmd;
            b = SCSI_BUS_32(cmd);
            t = SCSI_TCN_32(cmd);
            l = SCSI_LUN_32(cmd);
            q = GET_LU_Q(ha, b, t, l);

            /* Decrement outstanding commands on device. */
            if( q->q_outcnt )
                q->q_outcnt--;
            if( q->q_outcnt < ha->hiwat ) {
                q->q_flag &= ~QLA2100_QBUSY;
            }

            q->resp_time += jiffies - sp->r_start;                /* Lun bookkeeping information */
            q->act_time += jiffies - sp->u_start;
            q->io_cnt++;
            if( sp->dir & BIT_5 )
                q->r_cnt++;
            else
                q->w_cnt++;

            switch( (CMD_RESULT(cmd)>>16) ) {
            case DID_RESET:
                q->q_flag &= ~QLA2100_QRESET;
                /* Issue marker command. */
                qla2100_marker(ha, b, t, 0, MK_SYNC_ID); 
                break;
            case DID_ABORT:
                sp->flags &= ~SRB_ABORT_PENDING;
                sp->flags |= SRB_ABORTED;
                if( sp->flags & SRB_TIMEOUT )
                    CMD_RESULT(sp->cmd)= DID_TIME_OUT << 16;
                break;
            default:
                break;
            }

            /* Call the mid-level driver interrupt handler */
            /* DEBUG(sprintf(debug_buff,"D(%d) ",cmd->pid);)
            DEBUG(qla2100_print(debug_buff);) */

            qla2100_callback(ha,sp,TRUE);
            qla2100_next(ha, q);
        }


        COMTRACE('d')  
        /* LEAVE("qla2100_done"); */
    }

    /**************************************************************************
    * qla2100_return_status
    * 	Translates a ISP error to a Linux SCSI error
    **************************************************************************/
    STATIC int qla2100_return_status(sts_entry_t *sts, Scsi_Cmnd       *cp) {
        int host_status = DID_ERROR;
        int scsi_status;
        int comp_status;
        unsigned resid;
#if DEBUG_QLA2100_INTR
        STATIC char *reason[] = {
            "DID_OK",
                "DID_NO_CONNECT",
                "DID_BUS_BUSY",
                "DID_TIME_OUT",
                "DID_BAD_TARGET",
                "DID_ABORT",
                "DID_PARITY",
                "DID_ERROR",
                "DID_RESET",
                "DID_BAD_INTR"
        };
#endif /* DEBUG_QLA2100_INTR */

        ENTER("qla2100_return_status");

#if DEBUG_QLA2100_INTR
        /*
        DEBUG(printk("qla2100: compl status = 0x%04x\n", sts->comp_status));
        */
#endif
        scsi_status = sts->scsi_status;
        comp_status = sts->comp_status;

        if( (scsi_status & SS_RESIDUAL_OVER) )
            comp_status = CS_DATA_OVERRUN;
        else if( (scsi_status & SS_RESPONSE_INFO_LEN_VALID) &&
            sts->rsp_info[3] == (uint8_t) 0 )
            comp_status = CS_COMPLETE;

        switch( comp_status ) {
        case CS_COMPLETE:
            host_status = DID_OK;
            break;
        case CS_PORT_UNAVAILABLE:
            /* release target data structure */
            host_status = DID_NO_CONNECT;
            DEBUG3(sprintf(debug_buff,"scsi: Unavail port detected 0x%x-0x%x.\n",
                sts->comp_status, sts->scsi_status); )
            DEBUG3(qla2100_print(debug_buff);)
            break;
        case CS_PORT_LOGGED_OUT:
        case CS_PORT_CONFIG_CHG:
        case CS_PORT_BUSY:
        case CS_INCOMPLETE:
            host_status = DID_NO_CONNECT;
            DEBUG3(sprintf(debug_buff,"scsi: Port Error detected 0x%x-0x%x.\n",
                sts->comp_status, sts->scsi_status); )
            DEBUG3(qla2100_print(debug_buff);)
            break;
        case CS_RESET:
            host_status = DID_RESET;
            break;
        case CS_ABORTED:
            host_status = DID_ABORT;
            break;
        case CS_TIMEOUT:
            /* host_status = DID_TIME_OUT;  only retries once before trying to abort it */
            host_status = DID_BUS_BUSY;
            break;
        case CS_DATA_UNDERRUN:
            resid = sts->residual_length;
            /* if RISC reports underrun and target does not report it
            * then we must have a lost frame, so tell upper layer 
            * to retry it by reporting an error.
            */
            if( !(sts->scsi_status & SS_RESIDUAL_UNDER) ) {
                resid = (unsigned)(CMD_XFRLEN(cp));
            }

            if( (unsigned)(CMD_XFRLEN(cp) - resid) < cp->underflow ) {
                host_status = DID_ERROR;
                DEBUG2(sprintf(debug_buff,"scsi: Underflow detected - retrying command.\n");)
                DEBUG2(qla2100_print(debug_buff);)
            } else
                host_status = DID_OK;
            break;

        default:
            DEBUG2(printk("scsi: Error detected 0x%x-0x%x.\n",
                sts->comp_status, sts->scsi_status);)
            host_status = DID_ERROR;
            break;
        }

#if DEBUG_QLA2100_INTR
        sprintf(debug_buff, "qla2100 ISP status: host status (%s) scsi status %x\n\r", reason[host_status], scsi_status);
        DEBUG(qla2100_print(debug_buff);)
#endif

        LEAVE("qla2100_return_status");

        return (scsi_status & STATUS_MASK) | (host_status << 16);
    }

    /*
    * qla2100_done_q_put
    *      Place SRB command on done queue.
    *
    * Input:
    *      sp           = srb pointer.
    *      done_q_first = done queue first pointer.
    *      done_q_last  = done queue last pointer.
    */
    STATIC void
        qla2100_done_q_put(srb_t *sp, srb_t **done_q_first, srb_t **done_q_last) {

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_put_done_q");
#endif
        /* Place block on done queue */
        sp->s_next = NULL;
        sp->s_prev = *done_q_last;
        if( !*done_q_first )
            *done_q_first = sp;
        else
            (*done_q_last)->s_next = sp;
        *done_q_last = sp;

#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_put_done_q");
#endif
    }


    /**************************************************************************
    *   qla2100_timer
    *
    * Description:
    *   Take expired extries off of delayed queues and return them to the 
    *   OS.
    *
    * Context: Interrupt 
    ***************************************************************************/
    STATIC void
        qla2100_timer(scsi_qla_host_t *ha) {

        srb_t *sp, *sp_next;
        int  stop_timer, kick_off = 0;
        int  cnt;


        ENTER("qla2100_timer");

#if 0
        /* prevent dead lock */
        unsigned long cpu_flags = 0;
        spin_lock_irqsave(&io_request_lock, cpu_flags);
#endif

        stop_timer = 0;
        /* Port Down Handler. */
        if( ha->queue_restart_timer > 0 ) {
            ha->queue_restart_timer--;
#ifdef TRACECODE
            sprintf(debug_buff,"Port down %d\n",ha->queue_restart_timer);
            qla2100_print(debug_buff);
#endif
            /* 
            * When a port goes DOWN, we suspend the queue and wait 1 minute 
            * before trying to kick off the commands again.  We will do this 
            * for "port_down_retry_count" times per command before giving up 
            * on the command altogether.                                  
            */
            if( !ha->queue_restart_timer ) {
                ha->flags.port_restart_needed = TRUE;
#ifdef TRACECODE
                qla2100_print("qla2100_timer: Port Down - restarting commands in the queues\n");
#endif
                stop_timer++;
            }
        }

        /* Loop down handler. */
        if( ha->loop_down_timer > 0 &&
            !ha->flags.abort_isp_active &&
            ha->flags.online ) {
            if( ha->loop_down_timer == LOOP_DOWN_TIME ) {
#ifdef TRACECODE
                qla2100_print("qla2100_timer: Loop Down - aborting the queues before time expire\n");
#endif
#if 0
                ha->flags.abort_queue_needed = TRUE;
#else
                qla2100_abort_queues(ha, TRUE);
#endif
            }

            ha->loop_down_timer--;
#ifdef TRACECODE
            sprintf(debug_buff,"qla2100_timer: Loop Down - seconds remainning %d\n",ha->loop_down_timer);
            qla2100_print(debug_buff);
#endif
            /* if the loop has been down for 4 minutes, reinit adapter */
            if( !ha->loop_down_timer ) {
#ifdef TRACECODE
                qla2100_print("qla2100_timer: Loop down for 4 mins - Reinit adapter\n");
#endif
                ha->flags.isp_abort_needed = TRUE;
                stop_timer++;
            }
        }

        /* 
        * Retry Handler -- This handler will recycle queued requests until the 
        * temporary loop down condition terminates.
        */
        if( !ha->flags.abort_isp_active ) {
#ifdef TRACECODE
            if( ha->retry_q_first )
            qla2100_print("qla2100_timer: Scanning for timed out commands\n");
#endif
            for( cnt=0, sp = ha->retry_q_first; (sp); sp =  sp_next ) {
                if( sp->wdg_time )
                    sp->wdg_time--;
                sp_next = sp->s_next;
                if( sp->wdg_time ==  0 ) {
                    sp->flags |= SRB_TIMEOUT;
                    kick_off++;
#if 0
                    sp->flags |= SRB_TIMEOUT;
#else
                    DEBUG(sprintf(debug_buff,"timer: CMD timeout %p,  pid %d\n",sp, sp->cmd->pid);)
                    DEBUG(qla2100_print(debug_buff);)
                    cnt++;
                    qla2100_timeout_remove(ha, sp);
                    CMD_RESULT(sp->cmd) = DID_BUS_BUSY << 16;
                    CMD_HANDLE(sp->cmd) = (unsigned char *) NULL;
                    qla2100_done_q_put(sp, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
#endif
                }
            }

            if( cnt > 0 )
            {
                    DEBUG2(sprintf(debug_buff,"timer: found %d requests\n",cnt);)
                    DEBUG2(qla2100_print(debug_buff);)
            }
        }

#if 0
        /* 
        * Pending requests handler:
        * This handler detects when the ISP has went out-to-lunch.
         *
        * As each command comes in it gets stamped with the current 
        * timestamp before it is sent to the ISP.  Usually the ISP 
        * will timeout the command itself if the command gets lost
        * on the wire. However, if the F/W gets in an unrecoverable
        * situration the command will never return. The mid-level
        * driver will try and abort it, but we really need to reset 
        * the adapter. 
        */
        for( cnt = 1; cnt < MAX_OUTSTANDING_COMMANDS && 
            !ha->flags.isp_abort_needed ; cnt++ ) {
            if( (sp = ha->outstanding_cmds[cnt]) == NULL )
                continue;
            /* skip commands that have NO timeout value */
            if( sp->wdg_time ==  0 )
                continue;

            /* Check for F/W dead */
            sp->wdg_time--;
            if( sp->wdg_time == 0 ) {
#ifdef TRACECODE
                sprintf(debug_buff,"qla2100_timer: ISP timeout - pid %d\n",sp->cmd->pid);
                qla2100_print(debug_buff);
#endif
                /* ha->flags.isp_abort_needed = TRUE;  */
                stop_timer++;
            }
        }
#endif
#if 0
        spin_unlock_irqrestore(&io_request_lock, cpu_flags);
        if( (ha->forceLip++) == 60 )
        {
           qla2100_loop_reset(ha);
           ha->forceLip = 0;
        }
#endif


        /* Schedule the DPC routine if needed */
        if( ( ha->flags.isp_abort_needed ||
            (!ha->flags.loop_resync_active && ha->flags.loop_resync_needed) ||
            ha->flags.restart_queues_needed ||
            ha->flags.port_restart_needed ||
            kick_off > 0  ||
            ha->flags.abort_queue_needed ) &&
            !ha->dpc_active ) {
            up(ha->dpc_wait);
        }

        /* ha->flags.watchdog_enabled = FALSE; */
        RESTART_TIMER(qla2100_timer,ha,WATCH_INTERVAL);

        LEAVE("qla2100_timer"); 
    }

    /*
    * qla2100_timeout_insert
    *      Function used to insert a command block onto the
    *      watchdog timer queue.
    *
    *      Note: Must insure that sc_time is not zero
    *            before calling qla2100_timeout_insert.
    *
    * Input:
    *      ha = adapter block pointer.
    *      sp = srb pointer.
    */
    STATIC void
        qla2100_timeout_insert(scsi_qla_host_t *ha, srb_t *sp) {
        unsigned long cpu_flags = 0;
        uint8_t timeoutcnt;

#ifdef QL_DEBUG_LEVEL_3
        /* ENTER("qla2100_timeout_insert"); */
#endif

        /* Compute number of time intervals */
        timeoutcnt = (uint8_t) (CMD_TIMEOUT(sp->cmd)/(WATCH_INTERVAL * HZ));
        if( timeoutcnt >= 3 )  /* 3 or more */
            /* sp->wdg_time = timeoutcnt - 3;  */
            sp->wdg_time = 3; 
        else
            sp->wdg_time = 1;

        DEBUG(sprintf(debug_buff,"Watchdog (insert) - pid=%d, tmo=%d, start=0x%x\n",sp->cmd->pid,sp->wdg_time,sp->r_start);)
        DEBUG(qla2100_print(debug_buff);)

        /* Acquire watchdoq queue specific lock */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        DRIVER_LOCK
#else
            QLA2100_TIMER_LOCK(ha); 
#endif
        /* Add command to queue */
        if (ha->retry_q_first == NULL)
        {
            ha->retry_q_first = sp;
            ha->retry_q_last = sp;
        }
        else
        {
            ha->retry_q_last->s_next = sp;
            ha->retry_q_last = sp;
        }
        sp->s_next = NULL;

        sp->flags |= SRB_WATCHDOG;
        ha->flags.watchdog_enabled = TRUE;

        /* Release watchdog queue specific lock */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        DRIVER_UNLOCK
#else
            QLA2100_TIMER_UNLOCK(ha); 
#endif

#ifdef QL_DEBUG_LEVEL_3
        /*  LEAVE("qla2100_timeout_insert"); */
#endif
    }

    /*
    * qla2100_timeout_remove
    *      Function used to remove a command block from the
    *      watchdog timer queue.
    *
    *      Note: Must insure that command is on watchdog
    *            list before calling qla2100_timeout_remove.
    *            if (sp->flags & SRB_WATCHDOG)
    *
    * Input:
    *      ha = adapter block pointer.
    *      sp = srb pointer.
    */
    STATIC void
        qla2100_timeout_remove(scsi_qla_host_t *ha, srb_t *sp) {
        unsigned long cpu_flags = 0;
        srb_t *nextsp;

#ifdef QL_DEBUG_LEVEL_3
        /* ENTER("qla2100_timeout_remove"); */
#endif

        DEBUG(sprintf(debug_buff,"Watchdog (remove) pid=%d time%d\n",sp->cmd->pid,sp->wdg_time);)
        DEBUG(qla2100_print(debug_buff);)

        /* Acquire watchdoq queue specific lock */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        DRIVER_LOCK
#else
            QLA2100_TIMER_LOCK(ha); 
#endif
        /* Remove command block from watchdog queue. */
    if (ha->retry_q_first != NULL)
    {
    if (ha->retry_q_first == sp)
    {
        /* Remove from top of queue */
        ha->retry_q_first = sp->s_next;
        if (ha->retry_q_first == NULL) {
        
            ha->retry_q_last = NULL;
            ha->flags.watchdog_enabled = FALSE;
        }
    }
    else
    {
        /* Remove from middle of queue or bottom of queue */
        for (nextsp = ha->retry_q_first; nextsp->s_next != NULL;
            nextsp = nextsp->s_next)
        {
            if (nextsp->s_next == sp)
            {
                nextsp->s_next = sp->s_next;
                if (nextsp->s_next == NULL)
                    ha->retry_q_last = nextsp;
                break;
            }
        }
    }
    sp->flags &= ~SRB_WATCHDOG;
    }
    
        /* Release watchdog queue specific lock */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        DRIVER_UNLOCK
#else
            QLA2100_TIMER_UNLOCK(ha); 
#endif

#ifdef QL_DEBUG_LEVEL_3
        /* LEAVE("qla2100_timeout_remove"); */
#endif
    }

    /*
    * qla2100_next
    *      Retrieve and process next job in the queue.
    *
    * Input:
    *      ha = adapter block pointer.
    *      q  = SCSI LU pointer.
    *      SCSI_LU_Q lock must be already obtained and no other locks.
    *
    * Output:
    *      Releases SCSI_LU_Q upon exit.
    */
    STATIC void
        qla2100_next(scsi_qla_host_t *ha, scsi_lu_t *q) {
        srb_t    *sp;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        unsigned long cpu_flags = 0;
#endif
        uint32_t cnt;
        uint8_t  status;

#ifdef QL_DEBUG_LEVEL_3
        /* ENTER("qla2100_next"); */
#endif

        DRIVER_LOCK
        COMTRACE('N')
        while( ((sp = q->q_first) != NULL) &&   /* we have a pending cmds */
            !(q->q_flag & QLA2100_QBUSY) &&     /* device can accept more cmds */
            !((q->q_flag & QLA2100_QSUSP) &&    /* device queue not suspended */
            !ha->flags.abort_isp_active &&      /* adapter abort active */
            !ha->loop_down_timer) )             /* down timer not active */
        {
            /* Remove srb from SCSI LU queue. */
            qla2100_removeq(q, sp);

            /* Set busy flag if reached high water mark. */
            q->q_outcnt++;
            if( q->q_outcnt >= ha->hiwat ) {
                q->q_flag |= QLA2100_QBUSY;
            }

#if  QLA2100_64BIT_SUPPORT
            if( ha->flags.enable_64bit_addressing )
                status = qla2100_64bit_start_scsi(ha, sp);
            else
#endif
                status = qla2100_32bit_start_scsi(ha, sp);

            if( status ) {
                if( q->q_outcnt == 1 ) {
                    /* Release SCSI LU queue specific lock */

                    /* Wait for 30 sec for command to be accepted. */
                    for( cnt = 6000000; cnt; cnt-- ) {
#if  QLA2100_64BIT_SUPPORT
                        if( ha->flags.enable_64bit_addressing )
                            status = qla2100_64bit_start_scsi(ha, sp);
                        else
#endif
                            status = qla2100_32bit_start_scsi(ha, sp);
                        if( !status ) {
                            sp->flags |= SRB_SENT;
                            break;
                        }

                        /* Go check for pending interrupts. */
                        qla2100_poll(ha);

                        SYS_DELAY(5);  /* 10 */
                    }
                    if( !cnt ) {

                        /* Remove command from watchdog queue. */
                        if( sp->flags & SRB_WATCHDOG )
                            qla2100_timeout_remove(ha, sp);

                        /* Set timeout status */
                        CMD_RESULT(sp->cmd) = DID_TIME_OUT << 16;
                        qla2100_callback(ha,sp,FALSE);

                        /* Acquire LU queue specific lock */

                        if( q->q_outcnt )
                            q->q_outcnt--;
                    }
                    /* else */
                    /* Acquire LU queue specific lock */
                } else {   /* Place request back on top of device queue. */
                    qla2100_putq_t(q, sp);

                    if( q->q_outcnt )
                        q->q_outcnt--;
                    if( q->q_outcnt < ha->hiwat )
                        q->q_flag &= ~QLA2100_QBUSY;
                    break;
                }
            }
        }

        COMTRACE('n') 
        DRIVER_UNLOCK
        /* Release SCSI LU queue specific lock */

#ifdef QL_DEBUG_LEVEL_3
            /* LEAVE("qla2100_next"); */
#endif
    }

    /*
    * qla2100_alloc_phys
    *      Function used to allocate physical memory
    *      and zero it.
    *
    * Input:
    *      size     = size in bytes.
    *      flag     = sleep flag.
    *      phy_addr = physical address pointer.
    *
    * Returns:
    *      not NULL = success
    */
    STATIC void *
        qla2100_alloc_phys(int siz, u_long *phy_addr) {
        void        *mem = NULL;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_alloc_phys");
#endif
        mem = KMALLOC(siz);
        if( mem != NULL ) {
            *phy_addr = VIRT_TO_BUS(mem);
            BZERO((caddr_t)mem, siz);
            DEBUG(sprintf(debug_buff,"qla2100: get phys mem =0x%lx\n\r",(long)*phy_addr));
            DEBUG(qla2100_print(debug_buff);)
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( mem == NULL )
            qla2100_print("qla2100_alloc_phys: **** FAILED ****\n\r");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_alloc_phys");
#endif
        return(mem);
    }

    /*
    * qla2100_putq_t
    *      Add the standard SCB job to the top of standard SCB commands.
    *
    * Input:
    *      q  = SCSI LU pointer.
    *      sp = srb pointer.
    *      SCSI_LU_Q lock must be already obtained.
    */
    STATIC void
        qla2100_putq_t(scsi_lu_t *q, srb_t *sp) {
        srb_t *srb_p;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        unsigned long cpu_flags = 0;
#endif

#ifdef QL_DEBUG_LEVEL_3
        /* ENTER("qla2100_putq_t"); */
#endif
        DRIVER_LOCK
        DEBUG5(sprintf(debug_buff,"Adding to queue 0x%p<-(0x%p)\n\r",q,sp));
        DEBUG5(qla2100_print(debug_buff));
        sp->s_next = NULL;
        q->q_incnt++;
        if( !q->q_first )                  /* If queue empty */
        {
            sp->s_prev = NULL;
            q->q_first = sp;
            q->q_last = sp;
        } else {      
            srb_p = q->q_first;
            while( srb_p )
                srb_p = srb_p->s_next;

            if( srb_p ) {
                sp->s_prev = srb_p->s_prev;
                if( srb_p->s_prev )
                    srb_p->s_prev->s_next = sp;
                else
                    q->q_first = sp;
                srb_p->s_prev = sp;
                sp->s_next = srb_p;
            } else {
                sp->s_prev = q->q_last;
                q->q_last->s_next = sp;
                q->q_last = sp;
            }
        }

        DRIVER_UNLOCK
#ifdef QL_DEBUG_LEVEL_3
            /* LEAVE("qla2100_putq_t"); */
#endif
    }

    /*
    * qla2100_removeq
    *      Function used to remove a command block from the
    *      LU queue.
    *
    * Input:
    *      q  = SCSI LU pointer.
    *      sp = srb pointer.
    *      SCSI_LU_Q lock must be already obtained.
    */
    STATIC void
        qla2100_removeq(scsi_lu_t *q, srb_t *sp) {
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        unsigned long cpu_flags = 0;
#endif
        DEBUG5(sprintf(debug_buff,"Removing from device_q (0x%p)->(0x%p)\n\r",q,sp));
        DEBUG5(qla2100_print(debug_buff));
        DRIVER_LOCK
            if( sp->s_prev ) {
            if( (sp->s_prev->s_next = sp->s_next) != NULL )
                sp->s_next->s_prev = sp->s_prev;
            else
                q->q_last = sp->s_prev;
        } else if( !(q->q_first = sp->s_next) )
            q->q_last = NULL;
        else
            q->q_first->s_prev = NULL;
        q->q_incnt--;
        DRIVER_UNLOCK
    }
    /*
    * qla2100_callback
    *      Returns the completed SCSI command to LINUX.
    *
    * Returns:
    *      None 
    */
    static inline void qla2100_callback(scsi_qla_host_t *ha, srb_t *sp, uint8_t dec) {
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        unsigned long cpu_flags = 0;
#endif

        CMD_HANDLE(sp->cmd) = (unsigned char *) NULL;

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        DRIVER_LOCK
#endif
            if( dec )
            ha->actthreads--;
        /* Call the mid-level driver interrupt handler */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        sti(); 
        (*(sp->cmd)->scsi_done)(sp->cmd);
        cli(); 
#else
        (*(sp->cmd)->scsi_done)(sp->cmd);
#endif
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        DRIVER_UNLOCK
#endif
    }


    /*
    * qla2100_mem_alloc
    *      Allocates adapter memory.
    *
    * Returns:
    *      0  = success.
    *      1  = failure.
    */
    STATIC uint8_t
    qla2100_mem_alloc(scsi_qla_host_t *ha) {

        uint8_t   status = 1;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_mem_alloc");
#endif

#ifdef DYNAMIC_MEM_ALLOC
        ha->request_ring = qla2100_alloc_phys(REQUEST_ENTRY_SIZE * REQUEST_ENTRY_CNT,
            &ha->request_dma);
        if( ha->request_ring ) {
            ha->response_ring = qla2100_alloc_phys(RESPONSE_ENTRY_SIZE * RESPONSE_ENTRY_CNT,
                &ha->response_dma);
            if( ha->response_ring ) {
                status = 0;
            }
        }
#else
        ha->request_ring = &ha->req[0];
        ha->request_dma = VIRT_TO_BUS(&ha->req[0]);
        ha->response_ring = &ha->res[0];
        ha->response_dma = VIRT_TO_BUS(&ha->res[0]);
#endif
        ha->init_cb = qla2100_alloc_phys(sizeof(init_cb_t),&ha->init_cb_dma);
        if( ha->init_cb )
            status = 0;

        if( status ) {
#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
            qla2100_print("qla2100_mem_alloc: **** FAILED ****\n");
#endif
        }
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_mem_alloc");
#endif
        return(status);
    }

    /*
    * qla2100_mem_free
    *      Frees adapter allocated memory.
    *
    * Input:
    *      ha = adapter block pointer.
    */
    STATIC void
        qla2100_mem_free(scsi_qla_host_t *ha) {
        tgt_t    *tgt;
        uint32_t b, t;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_mem_free");
#endif
        if( ha ) {
            /* Free the target queues */
            b = 0; 
            for( t = 0; t < MAX_FIBRE_DEVICES; t++ ) {
                tgt = TGT_Q(ha, b, t);
                if( tgt )
                    qla2100_tgt_dealloc(ha, tgt);
            }


#ifdef DYNAMIC_MEM_ALLOC
            if( ha->response_ring )
                KMFREE(ha->response_ring,
                    RESPONSE_ENTRY_SIZE * RESPONSE_ENTRY_CNT);

            if( ha->request_ring )
                KMFREE(ha->request_ring,
                    REQUEST_ENTRY_SIZE * REQUEST_ENTRY_CNT);
#endif

        }

#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_mem_free");
#endif
    }



    /*
    * qla2100_tgt_alloc
    *      Allocates a target queue structure.
    *
    * Input:
    *      ha  = adapter block pointer.
    *
    * Returns
    *      target queue structure = success:
    *      NULL = otherwise 
    */
    static inline tgt_t *
        qla2100_tgt_alloc(scsi_qla_host_t *ha) {
        tgt_t    *tgt;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_tgt_alloc");
#endif

        tgt = (tgt_t *)KMALLOC(sizeof(tgt_t));   /* Could Sleep here */
        if( tgt != NULL ) {
            BZERO(tgt,sizeof(tgt_t));
            DEBUG(sprintf(debug_buff,"Alloc Target @ %08x \n",tgt);)
            DEBUG(qla2100_print(debug_buff);)
        }

#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_tgt_alloc");
#endif
        return(tgt);
    }

    /*
    * qla2100_lun_alloc
    *      Allocates a logical device queue structure and lock
    *
    * Returns:
    *      SCSI LU structure pointer
    */
    STATIC inline scsi_lu_t *
        qla2100_lun_alloc(void) {
        scsi_lu_t *q;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_lun_alloc");
#endif

        q = (scsi_lu_t *)KMALLOC(sizeof(scsi_lu_t));  /* Sleep */
        BZERO(q,sizeof(struct scsi_lu));
        DEBUG(sprintf(debug_buff,"Alloc Lun @ %08x \n",q);)
        DEBUG(qla2100_print(debug_buff);)

#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_lun_alloc");
#endif
        return(q);
    }

    /*
    * qla2100_tgt_dealloc
    *      Deallocates a target and all logical device queue structures.
    *
    * Input:
    *      ha  = adapter block pointer.
    *      tgt = Target queue structure pointer
    */
    static inline void
        qla2100_tgt_dealloc(scsi_qla_host_t *ha, tgt_t *tgt) {
        uint32_t  l;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_tgt_dealloc");
#endif

        if( tgt != NULL ) {
            /* Insure all LUN memory is released. */
            for( l = 0; l <  ha->max_luns; l++ ) {
                if( tgt->luns[l] )
                    qla2100_lun_dealloc(tgt->luns[l]);
            }
            KMFREE(tgt, sizeof(tgt_t));
        }

#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_tgt_dealloc");
#endif
    }

    /*
    * qla2100_lun_dealloc
    *      Deallocates a logical unit queue structure.
    *
    * Input:
    *      q = SCSI LU structure pointer
    */
    static inline void 
        qla2100_lun_dealloc(scsi_lu_t *q) {
#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_lun_dealloc");
#endif
        if( q != NULL ) {
            DEBUG(sprintf(debug_buff,"Dealloc Lun @ %08x -- deleted\n",q);)
            DEBUG(qla2100_print(debug_buff);)
            KMFREE(q, sizeof(scsi_lu_t));
        }
#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_lun_dealloc");
#endif

    }

    /*
    *  qla2100_abort_queue_single
    *      Abort all commands on a device queues.
    *
    * Input:
    *      ha = adapter block pointer.
    */
    STATIC void qla2100_abort_queue_single(scsi_qla_host_t *ha,uint32_t b,uint32_t t,uint32_t l,uint32_t stat) {
        scsi_lu_t *q;
        srb_t     *sp; 

        ENTER("qla2100_abort_queue_single");
        /* dg - 08/23/99 
        * We don't want to try and abort queues that don't exists
         * (i.e. the device is not configure on the loop )
         */
        if( ha->loop_down_timer > 0 ) {
            return;
        }
        DEBUG5(sprintf(debug_buff,"Abort queue single %2ld:%2d:%2d:%2d\n",
            ha->host_no,b,t,l);)
        DEBUG5(qla2100_print(debug_buff);)
        q = (scsi_lu_t * )GET_LU_Q(ha, b, t, l);
        while( q != NULL && (sp = q->q_first) != NULL ) {
            /* Acquire LU queue specific lock */

            qla2100_removeq(q, sp);

            /* Release LU queue specific lock */
            CMD_RESULT(sp->cmd) = stat;
            qla2100_done_q_put(sp, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
        }
        LEAVE("qla2100_abort_queue_single");
    }

    /****************************************************************************/
    /*                QLogic ISP2100 Hardware Support Functions.                */
    /****************************************************************************/

    /*
    * qla2100_initialize_adapter
    *      Initialize board.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success
    */
    uint8_t
    qla2100_initialize_adapter(scsi_qla_host_t *ha) {
        device_reg_t *reg;
        uint8_t      status;
        uint8_t      isp_init = 0;
        uint8_t      restart_risc = 0;
        uint8_t      retry;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_initialize_adapter");
#endif

        /* Clear adapter flags. */
        ha->forceLip = 0;
        ha->flags.online = FALSE;
        ha->flags.isp_abort_needed = FALSE;
        ha->flags.disable_host_adapter = FALSE;
        ha->flags.loop_resync_active = FALSE;
        ha->flags.reset_active = FALSE;
        ha->flags.abort_isp_active = FALSE;
        ha->flags.watchdog_enabled = FALSE;
        ha->loop_down_timer = LOOP_DOWN_TIME;
        ha->loop_state = LOOP_DOWN;
        ha->flags.start_timer  = FALSE;
        ha->device_flags = 0L;
        DEBUG(printk("Configure PCI space for adapter...\n"));

        if( !(status = qla2100_pci_config(ha)) ) {
            reg = ha->iobase;

            qla2100_reset_chip(ha); 

            /* Initialize Fibre Channel database. */
            qla2100_init_fc_db(ha); 

            /* Initialize target map database. */
            qla2100_init_tgt_map(ha); 
            if( qla2100_verbose )
                printk("scsi(%d): Configure NVRAM parameters...\n",(int)ha->host_no);

            if( ha->device_id == QLA2100_DEVICE_ID )  
                qla2100_nvram_config(ha);
            else
                qla2200_nvram_config(ha);
            if( qla2100_verbose )
                printk("scsi(%d): Verifying loaded RISC code...\n",(int)ha->host_no);

            qla2100_set_cache_line(ha);
            retry = 10;
            /* 
             * Try an configure the loop.
             */
            do {
                /* If firmware needs to be loaded */
                if( qla2100_isp_firmware(ha) ) {
                    if( qla2100_verbose )
                        printk("scsi(%d): Verifying chip...\n",(int)ha->host_no);

                    if( !(status = qla2100_chip_diag(ha)) )
                        status = qla2100_setup_chip(ha);

                    if( !status )
                        DEBUG(printk("scsi(%d): Chip verified and RISC loaded...\n",(int)ha->host_no));
                }
                if( !status && !(status = qla2100_init_rings(ha)) ) {
                    /* dg - 7/3/1999
                    *
                    * Wait for a successful LIP up to a maximum of (in seconds):
                    * RISC login timeout value, RISC retry count value, and port
                    * down retry value OR a minimum of 4 seconds OR If no cable, 
                    * only 5 seconds.
                    */
                    if( !qla2100_fw_ready(ha) ) {
                        ha->flags.reset_marker = FALSE;
                        /* Go setup flash database devices with proper Loop ID's. */
                        do {
                            ha->flags.loop_resync_needed = FALSE;
                            status = qla2100_update_fc_db(ha, FALSE);
                        }while( !ha->loop_down_timer && ha->flags.loop_resync_needed );

                        /* If database was full and a device was not configured. */
                        /* try and reuse the slots.                              */
                        if( status == 2 ) { 
                            do {
                                ha->flags.loop_resync_needed = FALSE;
                                status = qla2100_update_fc_db(ha, TRUE);
                            }while( !ha->loop_down_timer && ha->flags.loop_resync_needed );
                        }
                    }
                    if( ha->flags.update_config_needed ) {
                        ha->init_cb->additional_firmware_options.connection_options = ha->operating_mode;
                        restart_risc = 1;
                    }
                    isp_init = 1;

                }
            } while( restart_risc && retry-- );
            if( isp_init ) {
                ha->flags.reset_marker = FALSE;
                qla2100_marker(ha, 0, 0, 0, MK_SYNC_ALL);

                ha->flags.online = TRUE;

                /* Enable target response to SCSI bus. */
                if( ha->flags.enable_target_mode )
                    qla2100_enable_lun(ha);
            }

        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_initialize_adapter: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_initialize_adapter");
#endif
        return(status);
    }

    /*
    * ISP Firmware Test
    *      Checks if present version of RISC firmware is older than
    *      driver firmware.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = firmware does not need to be loaded.
    */
    STATIC uint8_t
    qla2100_isp_firmware(scsi_qla_host_t *ha) {
        uint8_t  status;
        uint16_t mb[MAILBOX_REGISTER_COUNT];

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_isp_firmware");
#endif

        if( ha->flags.disable_risc_code_load ) {
            /* Verify checksum of loaded RISC code. */
            mb[0] = MBC_VERIFY_CHECKSUM;
            mb[1] = *QL2x00BoardTbl[ha->devnum].fwstart;  
            if( !(status = qla2100_mailbox_command(ha, BIT_1|BIT_0, &mb[0])) ) {
                /* Start firmware execution. */
                mb[0] = MBC_EXECUTE_FIRMWARE;
                mb[1] = *QL2x00BoardTbl[ha->devnum].fwstart;  
                qla2100_mailbox_command(ha, BIT_1|BIT_0, &mb[0]);
            }
        } else
            status = 1;

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print(
                "qla2100_isp_firmware: **** Load RISC code ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_isp_firmware");
#endif
        return(status);
    }



    /*
    * (08/05/99) 
    *
    * PCI configuration
    *      Setup device PCI configuration registers.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success.
    */
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,1,95)
    STATIC uint8_t
    qla2100_pci_config(scsi_qla_host_t *ha) {
        uint8_t      status = 1;
        uint32_t     command;
#if MEMORY_MAPPED_IO
        uint32_t  page_offset, base;
        uint32_t   mmapbase;
#endif
        uint16_t     buf_wd;

        ENTER("qla2100_pci_config");

        pci_read_config_word(ha->pdev, PCI_REVISION_ID, &buf_wd); 
        ha->revision = buf_wd;  
        if( !ha->iobase ) {
            /* Get command register. */
            if( pci_read_config_word(ha->pdev, PCI_COMMAND, &buf_wd) == PCIBIOS_SUCCESSFUL ) {
                command = buf_wd;

                /*
                * Set Bus Master Enable (bit-2), Memory Address Space Enable and
                * reset any error bits.
                */
                buf_wd &= ~0x7;
#if MEMORY_MAPPED_IO
                DEBUG(printk("qla2100: I/O SPACE and MEMORY MAPPED IO is enabled.\n"));
                buf_wd |= BIT_2 + BIT_1 + BIT_0;
#else
                DEBUG(printk("qla2100: I/O SPACE Enabled and MEMORY MAPPED IO is disabled.\n"));
                buf_wd |= BIT_2 + BIT_0;
#endif
                if( pci_write_config_word(ha->pdev, PCI_COMMAND, buf_wd) ) {
                    printk(KERN_WARNING "qla2100: Could not write config word.\n");
                }
                /* Get expansion ROM address. */
                if( pci_read_config_word(ha->pdev, PCI_ROM_ADDRESS, &buf_wd) == PCIBIOS_SUCCESSFUL ) {
                    /* Reset expansion ROM address decode enable. */
                    buf_wd &= ~BIT_0;
                    if( pci_write_config_word(ha->pdev, PCI_ROM_ADDRESS, buf_wd) == PCIBIOS_SUCCESSFUL ) {
#if MEMORY_MAPPED_IO
                        /* Get memory mapped I/O address. */
                        pci_read_config_dword(ha->pci_bus, PCI_BASE_ADDRESS_1, &mmapbase);
                        mmapbase &= PCI_BASE_ADDRESS_MEM_MASK;

                        /* Find proper memory chunk for memory map I/O reg. */
                        base = mmapbase & PAGE_MASK;
                        page_offset = mmapbase - base;
                        /* Get virtual address for I/O registers. */
                        ha->mmpbase = ioremap(base,page_offset + 256);
                        if( ha->mmpbase ) {
                            ha->mmpbase += page_offset;
                            /* ha->iobase = ha->mmpbase; */
                            status = 0;
                        }
#else /* MEMORY_MAPPED_IO */
                        status = 0;
#endif /* MEMORY_MAPPED_IO */
                    }
                }
            }
        } else
            status = 0;


        LEAVE("qla2100_pci_config");
        return(status);
    }
#else
    STATIC uint8_t
    qla2100_pci_config(scsi_qla_host_t *ha) {
        uint8_t      status = 1;
        uint32_t     command;
#if MEMORY_MAPPED_IO
        uint32_t  page_offset, base;
        uint32_t   mmapbase;
#endif
        config_reg_t *creg = 0;
        uint16_t     buf_wd;

        ENTER("qla2100_pci_config");

        pcibios_read_config_word(ha->pci_bus,ha->pci_device_fn, OFFSET(creg->revision_id), &buf_wd); 
        ha->revision = buf_wd;  
        if( !ha->iobase ) {
            /* Get command register. */
            if( pcibios_read_config_word(ha->pci_bus,ha->pci_device_fn, OFFSET(creg->command), &buf_wd) == PCIBIOS_SUCCESSFUL ) {
                command = buf_wd;

                /*
                * Set Bus Master Enable (bit-2), Memory Address Space Enable and
                * reset any error bits.
                */
                buf_wd &= ~0x7;
#if MEMORY_MAPPED_IO
                DEBUG(printk("qla2100: I/O SPACE and MEMORY MAPPED IO is enabled.\n"));
                buf_wd |= BIT_2 + BIT_1 + BIT_0;
#else
                DEBUG(printk("qla2100: I/O SPACE Enabled and MEMORY MAPPED IO is disabled.\n"));
                buf_wd |= BIT_2 + BIT_0;
#endif
                if( pcibios_write_config_word(ha->pci_bus,ha->pci_device_fn, OFFSET(creg->command), buf_wd) ) {
                    printk(KERN_WARNING "qla2100: Could not write config word.\n");
                }
                /* Get expansion ROM address. */
                if( pcibios_read_config_word(ha->pci_bus,ha->pci_device_fn, OFFSET(creg->expansion_rom), &buf_wd) == PCIBIOS_SUCCESSFUL ) {
                    /* Reset expansion ROM address decode enable. */
                    buf_wd &= ~BIT_0;
                    if( pcibios_write_config_word(ha->pci_bus,ha->pci_device_fn, OFFSET(creg->expansion_rom), buf_wd) == PCIBIOS_SUCCESSFUL ) {
#if MEMORY_MAPPED_IO
                        /* Get memory mapped I/O address. */
                        pcibios_read_config_dword(ha->pci_bus, ha->pci_device_fn,OFFSET(cfgp->mem_base_addr), &mmapbase);
                        mmapbase &= PCI_BASE_ADDRESS_MEM_MASK;

                        /* Find proper memory chunk for memory map I/O reg. */
                        base = mmapbase & PAGE_MASK;
                        page_offset = mmapbase - base;
                        /* Get virtual address for I/O registers. */
                        ha->mmpbase = ioremap(base,page_offset + 256);
                        if( ha->mmpbase ) {
                            ha->mmpbase += page_offset;
                            /* ha->iobase = ha->mmpbase; */
                            status = 0;
                        }
#else /* MEMORY_MAPPED_IO */
                        status = 0;
#endif /* MEMORY_MAPPED_IO */
                    }
                }
            }
        } else
            status = 0;


        LEAVE("qla2100_pci_config");
        return(status);
    }
#endif


    /*
    * qla2100_set_cache_line
    *      Sets PCI cache line parameter.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success.
    */
    STATIC uint8_t
    qla2100_set_cache_line(scsi_qla_host_t *ha) {
        int          status = 0;
        uint8_t      buf;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_set_cache_line");
#endif
        /* Set the cache line. */
        if( ha->flags.set_cache_line_size_1 ) {
            buf = 1;
            if( pci_write_config_byte(ha->pdev, PCI_CACHE_LINE_SIZE, buf) != PCIBIOS_SUCCESSFUL )
                status = 1;
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_set_cache_line: **** FAILED ****\n\r");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_set_cache_line");
#endif
        return(status);
    }

    /*
    * Chip diagnostics
    *      Test chip for proper operation.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success.
    */
    STATIC uint8_t
    qla2100_chip_diag(scsi_qla_host_t *ha) {
        device_reg_t *reg   = ha->iobase;
        uint8_t      status = 0;
        uint16_t     data;
        uint32_t     cnt;
        uint16_t     mb[MAILBOX_REGISTER_COUNT];

        ENTER("qla2100_chip_diag");
#ifdef QL_DEBUG_LEVEL_3
        qla2100_print("qla2100_chip_diag: testing device at ");
        qla2100_output_number((u_long)&reg->flash_address, 16);
        qla2100_print("\n");
#endif

        /* Reset ISP chip. */
        WRT_REG_WORD(&reg->ctrl_status, ISP_RESET);
        data = qla2100_debounce_register(&reg->ctrl_status);
        for( cnt = 6000000; cnt && data & ISP_RESET; cnt-- ) {
            SYS_DELAY(5);
            data = RD_REG_WORD(&reg->ctrl_status);
        }

        if( cnt ) {
#if defined(QL_DEBUG_LEVEL_3)
            qla2100_print("qla2100_chip_diag: reset register cleared by chip reset\n\r");
#endif
            /* Reset RISC processor. */
            WRT_REG_WORD(&reg->host_cmd, HC_RESET_RISC);
            WRT_REG_WORD(&reg->host_cmd, HC_RELEASE_RISC);
            data = qla2100_debounce_register(&reg->mailbox0);
            for( cnt = 6000000; cnt && data == MBS_BUSY; cnt-- ) {
                SYS_DELAY(5);
                data = RD_REG_WORD(&reg->mailbox0);
            }

            if( cnt ) {
                /* Check product ID of chip */
#if defined(QL_DEBUG_LEVEL_3)
                qla2100_print("qla2100_chip_diag: Checking product ID of chip\n\r");
#endif
                if( RD_REG_WORD(&reg->mailbox1) != PROD_ID_1 ||
                    (RD_REG_WORD(&reg->mailbox2) != PROD_ID_2 &&
                    RD_REG_WORD(&reg->mailbox2) != PROD_ID_2a) ||
                    RD_REG_WORD(&reg->mailbox3) != PROD_ID_3 ||
                    qla2100_debounce_register(&reg->mailbox4) != PROD_ID_4 ) {
                    printk(KERN_INFO "qla2100: Wrong product ID = 0x%x,0x%x,0x%x,0x%x\n",
                        RD_REG_WORD(&reg->mailbox1),
                        RD_REG_WORD(&reg->mailbox2),
                        RD_REG_WORD(&reg->mailbox3),
                        RD_REG_WORD(&reg->mailbox4));
                    status = 1;
                } else {
                    /* Now determine if we have a 2200A board */
                    if( ( ha->device_id == QLA2200_DEVICE_ID   ||
                        ha->device_id == QLA2200A_DEVICE_ID ) &&
                        RD_REG_WORD(&reg->mailbox7) == QLA2200A_RISC_ROM_VER ) {
                        ha->device_id = QLA2200A_DEVICE_ID;
#if defined(QL_DEBUG_LEVEL_3)
                        qla2100_print("qla2100_chip_diag: Found QLA2200A chip.\n\r");
#endif
                    }
                    DEBUG(printk("qla2100_chip_diag: Checking mailboxes.\n"));
#if defined(QL_DEBUG_LEVEL_3)
                    qla2100_print("qla2100_chip_diag: Checking mailboxes.\n\r");
#endif
                    /* Wrap Incoming Mailboxes Test. */
                    mb[0] = MBC_MAILBOX_REGISTER_TEST;
                    mb[1] = 0xAAAA;
                    mb[2] = 0x5555;
                    mb[3] = 0xAA55;
                    mb[4] = 0x55AA;
                    mb[5] = 0xA5A5;
                    mb[6] = 0x5A5A;
                    mb[7] = 0x2525;
                    if( !(status = qla2100_mailbox_command(ha,
                        BIT_7|BIT_6|BIT_5|BIT_4|BIT_3|BIT_2|BIT_1|BIT_0,
                        &mb[0])) ) {
                        if( mb[1] != 0xAAAA || mb[2] != 0x5555 ||
                            mb[3] != 0xAA55 || mb[4] != 0x55AA )
                            status = 1;
                        if( mb[5] != 0xA5A5 || mb[6] != 0x5A5A ||
                            mb[7] != 0x2525 )
                            status = 1;
                        if( status ) {
                            printk(KERN_INFO "qla2100: Failed mailbox check\n");
                        }
                    }
                }
            } else
                status = 1;
        } else
            status = 1;

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_chip_diag: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_chip_diag");
#endif
        return(status);
    }

    /*
    * Setup chip
    *      Load and start RISC firmware.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success.
    */
    STATIC uint8_t
    qla2100_setup_chip(scsi_qla_host_t *ha) {
        uint16_t cnt;
        uint16_t risc_address;
        uint16_t *risc_code_address;
        long risc_code_size;
        uint16_t mb[MAILBOX_REGISTER_COUNT];
        uint8_t  status = 0;
        int num;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_setup_chip");
#endif

        /* Load RISC code. */
        risc_address = *QL2x00BoardTbl[ha->devnum].fwstart;  
        risc_code_address = QL2x00BoardTbl[ha->devnum].fwcode;  
        risc_code_size    = (long)(*QL2x00BoardTbl[ha->devnum].fwlen & 0xffff);  

        DEBUG(printk("qla2100_setup_chip:  Loading RISC code size =(%d).\n",risc_code_size);)
        num = 0;
        DEBUG(ql_debug_print = 0;)
        while( risc_code_size > 0 && !status ) {
            /* for 2200A set transfer size to 128 bytes */
            if( ha->device_id == QLA2200A_DEVICE_ID )
                cnt = 128 >> 1;
            else
                cnt = REQUEST_ENTRY_SIZE * REQUEST_ENTRY_CNT >> 1;  
            if( cnt > risc_code_size )
                cnt = risc_code_size;

            DEBUG5(sprintf(debug_buff,"qla2100_setup_chip:loading risc segment@ addr 0x%x:bytes %d:offset 0x%p.\n\r",
                cnt,risc_address,risc_code_address);)
            DEBUG5(qla2100_print(debug_buff));
            BCOPY((caddr_t) risc_code_address,(caddr_t) ha->request_ring, (cnt <<1));
            mb[0] = MBC_LOAD_RAM;
            /* mb[0] = MBC_LOAD_RAM_A64; */
            mb[1] = risc_address;
            mb[3] = (uint16_t)(ha->request_dma & 0xffff);
            mb[2] = (uint16_t)((ha->request_dma >> 16) & 0xffff);
            mb[4] = cnt;
            mb[7] = QL21_64BITS_3RDWD(ha->request_dma);
            mb[6] = QL21_64BITS_4THWD(ha->request_dma);
            status = qla2100_mailbox_command(ha, BIT_4|BIT_3|BIT_2|BIT_1|BIT_0,
                &mb[0]);

            if( status ) {
                qla2100_dump_regs(ha->host);
                printk("Failed to load segment %d of FW\n",num);
                break;
            }
            risc_address += cnt;
            risc_code_size -= cnt;
            risc_code_address += cnt;
            num++;
        }
        DEBUG(ql_debug_print = 1;)
#ifdef QLA2100_UNUSED
        {
            int i;
            uint8_t temp;

            temp =  ql_debug_print;
            if( ql_debug_print )
                ql_debug_print = 0;
            for( i = 0; i < ql21_risc_code_length01; i++ ) {
                mb[0] = 0x4;
                mb[1] = ql21_risc_code_addr01 + i;
                mb[2] = ql21_risc_code01[i];

                status = qla2100_mailbox_command(ha, BIT_2|BIT_1|BIT_0,
                    &mb[0]);
                if( status ) {
                    printk("qla2100 : firmware load failure\n");
                    break;
                }

                mb[0] = 0x5;
                mb[1] = ql21_risc_code_addr01 + i;
                mb[2] = 0;

                status = qla2100_mailbox_command(ha, BIT_2|BIT_1|BIT_0,
                    &mb[0]);
                if( status ) {
                    printk("qla2100 : firmware dump failure\n");
                    break;
                }
                if( mb[2] != ql21_risc_code01[i] )
                    printk("qla2100 : firmware compare error @ (0x%x)\n",ql21_risc_code_addr01+i);
            }
            ql_debug_print = temp;
        }
#endif
        /* Verify checksum of loaded RISC code. */
        if( !status ) {
            DEBUG(printk("qla2100_setup_chip: Verifying checksum of loaded RISC code.\n");)
            mb[0] = MBC_VERIFY_CHECKSUM;
            mb[1] = *QL2x00BoardTbl[ha->devnum].fwstart;  
            if( !(status = qla2100_mailbox_command(ha, BIT_1|BIT_0, &mb[0])) ) {
                /* Start firmware execution. */
                DEBUG(qla2100_print("qla2100_setup_chip: start firmware running.\n\r");)
                mb[0] = MBC_EXECUTE_FIRMWARE;
                mb[1]= *QL2x00BoardTbl[ha->devnum].fwstart;  
                qla2100_mailbox_command(ha, BIT_1|BIT_0, &mb[0]);
            }
            else
                printk("qla2100_setup_chip: Failed checksum.\n");
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_setup_chip: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_setup_chip");
#endif
        return(status);
    }

    /*
    * qla2100_init_rings
    *      Initializes firmware.
    *
    *      Beginning of request ring has initialization control block
    *      already built by nvram config routine.
    *
    * Input:
    *      ha                = adapter block pointer.
    *      ha->request_ring  = request ring virtual address
    *      ha->response_ring = response ring virtual address
    *      ha->request_dma   = request ring physical address
    *      ha->response_dma  = response ring physical address
    *
    * Returns:
    *      0 = success.
    */
    STATIC uint8_t
    qla2100_init_rings(scsi_qla_host_t *ha) {
        uint8_t  status;
        uint16_t mb[MAILBOX_REGISTER_COUNT];
        int cnt;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_init_rings");
#endif
        /* Clear outstanding commands array. */
        for( cnt = 0; cnt < MAX_OUTSTANDING_COMMANDS; cnt++ )
            ha->outstanding_cmds[cnt] = 0;

        /* Initialize firmware. */
        ha->request_ring_ptr  = ha->request_ring;
        ha->req_ring_index    = 0;
        ha->req_q_cnt         = REQUEST_ENTRY_CNT;
        ha->response_ring_ptr = ha->response_ring;
        ha->rsp_ring_index    = 0;
        mb[0] = MBC_INITIALIZE_FIRMWARE;
        mb[3] = (uint16_t)ha->init_cb_dma;
        mb[2] = (uint16_t)(ha->init_cb_dma >> 16);
        mb[4] = 0;
        mb[5] = 0;
        mb[7] = QL21_64BITS_3RDWD(ha->init_cb_dma);
        mb[6] = QL21_64BITS_4THWD(ha->init_cb_dma);
        status = qla2100_mailbox_command(ha,
            BIT_7|BIT_6|BIT_5|BIT_4|BIT_3|BIT_2|BIT_0,
            &mb[0]);

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_init_rings: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_init_rings");
#endif
        return(status);
    }

    /*
    * qla2100_fw_ready
    *      Waits for firmware ready.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success.
    */
    STATIC uint8_t
    qla2100_fw_ready(scsi_qla_host_t *ha) {
        uint8_t  status = 0;
        uint16_t cnt, cnt1;
        uint16_t mb[MAILBOX_REGISTER_COUNT];
        uint16_t timeout, data;
        uint32_t i;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_fw_ready");
#endif

        timeout = (ha->retry_count * ha->login_timeout) + 5;
        cnt1 = 10; 
        /* Wait for ISP to finish LIP */
        for( cnt = timeout; cnt; cnt-- ) {
            mb[0] = MBC_GET_FIRMWARE_STATE;
            if( !(status = qla2100_mailbox_command(ha, BIT_0, &mb[0])) ) {
#if 0
                    if( (mb[1] == FSTATE_CONFIG_WAIT) && 
                    ((mb[2] == FSTATE_P2P_RCV_LIP) || 
                    (mb[2] == FSTATE_P2P_RCV_UNIDEN_LIP) ||
                    (mb[2] == FSTATE_FATAL_ERROR) ||
                    (mb[2] == FSTATE_LOOP_BACK_CONN)) ) {
                    if( (mb[2] == FSTATE_P2P_RCV_LIP) || 
                        (mb[2] == FSTATE_P2P_RCV_UNIDEN_LIP) || 
                        (mb[2] == FSTATE_LOOP_BACK_CONN) ) 
                        ha->operating_mode = LOOP;
                    ha->flags.update_config_needed = 1;
                    status = 1;
                    break;
                }
#endif
                DEBUG(printk("qla2100_fw_ready: mb1=%d, mb2=%d\n",mb[1],mb[2]);)
                if( ha->loop_down_timer || mb[1] != FSTATE_READY ) {
                    status = 1;
                    /* Exit if no cable connected after 10 seconds. */
                    if( !cnt1-- )
                        if( mb[1] == FSTATE_CONFIG_WAIT || mb[1] == FSTATE_LOSS_OF_SYNC ) {

                            break;   
                        }
                } else {
                    DEBUG(printk("qla2100_fw_ready: F/W Ready - OK \n");)
                    status = 0;   /* dg 09/15/99 */
                    break;
                }
            }

            if( ha->flags.online ) {
                status = 0;   /* dg 09/15/99 */
                break;
            }

            /* Delay for a second */
            for( i = 0 ; i < 1000; i++ ) {
                SYS_DELAY(1000); 
                data = qla2100_debounce_register(&ha->iobase->istatus);
            }
            /* QLA2100_DELAY(1); */

#ifdef QL_DEBUG_LEVEL_2
            qla2100_print("qla2100_fw_ready: mailbox_out[1] = ");
            qla2100_output_number((u_long)mb[1], 16);
            qla2100_print("\n");
#endif
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_fw_ready: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_fw_ready");
#endif
        return(status);
    }

    /*
    *  qla2100_configure_hba
    *      Setup adapter context.
    *
    * Input:
    *      ha = adapter state pointer.
    *
    * Returns:
    *      0 = success
    *
    * Context:
    *      Kernel context.
    */
    STATIC uint8_t
    qla2100_configure_hba(scsi_qla_host_t *ha) {
        uint8_t       rval;
        uint16_t    mb[MAILBOX_REGISTER_COUNT];

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_configure_hba");
#endif

        /* Get host addresses. */
        mb[0] = MBC_GET_ADAPTER_LOOP_ID;
        rval = qla2100_mailbox_command(ha, BIT_0, &mb[0]);
        if( !rval ) {
            ha->loop_id = mb[1];

            /* Get loop topology. */
            if( ha->device_id == QLA2100_DEVICE_ID ) {
                mb[6] = 0;
            }
            ha->flags.point_to_point = FALSE;
            ha->min_external_loopid = SNS_FIRST_LOOP_ID;   
            ha->operating_mode = LOOP;
            switch( mb[6] ) {
            case 0:
                ha->current_topology = ISP_CFG_NL;
                break;
            case 1:
                ha->current_topology = ISP_CFG_FL;
                break;
            case 2:
                ha->flags.point_to_point = TRUE;
                ha->operating_mode = P2P;
                ha->current_topology = ISP_CFG_N;
                ha->min_external_loopid = 0;   
                break;
            case 3:
                ha->flags.point_to_point = TRUE;
                ha->operating_mode = P2P;
                ha->current_topology = ISP_CFG_F;
                ha->min_external_loopid = 0;   
                break;
            default:
                ha->current_topology = ISP_CFG_NL;
                break;
            }

            /* Save Host port and loop ID. */
            ha->port_id[0] = LSB(mb[2]);
            ha->port_id[1] = MSB(mb[2]);
            ha->port_id[2] = LSB(mb[3]); 
            printk("scsi%d: Topology %d, Host Loop address 0x%x\n",(int)ha->host_no,mb[6], ha->loop_id);
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( rval != 0 )
            qla2100_print("qla2100_configure_hba: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_configure_hba");
#endif
        return(rval);
    }
    /*
    * NVRAM configuration for 2100.
    *
    * Input:
    *      ha                = adapter block pointer.
    *      ha->request_ring  = request ring virtual address
    *      ha->response_ring = response ring virtual address
    *      ha->request_dma   = request ring physical address
    *      ha->response_dma  = response ring physical address
    *
    * Output:
    *      initialization control block in response_ring
    *      host adapters parameters in host adapter block
    *
    * Returns:
    *      0 = success.
    */
    STATIC uint8_t
    qla2100_nvram_config(scsi_qla_host_t *ha) {
        uint8_t   status = 0;
        uint16_t  cnt;
        caddr_t   dptr1, dptr2;
        init_cb_t *icb   = ha->init_cb;
        nvram21_t   *nv    = (nvram21_t *)ha->request_ring;
        uint16_t  *wptr  = (uint16_t *)ha->request_ring;
        uint8_t   chksum = 0;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_nvram_config");
#endif

        /* Verify valid NVRAM checksum. */
        for( cnt = 0; cnt < sizeof(nvram21_t)/2; cnt++ ) {
            *wptr = qla2100_get_nvram_word(ha, cnt);
            chksum += (uint8_t)*wptr;
            chksum += (uint8_t)(*wptr >> 8);
            wptr++;
        }

#if  DEBUG_PRINT_NVRAM
        qla2100_print(
            "qla2100_nvram_config: Contents of NVRAM ");
        qla2100_print("\n\r");
        qla2100_dump_buffer((uint8_t *)ha->request_ring, sizeof(nvram21_t));
#endif

        /* Bad NVRAM data, set defaults parameters. */
        if( chksum || nv->id[0] != 'I' || nv->id[1] != 'S' || nv->id[2] != 'P' ||
            nv->id[3] != ' ' || nv->nvram_version < 1 ) {
            /* Reset NVRAM data. */
            DEBUG(printk("Using defaults for NVRAM: \n"));
            DEBUG(printk("checksum=0x%x, Id=%c, version=0x%x\n",chksum,nv->id[0],nv->nvram_version));
            wptr = (uint16_t *)ha->request_ring;
            for( cnt = 0; cnt < sizeof(nvram21_t)/2; cnt++ )
                *wptr++ = 0;

            /*
            * Set default initialization control block.
            */
            nv->parameter_block_version = ICB_VERSION;
            nv->firmware_options.enable_fairness = 1;
            nv->firmware_options.enable_fast_posting = 1;
            nv->firmware_options.enable_full_login_on_lip = 1;

            nv->frame_payload_size  = 1024;
            nv->max_iocb_allocation = 256;
            nv->execution_throttle  = 16;
            nv->retry_count         = 8;
            nv->retry_delay         = 1;
            nv->node_name[0]        = 32;
            nv->node_name[3]        = 224;
            nv->node_name[4]        = 139;
            nv->login_timeout       = 4;

            /*
            * Set default host adapter parameters
            */
            nv->host_p.enable_lip_full_login = 1;
            nv->reset_delay = 5;
            nv->port_down_retry_count = 8;
            nv->maximum_luns_per_target = 8;
            status = 1;
        }

        /*
        * Copy over NVRAM RISC parameter block
        * to initialization control block.
        */
        dptr1 = (caddr_t)icb;
        dptr2 = (caddr_t)&nv->parameter_block_version;
        cnt = (caddr_t)&nv->host_p - (caddr_t)&nv->parameter_block_version;
        while( cnt-- )
            *dptr1++ = *dptr2++;

        /*
        * Setup driver firmware options.
        */
#if  QL2100_TARGET_MODE_SUPPORT
        icb->firmware_options.enable_target_mode       = 1;
#else
        icb->firmware_options.enable_target_mode       = 0;
#endif
        icb->firmware_options.disable_initiator_mode   = 0;
        icb->firmware_options.enable_port_update_event = 1;
        icb->firmware_options.enable_full_login_on_lip = 1;

        /*
        * Set host adapter parameters
        */
        ha->flags.enable_target_mode = icb->firmware_options.enable_target_mode;
        ha->flags.disable_luns            = nv->host_p.disable_luns;
        ha->flags.disable_risc_code_load  = nv->host_p.disable_risc_code_load;
        ha->flags.set_cache_line_size_1   = nv->host_p.set_cache_line_size_1;
        ha->flags.enable_64bit_addressing = nv->host_p.enable_64bit_addressing;
        ha->flags.enable_lip_reset        = nv->host_p.enable_lip_reset;
        ha->flags.enable_lip_full_login   = nv->host_p.enable_lip_full_login;
        ha->flags.enable_target_reset     = nv->host_p.enable_target_reset;
        ha->flags.enable_flash_db_update  = nv->host_p.enable_database_storage;

        /* 01/18/00 - Execution depth */
        ha->hiwat =  nv->execution_throttle;
        
        ha->retry_count           = nv->retry_count;
        ha->login_timeout         = nv->login_timeout;
        /* Set minimum login_timeout to 4 seconds. */
        if( ha->login_timeout < 4 )
            ha->login_timeout = 4;
        ha->port_down_retry_count = nv->port_down_retry_count;
        ha->minimum_timeout       = (ha->login_timeout * ha->retry_count)
            + ha->port_down_retry_count;
        ha->loop_reset_delay      = nv->reset_delay;
        /* Will get the value from nvram. */
        ha->loop_down_timeout     = LOOP_DOWN_TIMEOUT; 
        ha->loop_down_abort_time  = LOOP_DOWN_TIME - ha->loop_down_timeout;


#if  USE_BIOS_MAX_LUNS
        if( !nv->maximum_luns_per_target )
            ha->max_luns = MAX_LUNS-1;
        else
            ha->max_luns = nv->maximum_luns_per_target;
#else
        ha->max_luns = MAX_LUNS-1;
#endif

        /*
        * Setup ring parameters in initialization control block
        */
        icb->request_q_outpointer  = 0;
        icb->response_q_inpointer  = 0;
        icb->request_q_length      = REQUEST_ENTRY_CNT;
        icb->response_q_length     = RESPONSE_ENTRY_CNT;
        icb->request_q_address[0]  = (uint32_t) ha->request_dma;
        /* 01/14/00  icb->request_q_address[1]  = 0; */
        icb->request_q_address[1]  = MS_64BITS(ha->request_dma);
        icb->response_q_address[0] = (uint32_t) ha->response_dma;
        /* 01/14/00 icb->response_q_address[1] = 0;  */
        icb->response_q_address[1] =MS_64BITS(ha->response_dma);

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_nvram_config: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_nvram_config");
#endif
        return(status);
    }

    /*
    * NVRAM configuration for the 2200.
    *
    * Input:
    *      ha                = adapter block pointer.
    *      ha->request_ring  = request ring virtual address
    *      ha->response_ring = response ring virtual address
    *      ha->request_dma   = request ring physical address
    *      ha->response_dma  = response ring physical address
    *
    * Output:
    *      initialization control block in response_ring
    *      host adapters parameters in host adapter block
    *
    * Returns:
    *      0 = success.
    */
    STATIC uint8_t
    qla2200_nvram_config(scsi_qla_host_t *ha) {
        uint8_t   status = 0;
        uint16_t  cnt;
        caddr_t   dptr1, dptr2;
        init_cb_t *icb   = ha->init_cb;
        nvram22_t   *nv    = (nvram22_t *)ha->request_ring;
        uint16_t  *wptr  = (uint16_t *)ha->request_ring;
        uint8_t   chksum = 0;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2200_nvram_config");
#endif

        if( !ha->flags.nvram_config_done ) {

            /* Verify valid NVRAM checksum. */
            for( cnt = 0; cnt < sizeof(nvram22_t)/2; cnt++ ) {
                *wptr = qla2100_get_nvram_word(ha, cnt);
                chksum += (uint8_t)*wptr;
                chksum += (uint8_t)(*wptr >> 8);
                wptr++;
            }

#if  DEBUG_PRINT_NVRAM
            qla2100_print(
                "qla2200_nvram_config: Contents of NVRAM ");
            qla2100_print("\n\r");
            qla2100_dump_buffer((uint8_t *)ha->request_ring, sizeof(nvram22_t));
#endif

            /* Bad NVRAM data, set defaults parameters. */
            if( chksum || nv->id[0] != 'I' || nv->id[1] != 'S' || nv->id[2] != 'P' ||
                nv->id[3] != ' ' || nv->nvram_version < 1 ) {
                /* Reset NVRAM data. */
                DEBUG(printk("Using defaults for NVRAM: \n"));
                DEBUG(printk("checksum=0x%x, Id=%c, version=0x%x\n",chksum,nv->id[0],nv->nvram_version));
                wptr = (uint16_t *)nv;
                for( cnt = 0; cnt < sizeof(nvram21_t)/2; cnt++ )
                    *wptr++ = 0;

                /*
                * Set default initialization control block.
                */
                nv->parameter_block_version = ICB_VERSION;
                nv->firmware_options.enable_fairness = 1;
                nv->firmware_options.enable_fast_posting = 1;
                nv->firmware_options.enable_full_login_on_lip = 1;
                nv->firmware_options.expanded_ifwcb = 1;

                nv->frame_payload_size  = 1024;
                nv->max_iocb_allocation = 256;
                nv->execution_throttle  = 16;
                nv->retry_count         = 8;
                nv->retry_delay         = 1;
                nv->port_name[0]        = 32;
                nv->port_name[3]        = 224;
                nv->port_name[4]        = 139;
                nv->login_timeout       = 4;
                nv->additional_firmware_options.connection_options = P2P_LOOP;
                /*
                * Set default host adapter parameters
                */
                nv->host_p.enable_lip_full_login = 1;
                nv->reset_delay = 5;
                nv->port_down_retry_count = 8;
                nv->maximum_luns_per_target = 8;
                status = 1;
            }

            /* Reset NVRAM data. */
            BZERO((caddr_t)icb, sizeof(init_cb_t));
            /*
            * Copy over NVRAM RISC parameter block
            * to initialization control block.
            */
            dptr1 = (caddr_t)icb;
            dptr2 = (caddr_t)&nv->parameter_block_version;
            cnt = (caddr_t)&nv->additional_firmware_options - (caddr_t)&nv->parameter_block_version;
            while( cnt-- )
                *dptr1++ = *dptr2++;

            dptr1 += (caddr_t)&icb->additional_firmware_options - (caddr_t)&icb->request_q_outpointer;
            cnt = (caddr_t)&nv->host_p - (caddr_t)&nv->additional_firmware_options;
            while( cnt-- )
                *dptr1++ = *dptr2++;
            /*
            * Setup driver firmware options.
            */
            icb->firmware_options.enable_full_duplex       = 0;
#if  QL2100_TARGET_MODE_SUPPORT
            icb->firmware_options.enable_target_mode       = 1;
#else
            icb->firmware_options.enable_target_mode       = 0;
#endif
            icb->firmware_options.disable_initiator_mode   = 0;
            icb->firmware_options.enable_port_update_event = 1;
            icb->firmware_options.enable_full_login_on_lip = 1;

            /*
            * Set host adapter parameters
            */
            ha->flags.enable_target_mode = icb->firmware_options.enable_target_mode;
            ha->flags.disable_luns            = nv->host_p.disable_luns;
            ha->flags.disable_risc_code_load  = nv->host_p.disable_risc_code_load;
            ha->flags.set_cache_line_size_1   = nv->host_p.set_cache_line_size_1;
            ha->flags.enable_64bit_addressing = nv->host_p.enable_64bit_addressing;
            ha->flags.enable_lip_reset        = nv->host_p.enable_lip_reset;
            ha->flags.enable_lip_full_login   = nv->host_p.enable_lip_full_login;
            ha->flags.enable_target_reset     = nv->host_p.enable_target_reset;
            ha->flags.enable_flash_db_update  = nv->host_p.enable_database_storage;
            ha->operating_mode = icb->additional_firmware_options.connection_options;

            /* 01/18/00 - Execution depth */
            ha->hiwat =  nv->execution_throttle;
            
            ha->retry_count           = nv->retry_count;
            ha->login_timeout         = nv->login_timeout;
            /* Set minimum login_timeout to 4 seconds. */
            if( ha->login_timeout < 4 )
                ha->login_timeout = 4;
            ha->port_down_retry_count = nv->port_down_retry_count;
            ha->minimum_timeout       = (ha->login_timeout * ha->retry_count)
                + ha->port_down_retry_count;
            ha->loop_reset_delay      = nv->reset_delay;
            /* Will get the value from nvram. */
            ha->loop_down_timeout     = LOOP_DOWN_TIMEOUT; 
            ha->loop_down_abort_time  = LOOP_DOWN_TIME - ha->loop_down_timeout;


#if  USE_BIOS_MAX_LUNS
            if( !nv->maximum_luns_per_target )
                ha->max_luns = MAX_LUNS;
            else if( nv->maximum_luns_per_target < MAX_LUNS )
                ha->max_luns = nv->maximum_luns_per_target;
            else
                ha->max_luns = MAX_LUNS;
#else
            ha->max_luns = MAX_LUNS;
#endif

            /*
            * Setup ring parameters in initialization control block
            */
            icb->request_q_outpointer  = 0;
            icb->response_q_inpointer  = 0;
            icb->request_q_length      = REQUEST_ENTRY_CNT;
            icb->response_q_length     = RESPONSE_ENTRY_CNT;
            icb->request_q_address[0]  = (uint32_t) ha->request_dma;
            /* 01/14/00 icb->request_q_address[1]  = 0; */
            icb->request_q_address[1]  = MS_64BITS(ha->request_dma);
            icb->response_q_address[0] = (uint32_t) ha->response_dma;
            /* 01/14/00 icb->response_q_address[1] = 0; */
            icb->response_q_address[1] = MS_64BITS(ha->response_dma);

            icb->lun_enables = 0;
            icb->command_resource_count = 0;
            icb->immediate_notify_resource_count = 0;
            icb->timeout = 0;
            icb->reserved_2 = 0;

            ha->flags.nvram_config_done = 1;
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2200_nvram_config: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2200_nvram_config");
#endif
        return(status);
    }

    /*
    * Get NVRAM data word
    *      Calculates word position in NVRAM and calls request routine to
    *      get the word from NVRAM.
    *
    * Input:
    *      ha      = adapter block pointer.
    *      address = NVRAM word address.
    *
    * Returns:
    *      data word.
    */
    STATIC uint16_t
    qla2100_get_nvram_word(scsi_qla_host_t *ha, uint32_t address) {
        uint32_t nv_cmd;
        uint16_t data;

#ifdef QL_DEBUG_ROUTINES
        uint8_t  saved_print_status = ql_debug_print;
#endif
#ifdef QL_DEBUG_LEVEL_4
        qla2100_print("qla2100_get_nvram_word: entered\n");
#endif

        nv_cmd = address << 16;
        nv_cmd |= NV_READ_OP;

#ifdef QL_DEBUG_ROUTINES
        ql_debug_print = FALSE;
#endif
        data = qla2100_nvram_request(ha, nv_cmd);
#ifdef QL_DEBUG_ROUTINES
        ql_debug_print = saved_print_status;
#endif

#ifdef QL_DEBUG_LEVEL_4
        qla2100_print("qla2100_get_nvram_word: exiting normally NVRAM data = ");
        qla2100_output_number((u_long)data, 16);
        qla2100_print("\n");
#endif
        return(data);
    }

    /*
    * NVRAM request
    *      Sends read command to NVRAM and gets data from NVRAM.
    *
    * Input:
    *      ha     = adapter block pointer.
    *      nv_cmd = Bit 26     = start bit
    *               Bit 25, 24 = opcode
    *               Bit 23-16  = address
    *               Bit 15-0   = write data
    *
    * Returns:
    *      data word.
    */
    STATIC uint16_t
    qla2100_nvram_request(scsi_qla_host_t *ha, uint32_t nv_cmd) {
        uint8_t      cnt;
        device_reg_t *reg = ha->iobase;
        uint16_t     data = 0;
        uint16_t     reg_data;

        /* Send command to NVRAM. */

        nv_cmd <<= 5;
        for( cnt = 0; cnt < 11; cnt++ ) {
            if( nv_cmd & BIT_31 )
                qla2100_nv_write(ha, NV_DATA_OUT);
            else
                qla2100_nv_write(ha, 0);
            nv_cmd <<= 1;
        }

        /* Read data from NVRAM. */

        for( cnt = 0; cnt < 16; cnt++ ) {
            WRT_REG_WORD(&reg->nvram, NV_SELECT+NV_CLOCK);
            /* qla2100_nv_delay(ha); */
            NVRAM_DELAY();
            data <<= 1;
            reg_data = RD_REG_WORD(&reg->nvram);
            if( reg_data & NV_DATA_IN )
                data |= BIT_0;
            WRT_REG_WORD(&reg->nvram, NV_SELECT);
            /* qla2100_nv_delay(ha); */
            NVRAM_DELAY();
        }

        /* Deselect chip. */

        WRT_REG_WORD(&reg->nvram, NV_DESELECT);
        /* qla2100_nv_delay(ha); */
        NVRAM_DELAY();

        return(data);
    }

    STATIC void
        qla2100_nv_write(scsi_qla_host_t *ha, uint16_t data) {
        device_reg_t *reg = ha->iobase;

        WRT_REG_WORD(&reg->nvram, data | NV_SELECT);
        NVRAM_DELAY();
        /* qla2100_nv_delay(ha); */
        WRT_REG_WORD(&reg->nvram, data | NV_SELECT | NV_CLOCK);
        /* qla2100_nv_delay(ha); */
        NVRAM_DELAY();
        WRT_REG_WORD(&reg->nvram, data | NV_SELECT);
        /* qla2100_nv_delay(ha); */
        NVRAM_DELAY();
    }

    STATIC void
        qla2100_nv_delay(void) {
        SYS_DELAY(NV_DELAY_COUNT);
    }

    /*
    * Mailbox Command
    *      Issue mailbox command and waits for completion.
    *
    * Input:
    *      ha = adapter block pointer.
    *      mr = mailbox registers to load.
    *      mb = data pointer for mailbox registers.
    *
    * Output:
    *      mb[MAILBOX_REGISTER_COUNT] = returned mailbox data.
    *
    * Returns:
    *      0 = success
    *      1 = failed    (mbox status != 0x4000)
    */
    STATIC uint8_t
    qla2100_mailbox_command(scsi_qla_host_t *ha, uint8_t mr, uint16_t *mb) {
        device_reg_t *reg   = ha->iobase;
        uint8_t      status = 0;
        uint32_t     cnt;
        uint16_t     *optr, *iptr;
        uint16_t     data;
        srb_t        *done_q_first = 0;
        srb_t        *done_q_last = 0;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        unsigned long cpu_flags = 0;
#endif

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_mailbox_command");
#endif

        /* Acquire interrupt specific lock */
        QLA2100_INTR_LOCK(ha);

        DRIVER_LOCK
            ha->flags.mbox_busy = TRUE;

#ifdef QL_DEBUG_LEVEL_2
        qla2100_print("qla2100_mailbox_command: mbox_out[0] = ");
        qla2100_output_number((u_long)*mb, 16);
        qla2100_print("\n");
#endif
        /* Load mailbox registers. */
        optr = (uint16_t *)&reg->mailbox0;

#ifdef QL_DEBUG_LEVEL_5
        qla2100_print(
            "qla2100_mailbox_command: Load MB registers = ");
        qla2100_output_number((u_long)mr, 16);
        qla2100_print("\n");
        qla2100_dump_buffer((uint8_t *)mb, 16);
        qla2100_print("\n");
        qla2100_print("qla2100_mailbox_command: I/O address = ");
        qla2100_output_number((u_long)optr, 16);
#endif

        iptr = mb;
        for( cnt = 0; cnt < MAILBOX_REGISTER_COUNT; cnt++ ) {
            if( mr & BIT_0 ) {
                WRT_REG_WORD(optr, (*iptr)); 
            }
            mr >>= 1;
            optr++;
            iptr++;
        }
#ifdef QL_DEBUG_LEVEL_5
        qla2100_dump_regs(ha->host);
#endif

        /* Issue set host interrupt command. */
        ha->flags.mbox_int = FALSE;
        WRT_REG_WORD(&reg->host_cmd, HC_SET_HOST_INT);
        data = qla2100_debounce_register(&reg->istatus);
        /* Wait for 30 seconds for command to finish. */
        /* for( cnt = 10000000; cnt > 0 && !ha->flags.mbox_int; cnt-- ) { */
        for( cnt = 100000; cnt > 0 && !ha->flags.mbox_int; cnt-- ) {
            /* Check for pending interrupts. */
            if( (data & RISC_INT) )
                qla2100_isr(ha, (srb_t **)&done_q_first, (srb_t **)&done_q_last);
            SYS_DELAY(3);
            data = RD_REG_WORD(&reg->istatus);
        }

        /* Check for mailbox command timeout. */
        if( !cnt ) {
#ifdef QL_DEBUG_LEVEL_2
            qla2100_print(
                "qla2100_mailbox_command: **** Command Timeout, mailbox0 = ");
            qla2100_output_number((u_long)mb[0], 16);
            qla2100_print(" ****\n");
            qla2100_dump_regs(ha->host);
#endif
            ha->flags.isp_abort_needed = TRUE;
            status = 1;
        } else if( ha->mailbox_out[0] != MBS_CMD_CMP )
            status = 1;

        /* Load return mailbox registers. */
        optr = mb;
        iptr = (uint16_t *)&ha->mailbox_out[0];
        mr = MAILBOX_REGISTER_COUNT;
        while( mr-- )
            *optr++ = *iptr++;

        /* Go check for any response interrupts pending. */
        ha->flags.mbox_busy = FALSE;
        qla2100_isr(ha, (srb_t **)&done_q_first, (srb_t **)&done_q_last);

        /* Release interrupt specific lock */
        QLA2100_INTR_UNLOCK(ha);
        DRIVER_UNLOCK

            if( ha->flags.isp_abort_needed )
            qla2100_abort_isp(ha);

        if( ha->flags.reset_marker )
            qla2100_rst_aen(ha);
        if( ha->flags.update_config_needed )
            qla2100_update_config(ha);
        if( ha->flags.loop_resync_needed )
            qla2100_loop_resync(ha);

        if( done_q_first )
            qla2100_done(ha, (srb_t **)&done_q_first, (srb_t **)&done_q_last);

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status ) {
            qla2100_print("qla2100_mailbox_command: **** FAILED, mailbox0 = ");
            qla2100_output_number((u_long)mb[0], 16);
            qla2100_print(" ****\n");
        }
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_mailbox_command");
#endif
        return(status);
    }

    /*
    * qla2100_poll
    *      Polls ISP for interrupts.
    *
    * Input:
    *      ha = adapter block pointer.
    */
    STATIC void
        qla2100_poll(scsi_qla_host_t *ha) {
        device_reg_t *reg   = ha->iobase;
        uint16_t     data;
        srb_t        *done_q_first = 0;
        srb_t        *done_q_last = 0;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_poll");
#endif

        /* Acquire interrupt specific lock */
        QLA2100_INTR_LOCK(ha);

        /* Check for pending interrupts. */
        data = RD_REG_WORD(&reg->istatus);
        if( data & RISC_INT )
            qla2100_isr(ha, (srb_t **)&done_q_first, (srb_t **)&done_q_last);

        /* Release interrupt specific lock */
        QLA2100_INTR_UNLOCK(ha);

        if( !ha->flags.mbox_busy ) {
            if( ha->flags.isp_abort_needed )
                qla2100_abort_isp(ha);
            if( ha->flags.reset_marker )
                qla2100_rst_aen(ha);
            if( ha->flags.update_config_needed )
                qla2100_update_config(ha);
            if( ha->flags.loop_resync_needed )
                qla2100_loop_resync(ha);
        }

        if( done_q_first )
            qla2100_done(ha, (srb_t **)&done_q_first, (srb_t **)&done_q_last);

#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_poll");
#endif
    }

    /*
    * qla2100_update_device
    *      This routine updates the device data in the database and logs
    *      onto the device if necessary. 
    *
    * Input:
    *      ha = adapter block pointer.
    *      device = device data pointer.
    *
    * Returns:
    *      0 = success, if device found or added to database.
    *      1 = error
    *      2 = database was full and device was not configured.
    */
    STATIC uint8_t
    qla2100_update_device(scsi_qla_host_t *ha, device_data_t *device, uint8_t enable_slot_reuse) {
        uint8_t     status = 0;
        uint8_t     dev_configured;
        uint16_t    cnt, i;
        uint16_t    mb[MAILBOX_REGISTER_COUNT];

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_update_device");
#endif

        dev_configured = FALSE;
        if( ha->device_id == QLA2100_DEVICE_ID ) {
            ha->min_external_loopid = 0;
            ha->max_public_loop_ids = LAST_SNS_LOOP_ID - SNS_FIRST_LOOP_ID + 1;
        } else {
            ha->max_public_loop_ids = LAST_SNS_LOOP_ID + 1;
        }

        DEBUG(printk("qla2100: Adding device portname=%lx%lx, nodename=%lx%lx, port Id=%06lx, loop id=%04x\n",
                device->ms_wwn,device->ls_wwn,
                device->ms_name,device->ls_name,
            device->port_id[0] << 16 | device->port_id[1] <<  8 | device->port_id[2], device->loop_id);)
                                    
        /* Search to see if node name is already in database. If found then change loop ID in database. */
        for( cnt = 0; cnt < MAX_FIBRE_DEVICES &&
            !dev_configured; cnt++ ) {
            /* if nodename/portname in database then replace it */
#if  USE_PORTNAME
            if( device->ls_wwn == ha->fc_db[cnt].name[0] &&
                device->ms_wwn == ha->fc_db[cnt].name[1] ) {
#else
            if( device->ls_name == ha->fc_db[cnt].name[0] &&
                device->ms_name == ha->fc_db[cnt].name[1] ) {
#endif
                /* if loop ID is available then change it */
                if( ha->fc_db[cnt].loop_id == PORT_AVAILABLE ) {
                    /* If device found is on the public loop. */
                    /* then find the next available fabric loop ID */
                    if( device->loop_id == 0xffff ) {
                        status = 1;
                        /* fabric ports */
                        DEBUG(printk("qla2100_update_device: Get next public loop ID: %d - %d (max)\n",
                            ha->min_external_loopid, ha->max_public_loop_ids);)
                        /* Search the public database for first available slot.  */
                        for( i = ha->min_external_loopid; i < ha->max_public_loop_ids; i++ ) {
                            if( !ha->fabricid[i].in_use ) {
                                ha->fabricid[i].in_use = TRUE;
                                if( ha->device_id == QLA2100_DEVICE_ID )
                                    device->loop_id = SNS_FIRST_LOOP_ID + i;
                                else
                                    device->loop_id = i;
                                ha->fc_db[cnt].loop_id = device->loop_id;
                                ha->fc_db[cnt].port_id[0] = device->port_id[0];
                                ha->fc_db[cnt].port_id[1] = device->port_id[1];
                                ha->fc_db[cnt].port_id[2] = device->port_id[2];
                                ha->fc_db[cnt].flag |= DEV_PUBLIC;
                                status = 0;
                                break;
                            }
                        }
                    } else {  /* change the local loop ID in database */
                        ha->fc_db[cnt].loop_id = device->loop_id;
                    }
                } else /* loop id has been previously used */
                {
                    DEBUG(printk("Loop ID used. \n");)
                    /* If device is on public loop. */
                    if( device->loop_id == 0xffff ) {
                        /* It was previously public, so use previously assigned loop id. */
                        if( ha->fc_db[cnt].flag & DEV_PUBLIC )
                            if( ha->device_id == QLA2100_DEVICE_ID )  
                                device->loop_id = ha->fc_db[cnt].loop_id;
                            else { 
                                  /* if the same topology and public loop */
                                  /* search for the next avaiable public loop ID */
                                    if( ha->prev_topology == ha->current_topology ) {
                                        if( (ha->min_external_loopid) && 
                                            (ha->fc_db[cnt].loop_id < ha->min_external_loopid) ) {
                                            status = 1;
                                            for( i = ha->min_external_loopid; i < ha->max_public_loop_ids; i++ )
                                                if( !ha->fabricid[i].in_use ) {
                                                    ha->fabricid[i].in_use = TRUE;
                                                    device->loop_id = i;
                                                    ha->fc_db[cnt].loop_id = device->loop_id;
                                                    status = 0;
                                                    break;
                                                }
                                        } else
                                            device->loop_id = ha->fc_db[cnt].loop_id;
                                    } else {
                                        status = 1;
                                        for( i = ha->min_external_loopid; i < ha->max_public_loop_ids; i++ )
                                            if( !ha->fabricid[i].in_use ) {
                                                ha->fabricid[i].in_use = TRUE;
                                                device->loop_id = i;
                                                ha->fc_db[cnt].loop_id = device->loop_id;
                                                status = 0;
                                                break;
                                            }
                                    }
                                
                            } else {
                                /* If it moved from private to public loop, assign new public loop id. */
                                status = 1;
                                for( i = ha->min_external_loopid; i < ha->max_public_loop_ids; i++ )
                                    if( !ha->fabricid[i].in_use ) {
                                        ha->fabricid[i].in_use = TRUE;
                                        if( ha->device_id == QLA2100_DEVICE_ID )  

                                            device->loop_id = SNS_FIRST_LOOP_ID + i;
                                        else
                                            device->loop_id = i;
                                        ha->fc_db[cnt].loop_id = device->loop_id;
                                        ha->fc_db[cnt].flag |= DEV_PUBLIC;
                                        ha->fc_db[cnt].port_id[0] = device->port_id[0];
                                        ha->fc_db[cnt].port_id[1] = device->port_id[1];
                                        ha->fc_db[cnt].port_id[2] = device->port_id[2];
                                        status = 0;
                                        break;
                                    }
                            }
                    } else {
                        /* The found device is on private loop but was
                        previously on public loop, so free public loop id. */
                        if( ha->fc_db[cnt].flag & DEV_PUBLIC ) {
                            ha->fc_db[cnt].flag &= ~DEV_PUBLIC;
                            i = ha->fc_db[cnt].loop_id - SNS_FIRST_LOOP_ID;
                            ha->fabricid[i].in_use = 0;
                        }
                        ha->fc_db[cnt].loop_id = device->loop_id;
                    }
                }

                if( !status && (ha->fc_db[cnt].flag) & DEV_PUBLIC ) {
                    /* If public loop device, compare port id to see if 
                    device moves to another FL port. */
                    if( ha->fc_db[cnt].port_id[0] != device->port_id[0] ||
                        ha->fc_db[cnt].port_id[1] != device->port_id[1] ||
                        ha->fc_db[cnt].port_id[2] != device->port_id[2] ) {
                        if( ha->prev_topology == ha->current_topology ) {
                            /* Port id changed, log device out then log back
                            in with new port id but same loop id. */
                            mb[0] = MBC_LOGOUT_FABRIC_PORT;
                            mb[1] = ha->fc_db[cnt].loop_id << 8;
                            qla2100_mailbox_command(ha, BIT_1|BIT_0, &mb[0]);
                            ha->fc_db[cnt].port_id[0] = device->port_id[0];
                            ha->fc_db[cnt].port_id[1] = device->port_id[1];
                            ha->fc_db[cnt].port_id[2] = device->port_id[2];
                        }
                    }
                    mb[0] = 0x4008;
                    while( !status && mb[0] == 0x4008 ) {
                        mb[0] = MBC_LOGIN_FABRIC_PORT;
                        mb[1] = device->loop_id << 8 | 0x01;
                        mb[2] = device->port_id[0];
                        mb[3] = device->port_id[1] << 8 | device->port_id[2];
                        qla2100_mailbox_command(ha, BIT_3|BIT_2|BIT_1|BIT_0,
                            &mb[0]);
                        /* Command parameter error or all IDS used */
                        if( mb[0] == 0x4006 || mb[0] == 0x4009 )
                            status = 1;
                        if( mb[0] == 0x4008 ) {
                            if( device->loop_id++ <= LAST_SNS_LOOP_ID )
                                ha->fabricid[device->loop_id].in_use = TRUE;
                            else
                                status = 1;
                        }
                    }
#if 0
                        /* Command error */
                        if( !status && mb[0] != 0x4005 ) {
                        /* Issue Abort target command to cause RISC to
                        flush all commands outstanding for this device.
                        Commands will be returned with "Aborted" status. */
                        mb[0] = MBC_ABORT_TARGET;
                        mb[1] = device->loop_id << 8;
                        mb[2] = 1;
                        status = qla2100_mailbox_command(ha, BIT_2|BIT_1|BIT_0, &mb[0]);
                    }
#endif
                }
                dev_configured = TRUE;
            }
        }

        /* Device not found in the database. */
        if( !dev_configured ) {
            /* If device is on public loop. */
            if( device->loop_id == 0xffff ) {
                status = 1;

                for( i = ha->min_external_loopid; i < ha->max_public_loop_ids; i++ ) {
                    if( !ha->fabricid[i].in_use ) {    
                        ha->fabricid[i].in_use = TRUE;
                        if( ha->device_id == QLA2100_DEVICE_ID )  
                            device->loop_id = SNS_FIRST_LOOP_ID + i;
                        else
                            device->loop_id = i;
                        status = 0;
                        break;
                    }
                }
                /* Loop ID used */
                mb[0] = 0x4008;
                /* loop ID used */
                while( !status && mb[0] == 0x4008 ) {
                    mb[0] = MBC_LOGIN_FABRIC_PORT;
                    mb[1] = device->loop_id << 8 | 0x01;
                    mb[2] = device->port_id[0];
                    mb[3] = device->port_id[1] << 8 | device->port_id[2];
                    qla2100_mailbox_command(ha, BIT_3|BIT_2|BIT_1|BIT_0,
                        &mb[0]);
                    if( mb[0] == 0x4006 || mb[0] == 0x4009 )
                        status = 1;
                    if( mb[0] == 0x4008 ) {
                        if( device->loop_id++ <= LAST_SNS_LOOP_ID )
                            ha->fabricid[device->loop_id-SNS_FIRST_LOOP_ID].in_use = TRUE;
                        else
                            status = 1;
                    }
                }
            }

            if( !status ) {
                if( ha->device_id == QLA2100_DEVICE_ID )  
                    ha->min_external_loopid = SNS_FIRST_LOOP_ID;
                /* Find a empty slot and add device into database. */
                for( i = 0; i < MAX_FIBRE_DEVICES; i++ )
                    if( ha->fc_db[i].loop_id == PORT_UNUSED ) {
#if  USE_PORTNAME
                        ha->fc_db[i].name[0] = device->ls_wwn;
                        ha->fc_db[i].name[1] = device->ms_wwn;
#else
                        ha->fc_db[i].name[0] = device->ls_name;
                        ha->fc_db[i].name[1] = device->ms_name;
#endif
                        ha->fc_db[i].loop_id = device->loop_id;
                        if( device->loop_id >= ha->min_external_loopid ) {
                            ha->fc_db[i].flag |= DEV_PUBLIC;
                            ha->fc_db[i].port_id[0] = device->port_id[0];
                            ha->fc_db[i].port_id[1] = device->port_id[1];
                            ha->fc_db[i].port_id[2] = device->port_id[2];
                        }
                        ha->flags.updated_fc_db = TRUE;
                        dev_configured = TRUE;
                        break;
                    }
                if( !dev_configured ) {
                    if( enable_slot_reuse ) {
                      for( i = 0; i < MAX_FIBRE_DEVICES; i++ )
                         if( ha->fc_db[i].loop_id == PORT_AVAILABLE ) {
#if  USE_PORTNAME
                              ha->fc_db[i].name[0] = device->ls_wwn;
                              ha->fc_db[i].name[1] = device->ms_wwn;
#else
                              ha->fc_db[i].name[0] = device->ls_name;
                              ha->fc_db[i].name[1] = device->ms_name;
#endif
                              ha->fc_db[i].loop_id = device->loop_id;
                              if( device->loop_id >= ha->min_external_loopid ) {
                                 ha->fc_db[i].flag |= DEV_PUBLIC;
                                 ha->fc_db[i].port_id[0] = device->port_id[0];
                                 ha->fc_db[i].port_id[1] = device->port_id[1];
                                 ha->fc_db[i].port_id[2] = device->port_id[2];
                               }
                               ha->flags.updated_fc_db = TRUE;
                               break;
                          }
                   } else {
                       ha->fabricid[device->loop_id].in_use = FALSE;
                       status = 2;
                     }

                 }
            }   
        }
#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_update_device: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_update_device");
#endif
        return(status);
    }

    /*
    * qla2100_sns_device
    *      Setup Simple Name Server devices with loop ID's.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success.
    *      1 = error
    *      2 = database was full and device was not configured.
    */
    STATIC uint8_t
    qla2100_sns_device(scsi_qla_host_t *ha, uint8_t enable_slot_reuse) {
        uint8_t     status = 1;
        uint8_t     first_port_id[3];
        uint8_t     next_port_id[3];
        uint8_t     host_port_id[3];
        sns_data_t  *sns;
        u_long      phys_address;
        uint16_t    mb[MAILBOX_REGISTER_COUNT];
        uint8_t     use_gan = 1;
        uint8_t     retry_count = 0;
        gp_idnn_t   *gp_idnn;
        uint16_t    i;
        device_data_t device;
        uint8_t     db_full = 0;
        uint16_t    public_count;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_sns_device");
#endif

        /* If FL port exists, then SNS is present */
        DEBUG(printk("qla2100_sns_device: Checking for Fabric.\n");)
        mb[0] = MBC_GET_PORT_NAME;
        mb[1] = SNS_FL_PORT << 8;  /* port name */
        if( !qla2100_mailbox_command(ha, BIT_1|BIT_0, &mb[0]) ) {
            host_port_id[0] = ha->port_id[0];
            host_port_id[1] = ha->port_id[1];
            host_port_id[2] = ha->port_id[2];

            /* calculate the number of public ports */
            if( ha->device_id == QLA2100_DEVICE_ID )  
                public_count = ha->max_public_loop_ids;
            else
                public_count = ha->max_public_loop_ids - ha->min_external_loopid;

            /* Find out if this is a Brocade switch, if so do GP_IDNN. */
            /* otherwise use the GAN                                   */
            mb[0] = MBC_GET_PORT_NAME;
            mb[1] = SNS_FL_PORT << 8 | BIT_0;   /* node name */
            qla2100_mailbox_command(ha, BIT_1|BIT_0, &mb[0]);
            if( mb[2] == 0x0010 && mb[3] == 0x6000 && 
                (mb[6] & 0x00FF) == 0x0069 ) {
                if( (gp_idnn = qla2100_alloc_phys(GP_IDNN_LENGTH, &phys_address)) != NULL ) {  
                    /* Retry GP_IDNN until get valid list or retries done */
                    while( retry_count++ < 10 ) {
                        /* 
                        * Issue GP_IDNN to get list of port IDs and
                        * node names from name server. 
                        */
                        gp_idnn->req.buffer_length = GP_IDNN_LENGTH / 2;
                        gp_idnn->req.buffer_address[0] = phys_address;
                        gp_idnn->req.buffer_address[1] = 0;
                        gp_idnn->req.subcommand_length = 6;
                        gp_idnn->req.subcommand = 0x173;
                        gp_idnn->req.length = GP_IDNN_LENGTH / 4;
                        gp_idnn->req.protocol = 0x08;
                        mb[0] = MBC_SEND_SNS_COMMAND;
                        mb[1] = 14;
                        mb[3] = LSW(phys_address);
                        mb[2] = MSW(phys_address);
                        mb[7] = QL21_64BITS_3RDWD(phys_address);
                        mb[6] = QL21_64BITS_4THWD(phys_address);
                        if( !qla2100_mailbox_command(ha,
                            BIT_7|BIT_6|BIT_3|BIT_2|BIT_1|BIT_0,
                            &mb[0]) ) {
                            if( gp_idnn->rsp.response == SNS_ACCEPT ) {
                                DEBUG(printk("Sns: nodename list from Fabric:\n");)
                                /* Go down device list and add devices to database. */
                                for( i = 0; i < public_count; i++ ) {
                                    /* if not host port id then add it to the database */
                                    if( gp_idnn->rsp.port_data[i].port_id[0] != host_port_id[0] ||
                                        gp_idnn->rsp.port_data[i].port_id[1] != host_port_id[1] ||
                                        gp_idnn->rsp.port_data[i].port_id[2] != host_port_id[2] ) {
                                        device.ms_name = gp_idnn->rsp.port_data[i].nodename[0] << 24
                                            | gp_idnn->rsp.port_data[i].nodename[1] << 16
                                            | gp_idnn->rsp.port_data[i].nodename[2] << 8
                                            | gp_idnn->rsp.port_data[i].nodename[3];
                                        device.ls_name = gp_idnn->rsp.port_data[i].nodename[4] << 24
                                            | gp_idnn->rsp.port_data[i].nodename[5] << 16
                                            | gp_idnn->rsp.port_data[i].nodename[6] << 8
                                            | gp_idnn->rsp.port_data[i].nodename[7];
                                        /* get loop id */
                                        device.port_id[0] = gp_idnn->rsp.port_data[i].port_id[0];
                                        device.port_id[1] = gp_idnn->rsp.port_data[i].port_id[1];
                                        device.port_id[2] = gp_idnn->rsp.port_data[i].port_id[2];
#if USE_PORTNAME
                                        /* Get portname */
                                        if( qla2100_sns_get_name(ha, &device, 0) )
                                                break;
#endif
                                        device.loop_id = 0xffff;
                                        /* Update device database and login to device. */
                                        if( (status = qla2100_update_device(ha, &device, enable_slot_reuse)) ) {
                                            if( status == 2 )
                                                db_full = 1;
                                            else
                                                break;
                                        }
                                    }
                                    if( gp_idnn->rsp.port_data[i].controlbyte == 0x80 )
                                        break;
                                }
                                use_gan = 0;
                                break;
                            }
                        }
                        /* Wait for 100ms before retrying */
                        for( i = 0; i <= 10000; i++ ) {
                            SYS_DELAY(10);
                        }
                    }
                    KMFREE(gp_idnn, GP_IDNN_LENGTH);
                } else {
                    use_gan = 0;
#ifdef QL_DEBUG_LEVEL_2
                    qla2100_print(
                        "qla2100_sns_device: Failed to allocate memory, No FL Port\n");
#endif
                }
            }
            /* use the GAN (GA_NXT) Name server request to discover the ports */
            if( use_gan ) {
                /* Find all registered ports in the Fabric */
                if( (sns = qla2100_alloc_phys(sizeof(sns_data_t), &phys_address)) != NULL ) {
                    status = 0;
                    /* start with port ID = 0 */
                    first_port_id[0] = first_port_id[1] = first_port_id[2] = 0;
                    next_port_id[0] = next_port_id[1] = next_port_id[2] = 0;
                    mb[0] = 0;
                    for( i = 0; i < public_count && !ha->loop_down_timer &&
                        !ha->flags.loop_resync_needed; i++ ) {
                        /* GAN Get all next entries for the selected port ID from SNS. */
                        BZERO((caddr_t)sns, sizeof(sns_data_t));
                        sns->p.req.hdr.buffer_length = 304;
                        sns->p.req.hdr.buffer_address[0] = phys_address;
                        sns->p.req.hdr.buffer_address[1] = 0;
                        sns->p.req.hdr.subcommand_length = 6;
                        sns->p.req.subcommand = 0x100;
                        sns->p.req.param[6] = next_port_id[2];
                        sns->p.req.param[7] = next_port_id[1];
                        sns->p.req.param[8] = next_port_id[0];

                        mb[0] = MBC_SEND_SNS_COMMAND;
                        mb[1] = 14;
                        mb[3] = (uint16_t)phys_address;
                        mb[2] = (uint16_t)(phys_address >> 16);
                        mb[7] = QL21_64BITS_3RDWD(phys_address);
                        mb[6] = QL21_64BITS_4THWD(phys_address);
                        if( !qla2100_mailbox_command(ha,
                            BIT_7|BIT_6|BIT_3|BIT_2|BIT_1|BIT_0,
                            &mb[0]) ) {
                            /* save next port ID */
                            next_port_id[0] = sns->p.rsp[17];
                            next_port_id[1] = sns->p.rsp[18];
                            next_port_id[2] = sns->p.rsp[19];
                            
                        } else {
#ifdef QL_DEBUG_LEVEL_2
                            qla2100_print(
                                "qla2100_sns_device: MBC_SEND_SNS_COMMAND Failed, No FL Port\n");
#endif
                            status = 1;
                            break;
                        }

                        /* Assign loop ID for device on SNS. */
                        if( (next_port_id[0] != first_port_id[0] ||
                            next_port_id[1] != first_port_id[1] ||
                            next_port_id[2] != first_port_id[2])
                            &&  (sns->p.rsp[284] || sns->p.rsp[285] ||
                            sns->p.rsp[286] || sns->p.rsp[287] ||
                            sns->p.rsp[288] || sns->p.rsp[289] ||
                            sns->p.rsp[290] || sns->p.rsp[291]) ) {
                            if( next_port_id[0] != host_port_id[0] ||
                                next_port_id[1] != host_port_id[1] ||
                                next_port_id[2] != host_port_id[2] ) {
#if USE_PORTNAME
                                /* Extract portname */
                                device.ms_wwn = sns->p.rsp[20] << 24
                                    | sns->p.rsp[21] << 16
                                    | sns->p.rsp[22] << 8
                                    | sns->p.rsp[23];
                                device.ls_wwn = sns->p.rsp[24] << 24
                                    | sns->p.rsp[25] << 16
                                    | sns->p.rsp[26] << 8
                                    | sns->p.rsp[27];
#endif
                                /* Extract nodename */
                                device.ms_name = sns->p.rsp[284] << 24
                                    | sns->p.rsp[285] << 16
                                    | sns->p.rsp[286] << 8
                                    | sns->p.rsp[287];
                                device.ls_name = sns->p.rsp[288] << 24
                                    | sns->p.rsp[289] << 16
                                    | sns->p.rsp[290] << 8
                                    | sns->p.rsp[291];
                                /* extract port ID */
                                device.port_id[0] = next_port_id[0];
                                device.port_id[1] = next_port_id[1];
                                device.port_id[2] = next_port_id[2];
                                device.loop_id = 0xffff;
                                
                                /* Update device database and login device in */
                                if( (status = qla2100_update_device(ha, &device, enable_slot_reuse)) ) {
                                    if( status == 2 )
                                        db_full = 1;
                                    else
                                        break;
                                }
                            }

                            /*
                            * Save first port if not repeating port
                            * on another Loop ID.
                            */
                            if( !(first_port_id[0] || first_port_id[1] ||
                                first_port_id[2]) ) {
                                first_port_id[0] = next_port_id[0];
                                first_port_id[1] = next_port_id[1];
                                first_port_id[2] = next_port_id[2];
                            }
                        } else
                            break;
                    }
                    KMFREE(sns, sizeof(sns_data_t));
                }
#ifdef QL_DEBUG_LEVEL_2
                else
                    qla2100_print(
                        "qla2100_sns_device: Failed to allocate memory, No FL Port\n");
#endif
            }
        } else
#ifdef QL_DEBUG_LEVEL_2
            qla2100_print(
                "qla2100_sns_device: MBC_GET_PORT_NAME Failed, No FL Port\n");
#else
        DEBUG(printk("No Fabric found.\n");)
#endif

        if( db_full )
            status = 2;

        /* Update iff F/FL found and update O.K. */
        if( !status )
            ha->prev_topology = ha->current_topology;

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_sns_device: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_sns_device");
#endif
        return(status);
    }
    
#if USE_PORTNAME
    /*
    * qla2100_sns_get_name
    *      This routine is called tot do the SNS Get Port/Name command
    *      of the specified port.
    *
    * Input:
    *      ha = adapter block pointer.
    *      flag = 0 - port name , 1 - node name
    *
    * Output:
    *      
    */
    STATIC uint8_t qla2100_sns_get_name( scsi_qla_host_t *ha, device_data_t *device, uint8_t flag )
    {
    	uint8_t     lStatus = 0;
    	uint16_t    wRetryCount;
    	u_long      phys_address;
    	uint16_t    mb[MAILBOX_REGISTER_COUNT];
    	uint16_t    subCmd, response;
       sns_data_t  *sns;
    
    /* Set retry count */
   if ( flag )
    	subCmd = 0x113;
   else
    	subCmd = 0x112;
   DEBUG(printk("qla2100_SnsGetName: Get %x name for port Id %06lx\n", subCmd,
            device->port_id[0] << 16 | device->port_id[1] <<  8 | device->port_id[2]);)
   
    wRetryCount = 2;
    while (wRetryCount--)
    {
        /* Do 'Get Port/Node name' mailbox command for the FL attached device */
        if( (sns = qla2100_alloc_phys(sizeof(sns_data_t), &phys_address)) != NULL ) {
             BZERO((caddr_t)sns, sizeof(sns_data_t));
             sns->p.req.hdr.buffer_length = 12;
             sns->p.req.hdr.buffer_address[0] = phys_address;
             sns->p.req.hdr.buffer_address[1] = 0;
             sns->p.req.hdr.subcommand_length = 6;
             sns->p.req.subcommand = subCmd;
             sns->p.req.param[6] = device->port_id[2];
             sns->p.req.param[7] = device->port_id[1];
             sns->p.req.param[8] = device->port_id[0];
             sns->p.req.param[9] = 0;

             mb[0] = MBC_SEND_SNS_COMMAND;
             mb[1] = 14;
             mb[3] = LSW(phys_address);
             mb[2] = MSW(phys_address);
             mb[7] = QL21_64BITS_3RDWD(phys_address);
             mb[6] = QL21_64BITS_4THWD(phys_address);
             if( !qla2100_mailbox_command(ha,
                     BIT_7|BIT_6|BIT_3|BIT_2|BIT_1|BIT_0,
                       &mb[0]) ) {
       
                   response = sns->p.rsp[8] | (sns->p.rsp[9] << 8);
                   if( response == SNS_ACCEPT ) {
                        if ( flag ) 
                        {
                        device->ms_name = sns->p.rsp[16] << 24
      		                       | sns->p.rsp[17] << 16
                                   | sns->p.rsp[18] << 8
                                    | sns->p.rsp[19];
                                device->ls_name = sns->p.rsp[20] << 24
                                    | sns->p.rsp[21] << 16
                                    | sns->p.rsp[22] << 8
                                    | sns->p.rsp[23];
                        }
                        else 
                        {
                        device->ms_wwn = sns->p.rsp[16] << 24
      		                       | sns->p.rsp[17] << 16
                                   | sns->p.rsp[18] << 8
                                    | sns->p.rsp[19];
                                device->ls_wwn = sns->p.rsp[20] << 24
                                    | sns->p.rsp[21] << 16
                                    | sns->p.rsp[22] << 8
                                    | sns->p.rsp[23];
   
                        }
                            }
                            else
                            {
                                printk("qla2100_SnsGetName: Get Name mb cmd response is not accept - status %x\n", mb[0]);
                            }
                        }
                        else if (mb[0] == MBS_FATAL_ERROR)
                        {
                            printk("qla2100_SnsGetName: Get Name mb cmd fatal error - status %x\n", mb[0]);
                            lStatus = 1;
                            break;
                        }
        		 else
        		 {
            		 	printk("qla2100_SnsGetName: Get Name mb cmd failed - status %x\n", mb[0]);
        		 }

        }
        KMFREE(sns, sizeof(sns_data_t));
    }
    return(lStatus);

    }
#endif
    
    /*
    * qla2100_init_fc_db
    *      Initializes Fibre Channel Device Database.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Output:
    *      ha->fc_db = initialized
    */
    STATIC void
        qla2100_init_fc_db(scsi_qla_host_t *ha) {
        uint16_t cnt;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_init_fc_db");
#endif

        /* Initialize fc database if it is not initialized. */
        if( !ha->fc_db[0].loop_id && !ha->fc_db[1].loop_id ) {
            ha->flags.updated_fc_db = FALSE;

            /* Initialize target database. */
            for( cnt = 0; cnt < MAX_FIBRE_DEVICES; cnt++ ) {
                ha->fc_db[cnt].name[0] = 0L;
                ha->fc_db[cnt].name[1] = 0L;
                ha->fc_db[cnt].loop_id = PORT_UNUSED;
            }

            /* Move flash database to driver database. */
            qla2100_get_database(ha);
        }

#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_init_fc_db");
#endif
    }

    /*
    * qla2100_update_fc_db
    *      Updates Fibre Channel Device Database with what is actually on loop.
    *
    * Input:
    *      ha                = adapter block pointer.
    *      enable_slot_reuse = allows the use of PORT_AVAILABLE slots.
    *
    * Output:
    *      ha->fc_db = updated
    *
    * Returns:
    *      0 = success.
    *      1 = error.
    *      2 = database was full and device was not configured.
    */
    STATIC uint8_t
    qla2100_update_fc_db(scsi_qla_host_t *ha, uint8_t enable_slot_reuse) {
        uint8_t  status = 0;
        uint8_t  db_full = 0;
        uint16_t cnt, localdevices = 0;
        uint16_t mb[MAILBOX_REGISTER_COUNT];
        port_list_entry_t *gn_list, *port_entry;
        device_data_t device;
        u_long   phys_address;
        uint16_t i, size;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_update_fc_db");
#endif


        if( !qla2100_configure_hba(ha) ) {
            if( ha->device_id == QLA2100_DEVICE_ID ) {
                ha->max_public_loop_ids = LAST_SNS_LOOP_ID - SNS_FIRST_LOOP_ID + 1;
            } else {
                ha->max_public_loop_ids = LAST_SNS_LOOP_ID + 1;
                /* dg 09/15 */
                /* if the topology have change then make all devices available */
                if( ha->prev_topology != ha->current_topology ) {
                    /* Mark all fabric devices that where present as AVAILABLE */
                    for( i = 0; i < ha->max_public_loop_ids; i++ )
                        if( (i != SNS_FL_PORT) && (i != FABRIC_CONTROLLER)
                            && (i != SIMPLE_NAME_SERVER) ) 
                            ha->fabricid[i].in_use = FALSE;

                        /* Mark all local devices that where present as AVAILABLE */
                        if( ha->current_topology == ISP_CFG_F )
                            for( cnt = 0; cnt < MAX_FIBRE_DEVICES && !ha->loop_down_timer
                                && !ha->flags.loop_resync_needed; cnt++ )
                                if( ha->fc_db[cnt].loop_id < SNS_FIRST_LOOP_ID ) {
                                    ha->fc_db[cnt].loop_id = PORT_AVAILABLE;
                                    ha->fc_db[cnt].flag &= ~DEV_PUBLIC;
                                }
                }
            }
            /* Get the list of devices on the loop */
            if( (gn_list = qla2100_alloc_phys(GN_LIST_LENGTH, &phys_address)) != NULL ) {  

                if( !ha->loop_down_timer && !ha->flags.loop_resync_needed ) {
                    /* Get port list.*/
                    mb[0] = MBC_GET_PORT_LIST;
                    mb[1] = BIT_0;
                    mb[3] = (uint16_t)phys_address;
                    mb[2] = (uint16_t)(phys_address >> 16);
                    mb[7] = QL21_64BITS_3RDWD(phys_address);
                    mb[6] = QL21_64BITS_4THWD(phys_address);
                    if( !qla2100_mailbox_command(ha, BIT_7|BIT_6|BIT_3|BIT_2|BIT_1|BIT_0, &mb[0]) ) {
                        if ( mb[0] == MBS_COMMAND_COMPLETE ) 
                        {
                            port_entry = gn_list;
                            size = mb[1];
                            /* dg 10/29/99 - check for empty list */
                            if ( size/sizeof(port_list_entry_t) == 0 ) {
                               /* Local devices were present, but may not be reponding, 
                                  so retry them later */ 
                                 DEBUG2(qla2100_print("qla2100_update_fc_db: Empty port list\n");)
                            }
                            else 
                            /* Search through list adding the devices to the database */
                            for( ; size >= sizeof(port_list_entry_t);
                                size -= sizeof(port_list_entry_t), port_entry++ ) {
                                /* Skip the known ports. */
                                if( (port_entry->loop_id == SNS_FL_PORT) ||
                                    (port_entry->loop_id == FABRIC_CONTROLLER) ||
                                    (port_entry->loop_id == SIMPLE_NAME_SERVER) )
                                    continue;

                                /* if we are on a public loop then logout the device. */
                                if( ((ha->current_topology == ISP_CFG_FL)
                                    || (ha->current_topology == ISP_CFG_F))
                                    && (port_entry->loop_id >= ha->min_external_loopid) ) {
                                    mb[0] = MBC_LOGOUT_FABRIC_PORT;
                                    mb[1] = port_entry->loop_id << 8;
                                    qla2100_mailbox_command(ha, BIT_1|BIT_0, &mb[0]);
                                } else {
                                    /* We are on a local loop             */
                                    /* update the database with the loop  */
                                    /* ID and login to the device.        */
                                    device.loop_id = port_entry->loop_id;
#if USE_PORTNAME
                                     /* Get port name */
                                     mb[0] = MBC_GET_PORT_NAME;
                                     /* mb[1] = device.loop_id << 8 | BIT_0; */
                                     mb[1] = device.loop_id << 8;
                                     if( !qla2100_mailbox_command(ha, BIT_1|BIT_0, &mb[0]) ) {
                                         /* dg 09/15/99  */
                                        if ( mb[0] == MBS_COMMAND_COMPLETE ) {
                                            device.ms_wwn = mb[2] << 16
                                                | mb[3];
                                            device.ls_wwn = mb[6] << 16
                                                | mb[7];
                                        }
                                        else {
                                           status = 1;
                                            printk("qla2100_update_fc_db: GET PORT NAME - bad status.\n");
                                           goto qla2100_update_fc_db_exit;
                                        }
                                         
                                     }
				     else
                                     {   /* dg 10/29/99 */
                                        if ( mb[0] == MBS_FATAL_ERROR  ) {
                                           status = 1;
                                           goto qla2100_update_fc_db_exit;
                                        }
                                        continue;
                                     }
#endif
                                     device.ls_name = *(uint32_t *)&(port_entry->name[0]);
                                     device.ms_name = *(uint32_t *)&(port_entry->name[4]);
                                     
                                     if( (status = qla2100_update_device(ha, &device, enable_slot_reuse)) ) {
                                      /* if not configured or full */
                                        if( status == 2 )
                                            db_full = 1;
                                        else
                                            break;
                                    }
                                    else
                                        localdevices++;
                                }
                            }  /* end of For */
                        }
                    }
                }
                KMFREE(gn_list, GN_LIST_LENGTH);
                /* if local loop port */
                if( (ha->current_topology == ISP_CFG_N) ||
                    (ha->current_topology == ISP_CFG_NL) )
                    ha->prev_topology = ha->current_topology;
                else {
                    /* get public loop devices */
                    if( !ha->loop_down_timer && !ha->flags.loop_resync_needed )
                        if( (qla2100_sns_device(ha, enable_slot_reuse)) == 2 )
                            db_full = 1;
                }

                /* Set local loop devices present flag, clear retry flag */
                if (localdevices > 0 ) {
                    ha->device_flags |= DFLG_LOCAL_DEVICES;
                    ha->device_flags &= ~DFLG_RETRY_LOCAL_DEVICES;
                }
                
                /* Mark devices that are not present as PORT_AVAILABLE */
                for( cnt = 0; cnt < MAX_FIBRE_DEVICES && !ha->loop_down_timer 
                    && !ha->flags.loop_resync_needed; cnt++ ) 
                    /* if this slot is used (i.e. loop ID 0 - 0xfe) */
                    if( ha->fc_db[cnt].loop_id <= LAST_SNS_LOOP_ID ) {
                        /* Get port name */
                        mb[0] = MBC_GET_PORT_NAME;
                        mb[1] = ha->fc_db[cnt].loop_id << 8 | BIT_0;
                        if( qla2100_mailbox_command(ha, BIT_1|BIT_0, &mb[0]) ) {
                            /* free local or public port */ 
                        
                            /* if a fabric port free it */
                            if( ((ha->current_topology == ISP_CFG_FL) ||
                                (ha->current_topology == ISP_CFG_F)) &&
                                (ha->fc_db[cnt].loop_id >= ha->min_external_loopid)
                                && (ha->prev_topology == ha->current_topology) ) {
                                /* Free public loop id */
                                i = ha->fc_db[cnt].loop_id;
                                ha->fabricid[i].in_use = 0;
                            }
                            ha->fc_db[cnt].loop_id = PORT_AVAILABLE;
                            ha->fc_db[cnt].flag &= ~DEV_PUBLIC;
                        }
                    }
            } else {
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print(
                    "qla2100_update_fc_db: Failed to allocate memory, No local loop\n");
#endif
                status = 1;
            }
            /* Map the devices to target IDs */
            if( !ha->loop_down_timer && !ha->flags.loop_resync_needed )
                qla2100_map_targets(ha);
        } else
            status = 1;

        if( db_full )
            status = 2;

qla2100_update_fc_db_exit:

        if( status == 0 )
            ha->loop_state = LOOP_READY;

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_update_fc_db: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_update_fc_db");
#endif
        return(status);
    }

    /*
    * qla2100_init_tgt_map
    *      Initializes target map.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Output:
    *      TGT_Q initialized
    */
    STATIC void
        qla2100_init_tgt_map(scsi_qla_host_t *ha) {
        uint32_t b, t;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_init_tgt_map");
#endif

        for( b = 0; b < MAX_BUSES; b++ )
            for( t = 0; t < MAX_FIBRE_DEVICES; t++ )
                TGT_Q(ha, b, t) = (tgt_t *) NULL;

#ifdef QL_DEBUG_LEVEL_3
            LEAVE("qla2100_init_tgt_map");
#endif
    }

    /*
    * qla2100_map_targets
    *      Setup target queues.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success.
    */
    STATIC uint8_t
    qla2100_map_targets(scsi_qla_host_t *ha) {
        tgt_t    *tgt;
        uint32_t b;
        uint32_t t;
        uint8_t  status = 0;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_map_targets");
#endif

        b = 0;
        for( t = 0; t < MAX_FIBRE_DEVICES; t++ ) {
            /* if Port never been used. OR */
            /*  Device does not exist on port. */
            if( ha->fc_db[t].loop_id != PORT_UNUSED  &&
                ha->fc_db[t].loop_id != PORT_AVAILABLE ) {  /* dg 10/29/99 */

                if( (tgt = TGT_Q(ha, b, t)) != NULL ) {
                    DEBUG2(qla2100_print("Target/Lun already allocated\n"));
                    /* qla2100_tgt_dealloc(ha, tgt); */
                } else
                    tgt = qla2100_tgt_alloc(ha);
                DEBUG2(sprintf(debug_buff,"Assigned ID %02x:%02x:00 @ (%p) to loop id: %d\n",b,t,tgt,ha->fc_db[t].loop_id);)
                DEBUG2(qla2100_print(debug_buff));
                TGT_Q(ha, b, t) = tgt;
                tgt->loop_id = ha->fc_db[t].loop_id;
            }
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_map_targets: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_map_targets");
#endif
        return(status);
    }

    /*
    * qla2100_get_database
    *      Copies and converts flash database to driver database.
    *      (may sleep)
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success.
    */
    STATIC uint8_t
    qla2100_get_database(scsi_qla_host_t *ha) {
        flash_database_t *fptr;
        uint8_t          status = 1;
        uint32_t         addr;
        uint16_t         cnt;
        uint8_t          *bptr;
        uint8_t          checksum;
        uint32_t         b, t;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_get_database");
#endif

        /* Default setup. */
        ha->flash_db = FLASH_DATABASE_0;
        ha->flash_seq = 0;

        if( (fptr = (flash_database_t *)KMALLOC(sizeof(flash_database_t))) ) {
            /* Enable Flash Read/Write. */
            qla2100_flash_enable(ha);

            /* Start with flash database with the highest sequence number. */
            b = qla2100_read_flash_byte(ha, FLASH_DATABASE_0);
            b |= qla2100_read_flash_byte(ha, FLASH_DATABASE_0 + 1) << 8;
            b |= qla2100_read_flash_byte(ha, FLASH_DATABASE_0 + 1) << 16;
            b |= qla2100_read_flash_byte(ha, FLASH_DATABASE_0 + 1) << 24;
            t = qla2100_read_flash_byte(ha, FLASH_DATABASE_1);
            t |= qla2100_read_flash_byte(ha, FLASH_DATABASE_1 + 1) << 8;
            t |= qla2100_read_flash_byte(ha, FLASH_DATABASE_1 + 1) << 16;
            t |= qla2100_read_flash_byte(ha, FLASH_DATABASE_1 + 1) << 24;
            if( t > b )
                ha->flash_db = FLASH_DATABASE_1;

            /* Select the flash database with the good checksum. */
            for( t = 0; t < 2; t++ ) {
                checksum = 0;
                addr = ha->flash_db;
                bptr = (uint8_t *)fptr;
                fptr->hdr.size = sizeof(flash_database_t);

                /* Read flash database to driver. */
                for( cnt = 0; cnt < fptr->hdr.size; cnt++ ) {
                    *bptr = (uint8_t)qla2100_read_flash_byte(ha, addr++);
                    checksum += *bptr++;
                    if( bptr == &fptr->hdr.spares[0] &&
                        (fptr->hdr.size > sizeof(flash_database_t) ||
                        fptr->hdr.size < sizeof(flash_hdr_t) ||
                        !fptr->hdr.version) ) {
                        checksum = 1;
                        break;
                    }
                }

                if( !checksum ) {
                    status = 0;
                    break;
                }

                if( ha->flash_db == FLASH_DATABASE_0 )
                    ha->flash_db = FLASH_DATABASE_1;
                else
                    ha->flash_db = FLASH_DATABASE_0;
            }

            if( !status ) {
                ha->flash_seq = fptr->hdr.seq;

                /* Convert flash database to driver database format. */
                if( fptr->hdr.size -= sizeof(flash_hdr_t) ) {
                    for( cnt = 0; cnt < MAX_FIBRE_DEVICES; cnt++ ) {
                        ha->fc_db[cnt].name[0] = fptr->node[cnt].name[0];
                        ha->fc_db[cnt].name[1] = fptr->node[cnt].name[1];
                        ha->fc_db[cnt].loop_id = PORT_AVAILABLE;
                        if( !(fptr->hdr.size -= sizeof(flash_node_t)) )
                            break;
                    }
                }
            }

            qla2100_flash_disable(ha);

            KMFREE(fptr, sizeof(flash_database_t));
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_get_database: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_get_database");
#endif
        return(status);
    }

    /*
    * qla2100_save_database
    *      Copies and converts driver database to flash database.
    *      (may sleep)
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success.
    */
    STATIC uint8_t
    qla2100_save_database(scsi_qla_host_t *ha) {
        flash_database_t *fptr;
        uint8_t          status = 1;
        uint32_t         addr;
        uint16_t         cnt;
        uint8_t          *bptr;
        uint8_t          checksum;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_save_database");
#endif

        if( (fptr = (flash_database_t *)KMALLOC(sizeof(flash_database_t)) ) ) {
            /* Enable Flash Read/Write. */
            qla2100_flash_enable(ha);

            fptr->hdr.seq     = ++ha->flash_seq;
            fptr->hdr.version = FLASH_DATABASE_VERSION;
            fptr->hdr.size    = sizeof(flash_hdr_t);

            /* Copy and convert driver database to flash database. */
            for( cnt = 0; cnt < MAX_FIBRE_DEVICES; cnt++ ) {
                if( ha->fc_db[cnt].loop_id == PORT_UNUSED )
                    break;
                else {
                    fptr->node[cnt].name[0] = ha->fc_db[cnt].name[0];
                    fptr->node[cnt].name[1] = ha->fc_db[cnt].name[1];
                    fptr->hdr.size += sizeof(flash_node_t);
                }
            }

            /* Calculate checksum. */
            checksum = 0;
            bptr = (uint8_t *)fptr;
            for( cnt = 0; cnt < fptr->hdr.size; cnt++ )
                checksum += *bptr++;
            fptr->hdr.checksum = ~checksum + 1;

            /* Setup next sector address for flash */
            if( ha->flash_db == FLASH_DATABASE_0 )
                addr = FLASH_DATABASE_1;
            else
                addr = FLASH_DATABASE_0;
            ha->flash_db = addr;

            /* Erase flash sector prior to write. */
            status = qla2100_erase_flash_sector(ha, addr);

            /* Write database to flash. */
            bptr = (uint8_t *)fptr;
            for( cnt = 0; cnt < fptr->hdr.size && !status; cnt++ )
                status = qla2100_program_flash_address(ha, addr++, *bptr++);

            qla2100_flash_disable(ha);

            KMFREE(fptr, sizeof(flash_database_t));
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_save_database: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_save_database");
#endif
        return(status);
    }

    /*
    * qla2100_program_flash_address
    *      Program flash address.
    *
    * Input:
    *      ha   = adapter block pointer.
    *      addr = flash byte address.
    *      data = data to be written to flash.
    *
    * Returns:
    *      0 = success.
    */
    STATIC uint8_t
    qla2100_program_flash_address(scsi_qla_host_t *ha, uint32_t addr, uint8_t data) {
        uint8_t status;

        /* Write Program Command Sequence */
        qla2100_write_flash_byte(ha, 0x5555, 0xaa);
        qla2100_write_flash_byte(ha, 0x2aaa, 0x55);
        qla2100_write_flash_byte(ha, 0x5555, 0xa0);
        qla2100_write_flash_byte(ha, addr, data);

        /* Wait for write to complete. */
        status = qla2100_poll_flash(ha, addr, data);

#ifdef QL_DEBUG_LEVEL_2
        if( status )
            qla2100_print("qla2100_program_flash_address: **** FAILED ****\n");
#endif
        return(status);
    }

    /*
    * qla2100_erase_flash_sector
    *      Erases flash sector.
    *
    * Input:
    *      ha   = adapter block pointer.
    *      addr = sector address.
    *
    * Returns:
    *      0 = success.
    */
    STATIC uint8_t
    qla2100_erase_flash_sector(scsi_qla_host_t *ha, uint32_t addr) {
        uint8_t status;

        addr &= 0x1c000;

        /* Individual Sector Erase Command Sequence */
        qla2100_write_flash_byte(ha, 0x5555, 0xaa);
        qla2100_write_flash_byte(ha, 0x2aaa, 0x55);
        qla2100_write_flash_byte(ha, 0x5555, 0x80);
        qla2100_write_flash_byte(ha, 0x5555, 0xaa);
        qla2100_write_flash_byte(ha, 0x2aaa, 0x55);
        qla2100_write_flash_byte(ha, addr, 0x30);

        SYS_DELAY(150);

        /* Wait for erase to complete. */
        status = qla2100_poll_flash(ha, addr, 0x80);

#ifdef QL_DEBUG_LEVEL_2
        if( status )
            qla2100_print("qla2100_erase_flash_sector: **** FAILED ****\n");
#endif
        return(status);
    }

    /*
    * qla2100_poll_flash
    *      Polls flash for completion.
    *
    * Input:
    *      ha   = adapter block pointer.
    *      addr = flash byte address.
    *      data = data to be polled.
    *
    * Returns:
    *      0 = success.
    */
    STATIC uint8_t
    qla2100_poll_flash(scsi_qla_host_t *ha, uint32_t addr, uint8_t poll_data) {
        uint8_t  status = 1;
        uint8_t  flash_data;
        uint32_t cnt;

        poll_data &= BIT_7;

        /* Wait for 30 seconds for command to finish. */
        for( cnt = 3000000; cnt; cnt-- ) {
            flash_data = (uint8_t)qla2100_read_flash_byte(ha, addr);

            if( (flash_data & BIT_7) == poll_data ) {
                status = 0;
                break;
            }
            if( flash_data & BIT_5 && cnt > 2 )
                cnt = 2;
            SYS_DELAY(10);
        }

        return(status);
    }

    /*
    * qla2100_flash_enable
    *      Setup flash for reading/writing.
    *
    * Input:
    *      ha = adapter block pointer.
    */
    STATIC void
        qla2100_flash_enable(scsi_qla_host_t *ha) {
        device_reg_t *reg = ha->iobase;

        /* Setup bit 16 of flash address. */
        WRT_REG_WORD(&reg->nvram, NV_SELECT);

        /* Enable Flash Read/Write. */
        WRT_REG_WORD(&reg->ctrl_status, ISP_FLASH_ENABLE);

        /* Read/Reset Command Sequence */
        qla2100_write_flash_byte(ha, 0x5555, 0xaa);
        qla2100_write_flash_byte(ha, 0x2aaa, 0x55);
        qla2100_write_flash_byte(ha, 0x5555, 0xf0);
        qla2100_read_flash_byte(ha, FLASH_DATABASE_0);
    }

    /*
    * qla2100_flash_disable
    *      Disable flash and allow RISC to run.
    *
    * Input:
    *      ha = adapter block pointer.
    */
    STATIC void
        qla2100_flash_disable(scsi_qla_host_t *ha) {
        device_reg_t *reg = ha->iobase;

        /* Restore chip registers. */
        WRT_REG_WORD(&reg->ctrl_status, 0);
        WRT_REG_WORD(&reg->nvram, 0);
    }

    /*
    * qla2100_write_flash_byte
    *      Write byte to flash.
    *
    * Input:
    *      ha   = adapter block pointer.
    *      addr = flash byte address.
    *      data = data to be written.
    */
    STATIC void
        qla2100_write_flash_byte(scsi_qla_host_t *ha, uint32_t addr, uint8_t data) {
        device_reg_t *reg = ha->iobase;

        WRT_REG_WORD(&reg->flash_address, (uint16_t)addr);
        WRT_REG_WORD(&reg->flash_data, (uint16_t)data);
    }

    /*
    * qla2100_read_flash_byte
    *      Reads byte from flash, but must read a word from chip.
    *
    * Input:
    *      ha   = adapter block pointer.
    *      addr = flash byte address.
    *
    * Returns:
    *      byte from flash.
    */
    STATIC uint16_t
    qla2100_read_flash_byte(scsi_qla_host_t *ha, uint32_t addr) {
        device_reg_t *reg = ha->iobase;
        uint16_t     data;

        WRT_REG_WORD(&reg->flash_address, (uint16_t)addr);
        data = qla2100_debounce_register(&reg->flash_data);

        return(data);
    }

    /*
    * qla2100_reset_adapter
    *      Reset adapter.
    *
    * Input:
    *      ha = adapter block pointer.
    */
    STATIC void
        qla2100_reset_adapter(scsi_qla_host_t *ha) {
        device_reg_t *reg = ha->iobase;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_reset_adapter");
#endif

        ha->flags.online = FALSE;
        qla2100_disable_intrs(ha);
        /* WRT_REG_WORD(&reg->ictrl, 0); */
        /* Reset RISC processor. */
        WRT_REG_WORD(&reg->host_cmd, HC_RESET_RISC);
        WRT_REG_WORD(&reg->host_cmd, HC_RELEASE_RISC);
#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_reset_adapter");
#endif
    }

    /*
    * qla2100_loop_reset
    *      Issue loop reset.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success
    */
    STATIC uint8_t
    qla2100_loop_reset(scsi_qla_host_t *ha) {
        uint8_t  status = 0;
        uint16_t mb[MAILBOX_REGISTER_COUNT];

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_loop_reset");
#endif

        if( ha->flags.enable_lip_reset ) {
            mb[0] = MBC_LIP_RESET;
            mb[1] = 0xff00;
            mb[2] = ha->loop_reset_delay;
            status |= qla2100_mailbox_command(ha, BIT_2|BIT_1|BIT_0, &mb[0]);
        }
        if( ha->flags.enable_target_reset ) {
            mb[0] = MBC_TARGET_RESET;
            mb[1] = ha->loop_reset_delay;
            status |= qla2100_mailbox_command(ha, BIT_1|BIT_0, &mb[0]);
        }
        if( (!ha->flags.enable_target_reset && !ha->flags.enable_lip_reset ) ||
            ha->flags.enable_lip_full_login ) {
            mb[0] = MBC_LIP_FULL_LOGIN;
            status |= qla2100_mailbox_command(ha, BIT_0, &mb[0]);
        }

        /* Issue marker command. */
        qla2100_marker(ha, 0, 0, 0, MK_SYNC_ALL);

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_loop_reset: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_loop_reset");
#endif
        return(status);
    }

    /*
    * qla2100_device_reset
    *      Issue bus device reset message to the target.
    *
    * Input:
    *      ha = adapter block pointer.
    *      b  = BUS number.
    *      t  = SCSI ID.
    *
    * Returns:
    *      0 = success
    */
    STATIC uint8_t
    qla2100_device_reset(scsi_qla_host_t *ha, uint32_t b, uint32_t t) {
        tgt_t    *tgt;
        uint8_t  status;
        uint16_t mb[MAILBOX_REGISTER_COUNT];

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_device_reset");
#endif

        tgt =  TGT_Q(ha, b, t);

        mb[0] = MBC_ABORT_TARGET;
        mb[1] = tgt->loop_id << 8;
        mb[2] = 1;
        status = qla2100_mailbox_command(ha, BIT_2|BIT_1|BIT_0, &mb[0]);

        /* Issue marker command. */
        qla2100_marker(ha, b, t, 0, MK_SYNC_ID);

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_device_reset: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_device_reset");
#endif
        return(status);
    }

    /*
    * qla2100_abort_device
    *      Issue an abort message to the device
    *
    * Input:
    *      ha = adapter block pointer.
    *      b  = BUS number.
    *      t  = SCSI ID.
    *      l  = SCSI LUN.
    *
    * Returns:
    *      0 = success
    */
    STATIC uint8_t
    qla2100_abort_device(scsi_qla_host_t *ha, uint32_t b, uint32_t t, uint32_t l) {
        tgt_t    *tgt;
        uint8_t  status;
        uint16_t mb[MAILBOX_REGISTER_COUNT];

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_abort_device");
#endif

        tgt = TGT_Q(ha, b, t);

        mb[0] = MBC_ABORT_DEVICE;
        mb[1] = tgt->loop_id << 8;
        mb[2] = l;
        status = qla2100_mailbox_command(ha, BIT_2|BIT_1|BIT_0, &mb[0]);

        /* Issue marker command. */
        qla2100_marker(ha, b, t, l, MK_SYNC_ID_LUN);

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_abort_device: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_abort_device");
#endif
        return(status);
    }

    /*
    * qla2100_abort_command
    *      Abort command aborts a specified IOCB.
    *
    * Input:
    *      ha = adapter block pointer.
    *      sp = SB structure pointer.
    *
    * Returns:
    *      0 = success
    */
    STATIC uint8_t
    qla2100_abort_command(scsi_qla_host_t *ha, srb_t *sp) {
        uint8_t        status;
        uint16_t       mb[MAILBOX_REGISTER_COUNT];
        uint32_t       b, t, l;
        uint32_t       handle;
        tgt_t          *tgt;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_abort_command");
#endif

        /* Locate handle number. */
        for( handle = 0; handle < MAX_OUTSTANDING_COMMANDS; handle++ )
            if( ha->outstanding_cmds[handle] == sp )
                break;

            /* Get a pointer to the SCSI address */
            b  = SCSI_BUS_32(sp->cmd);
            t  = SCSI_TCN_32(sp->cmd);
            l  = SCSI_LUN_32(sp->cmd);

            tgt = TGT_Q(ha, b, t);

            mb[0] = MBC_ABORT_COMMAND;
            mb[1] = tgt->loop_id << 8;
            mb[2] = (uint16_t)handle;
            mb[3] = handle >> 16;
            mb[6] = l;
            if( !(status = qla2100_mailbox_command(ha, BIT_6|BIT_3|BIT_2|BIT_1|BIT_0,
                &mb[0])) )
                sp->flags |= SRB_ABORT_PENDING;


#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
            if( status )
                qla2100_print("qla2100_abort_command: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
            else
                LEAVE("qla2100_abort_command");
#endif
            return(status);
    }

    /*
    *  Issue marker command.
    *      Function issues marker IOCB.
    *
    * Input:
    *      ha   = adapter block pointer.
    *      b    = BUS number.
    *      t    = SCSI ID
    *      l    = SCSI LUN
    *      type = marker modifier
    */
    STATIC void
        qla2100_marker(scsi_qla_host_t *ha, uint32_t b, uint32_t t, uint32_t l, uint8_t type) {
        mrk_entry_t *pkt;
        tgt_t       *tgt;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_marker");
#endif

        tgt = TGT_Q(ha, b, t);

        /* Get request packet. */
        if( (pkt = (mrk_entry_t *)qla2100_req_pkt(ha) ) ) {
            pkt->entry_type = MARKER_TYPE;
            pkt->modifier = type;

            if( type == MK_SYNC_LIP )
                pkt->sequence_number = ha->lip_seq;
            else if( type != MK_SYNC_ALL ) {
                pkt->lun = l;
                pkt->target = (uint8_t)tgt->loop_id;
            }

            /* Issue command to ISP */
            qla2100_isp_cmd(ha);
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( !pkt )
            qla2100_print("qla2100_marker: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_marker");
#endif
    }

#if  QLA2100_64BIT_SUPPORT
    /*
    * qla2100_64bit_start_scsi
    *      The start SCSI is responsible for building request packets on
    *      request ring and modifying ISP input pointer.
    *
    * Input:
    *      ha = adapter block pointer.
    *      sp = SB structure pointer.
    *
    * Returns:
    *      0 = success, was able to issue command.
    */
    STATIC uint8_t
    qla2100_64bit_start_scsi(scsi_qla_host_t *ha, srb_t *sp) {
        device_reg_t    *reg   = ha->iobase;
        uint8_t         status = 0;
        Scsi_Cmnd       *cmd = sp->cmd;
        uint16_t        cdb_len;
        uint32_t        cnt, temp;
        cmd_a64_entry_t     *pkt;
        uint16_t        req_cnt;
        uint16_t        seg_cnt;
        struct scatterlist    *sg = (struct scatterlist *) NULL;
        uint32_t        *dword_ptr;
        uint32_t        timeout;
        caddr_t         data_ptr;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_64bit_start_scsi:");
#endif

        /* Calculate number of entries and segments required. */
        seg_cnt = 0;
        req_cnt = 1;
        if( cmd->use_sg ) {
            seg_cnt =  cmd->use_sg;
            sg = (struct scatterlist *) cmd->request_buffer;

            if( seg_cnt > 2 ) {
                req_cnt += (uint16_t)(seg_cnt - 2) / 5;
                if( (uint16_t)(seg_cnt - 2) % 5 )
                    req_cnt++;
            }
        } else if( cmd->request_bufflen )  /* If data transfer. */
        {
            DEBUG5(printk("Single data transfer (0x%x)\n",cmd->request_bufflen));
            seg_cnt = 1;
        }

        /* Acquire ring specific lock */
        QLA2100_RING_LOCK(ha);

        if( (uint16_t)(req_cnt + 2) >= ha->req_q_cnt ) {
            /* Calculate number of free request entries. */
            cnt = RD_REG_WORD(&reg->mailbox4);
            if( ha->req_ring_index < cnt )
                ha->req_q_cnt = cnt - ha->req_ring_index;
            else
                ha->req_q_cnt = REQUEST_ENTRY_CNT - (ha->req_ring_index - cnt);
        }

        /* If room for request in request ring. */
        if( (uint16_t)(req_cnt + 2) < ha->req_q_cnt ) {
            /* Check for room in outstanding command list. */
            for( cnt = 1; cnt < MAX_OUTSTANDING_COMMANDS &&
                ha->outstanding_cmds[cnt] != 0; cnt++ )
                ;

            if( cnt < MAX_OUTSTANDING_COMMANDS ) {
                ha->outstanding_cmds[cnt] = sp;
                ha->req_q_cnt -= req_cnt;
                CMD_HANDLE(sp->cmd) = (unsigned char *) (u_long) cnt;

                /*
                * Build command packet.
                */
                pkt = (cmd_a64_entry_t *)ha->request_ring_ptr;

                pkt->entry_type = COMMAND_A64_TYPE;
                pkt->entry_count = (uint8_t)req_cnt;
                pkt->sys_define = (uint8_t)ha->req_ring_index;
                pkt->handle = (uint32_t)cnt;

                /* Zero out remaining portion of packet. */
                dword_ptr = (uint32_t *)pkt + 2;
                for( cnt = 2; cnt < REQUEST_ENTRY_SIZE/4; cnt++ )
                    *dword_ptr++ = 0;

                /*  
                * We subtract 2 sec. from the timeout value to insure 
                * the ISP time-out before the mid-level or the driver.
                */
                timeout = (uint32_t) CMD_TIMEOUT(cmd)/HZ;
                if( timeout > 2 )
                    pkt->timeout = (uint16_t) timeout - 2;
                else
                    pkt->timeout = (uint16_t) timeout;

                /* Set device target ID and LUN */
                pkt->target = TGT_Q(ha, SCSI_BUS_32(cmd), SCSI_TCN_32(cmd))->loop_id;
                pkt->lun = SCSI_LUN_32(cmd);
                
                /* Enable simple tag queuing if device supports it. */
                if ( cmd->device->tagged_queue ) 
                {
		     switch (cmd->tag) {
		     case SIMPLE_QUEUE_TAG:
                         pkt->control_flags = CF_SIMPLE_TAG;
			     break;
		     case HEAD_OF_QUEUE_TAG:
			     pkt->control_flags = CF_HEAD_TAG;
			     break;
		     case ORDERED_QUEUE_TAG:
			     pkt->control_flags = CF_ORDERED_TAG;
			     break;
		     default:
			pkt->control_flags = CF_SIMPLE_TAG;
                    }
		 }
                else
                  pkt->control_flags = CF_SIMPLE_TAG;

                /* Load SCSI command packet. */
                cdb_len = (uint16_t)CMD_CDBLEN(cmd);
                if( cdb_len > MAX_CMDSZ )
                    cdb_len = MAX_CMDSZ;
                data_ptr = (uint8_t *) &(CMD_CDBP(cmd));
                for( cnt = 0; cnt < cdb_len; cnt++ )
                    pkt->scsi_cdb[cnt] = *data_ptr++;
                DEBUG3(sprintf(debug_buff,"qla2100: Packet has command[0]=0x%x, hndl=0x%x\n",pkt->scsi_cdb[0],pkt->handle);)
                DEBUG3(qla2100_print(debug_buff);)
                pkt->byte_count = (uint32_t) CMD_XFRLEN(cmd);

                /*
                * Load data segments.
                */
                if( seg_cnt )                /* If data transfer. */
                {
                    /* Set transfer direction. */
                    switch( cmd->data_cmnd[0] ) {
                    case FORMAT_UNIT:
                    case WRITE_6:
                    case MODE_SELECT:
                    case SEND_DIAGNOSTIC:
                    case WRITE_10:
                    case WRITE_BUFFER:
                    case WRITE_LONG:
                    case WRITE_SAME:
                    case MODE_SELECT_10:
                    case WRITE_12:
                    case WRITE_VERIFY_12:
                    case SEND_VOLUME_TAG:
                        pkt->control_flags |= BIT_6;
                        break;
                    default:
                        pkt->control_flags |= BIT_5;
                    }
                    sp->dir = pkt->control_flags & (BIT_5|BIT_6);

                    /* Set total data segment count. */
                    pkt->dseg_count = seg_cnt;

                    /* Setup packet address segment pointer. */
                    dword_ptr = (uint32_t *)&pkt->dseg_0_address;

                    if( cmd->use_sg )              /* If scatter gather */
                    {
                        /* Load command entry data segments. */
                        for( cnt = 0; cnt < 2 && seg_cnt; cnt++, seg_cnt-- ) {
                            *dword_ptr++ = cpu_to_le32(VIRT_TO_BUS_LOW(sg->address));
                            *dword_ptr++ = cpu_to_le32(VIRT_TO_BUS_HIGH(sg->address));
                            *dword_ptr++ = sg->length;
                            sg++;
                        }
#ifdef QL_DEBUG_LEVEL_5
                        qla2100_print(
                            "qla2100_64bit_start_scsi: Scatter/gather command packet data - ");
                        qla2100_print("b");
                        qla2100_output_number((u_long)SCSI_BUS_32(cmd), 10);
                        qla2100_print("t");
                        qla2100_output_number((u_long)SCSI_TCN_32(cmd), 10);
                        qla2100_print("d");
                        qla2100_output_number((u_long)SCSI_LUN_32(cmd), 10);
                        qla2100_print("\n\r");
                        qla2100_dump_buffer((caddr_t)pkt, REQUEST_ENTRY_SIZE);
#endif
                        /*
                        * Build continuation packets.
                        */
                        while( seg_cnt > 0 ) {
                            /* Adjust ring index. */
                            ha->req_ring_index++;
                            if( ha->req_ring_index == REQUEST_ENTRY_CNT ) {
                                ha->req_ring_index = 0;
                                ha->request_ring_ptr = ha->request_ring;
                            } else
                                ha->request_ring_ptr++;

                            pkt = (cmd_a64_entry_t *)ha->request_ring_ptr;

                            /* Zero out packet. */
                            dword_ptr = (uint32_t *)pkt;
                            for( cnt = 0;cnt < REQUEST_ENTRY_SIZE/4; cnt++ )
                                *dword_ptr++ = 0;

                            /* Load packet defaults. */
                            ((cont_a64_entry_t *)pkt)->entry_type =
                                CONTINUE_A64_TYPE;
                            ((cont_a64_entry_t *)pkt)->entry_count = 1;
                            ((cont_a64_entry_t *)pkt)->sys_define = (uint8_t)
                                ha->req_ring_index;

                            /* Setup packet address segment pointer. */
                            dword_ptr = (uint32_t *)
                                &((cont_a64_entry_t *)pkt)->dseg_0_address;

                            /* Load continuation entry data segments. */
                            for( cnt = 0; cnt < 5 && seg_cnt; cnt++, seg_cnt-- ) {
                                *dword_ptr++ = cpu_to_le32(VIRT_TO_BUS_LOW(sg->address));
                                *dword_ptr++ = cpu_to_le32(VIRT_TO_BUS_HIGH(sg->address));
                                *dword_ptr++ = sg->length;
                                sg++;
                            }
#ifdef QL_DEBUG_LEVEL_5
                            qla2100_print(
                                "qla2100_64bit_start_scsi: continuation packet data - c");
                            qla2100_print("b");
                            qla2100_output_number((u_long)SCSI_BUS_32(cmd), 10);

                            qla2100_print("t");
                            qla2100_output_number((u_long)SCSI_TCN_32(cmd), 10);
                            qla2100_print("d");
                            qla2100_output_number((u_long)SCSI_LUN_32(cmd), 10);
                            qla2100_print("\n\r");
                            qla2100_dump_buffer((caddr_t)pkt, REQUEST_ENTRY_SIZE);
#endif
                        }
                    } else                    /* No scatter gather data transfer */
                    {
                        *dword_ptr++ = cpu_to_le32(VIRT_TO_BUS_LOW(cmd->request_buffer));
                        *dword_ptr++ = cpu_to_le32(VIRT_TO_BUS_HIGH(cmd->request_buffer));
                        *dword_ptr = (uint32_t) cmd->request_bufflen;
#ifdef QL_DEBUG_LEVEL_5
                        qla2100_print(
                            "qla2100_64bit_start_scsi: No scatter/gather command packet data - c");
                        qla2100_print("b");
                        qla2100_output_number((u_long)SCSI_BUS_32(cmd), 10);
                        qla2100_print("t");
                        qla2100_output_number((u_long)SCSI_TCN_32(cmd), 10);
                        qla2100_print("d");
                        qla2100_output_number((u_long)SCSI_LUN_32(cmd), 10);
                        qla2100_print("\n\r");
                        qla2100_dump_buffer((caddr_t)pkt, REQUEST_ENTRY_SIZE);
#endif
                    }
                }
#ifdef QL_DEBUG_LEVEL_5
                else                            /* No data transfer */
                {
                    *dword_ptr++ = (uint32_t) 0;
                    *dword_ptr++ = (uint32_t) 0;
                    *dword_ptr = (uint32_t)  0;
                    qla2100_print(
                        "qla2100_64bit_start_scsi: No data, command packet data - c");
                    qla2100_print("b");
                    qla2100_output_number((u_long)SCSI_BUS_32(cmd), 10);
                    qla2100_print("t");
                    qla2100_output_number((u_long)SCSI_TCN_32(cmd), 10);
                    qla2100_print("d");
                    qla2100_output_number((u_long)SCSI_LUN_32(cmd), 10);
                    qla2100_print("\n\r");
                    qla2100_dump_buffer((caddr_t)pkt, REQUEST_ENTRY_SIZE);
                }
#endif
                /* Adjust ring index. */
                ha->req_ring_index++;
                if( ha->req_ring_index == REQUEST_ENTRY_CNT ) {
                    ha->req_ring_index = 0;
                    ha->request_ring_ptr = ha->request_ring;
                } else
                    ha->request_ring_ptr++;

                /* Set chip new ring index. */
#if WATCH_THREADS_SIZE
                DEBUG3(qla2100_output_number((u_long)ha->actthreads, 16)); 
#endif
                temp = CACHE_FLUSH(&reg->mailbox4);
                WRT_REG_WORD(&reg->mailbox4, ha->req_ring_index);
            } else {
                status = 1;
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print(
                    "qla2100_64bit_start_scsi: NO ROOM IN OUTSTANDING ARRAY\n\r");
                qla2100_print(" req_q_cnt=");
                qla2100_output_number((u_long)ha->req_q_cnt, 16);
#endif
            }
        } else {
            status = 1;
#ifdef QL_DEBUG_LEVEL_2
            qla2100_print("qla2100_64bit_start_scsi: in-ptr=");
            qla2100_output_number((u_long)ha->req_ring_index, 16);
            qla2100_print(" req_q_cnt=");
            qla2100_output_number((u_long)ha->req_q_cnt, 16);
            qla2100_print(" req_cnt=");
            qla2100_output_number((u_long)req_cnt, 16);
            qla2100_print("\n\r");
#endif
        }

        /* Release ring specific lock */
        QLA2100_RING_UNLOCK(ha);

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_64bit_start_scsi: **** FAILED ****\n\r");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            qla2100_print("qla2100_64bit_start_scsi: exiting normally\n\r");
#endif
        return(status);
    }
#endif  /* QLA2100_64BIT_SUPPORT */

    /*
    * qla2100_32bit_start_scsi
    *      The start SCSI is responsible for building request packets on
    *      request ring and modifying ISP input pointer.
    *
    *      The Qlogic firmware interface allows every queue slot to have a SCSI
    *      command and up to 4 scatter/gather (SG) entries.  If we need more
    *      than 4 SG entries, then continuation entries are used that can 
    *      hold another 7 entries each.  The start routine determines if there
    *      is eought empty slots then build the combination of requests to 
    *      fulfill the OS request.
    *
    * Input:
    *      ha = adapter block pointer.
    *      sp = SCSI Request Block structure pointer.
    *
    * Returns:
    *      0 = success, was able to issue command.
    */
    STATIC uint8_t
    qla2100_32bit_start_scsi(scsi_qla_host_t *ha, srb_t *sp) {
        device_reg_t    *reg   = ha->iobase;
        uint8_t         status = 0;
        Scsi_Cmnd       *cmd = sp->cmd;
        uint16_t        cdb_len, temp;
        uint32_t        cnt;
        cmd_entry_t     *pkt;
        uint16_t        req_cnt;
        uint16_t        seg_cnt;
        struct scatterlist    *sg = (struct scatterlist *) NULL;
        caddr_t         data_ptr;
        uint32_t        *dword_ptr;
        uint32_t        timeout;

#ifdef QL_DEBUG_LEVEL_3
        /* ENTER("qla2100_32bit_start_scsi"); */
#endif


        COMTRACE('S')
#ifdef TRACECODE
            qla2100_putc('S');
#endif
        /* Calculate number of entries and segments required. */
        seg_cnt = 0;
        req_cnt = 1;
        if( cmd->use_sg ) {
            /*
            * We must build an SG list in adapter format, as the kernel's SG list
            * cannot be used directly because of data field size (__alpha__)
            * differences and the kernel SG list uses virtual addresses where
            * we need physical addresses.
            */
            seg_cnt =  cmd->use_sg;
            sg = (struct scatterlist *) cmd->request_buffer;
            /* 
            * if greater than four sg entries then we need to allocate
            * continuation entries
            */
            if( seg_cnt > 2 ) {
                req_cnt += (uint16_t)(seg_cnt - 3) / 7;
                if( (uint16_t)(seg_cnt - 3) % 7 )
                    req_cnt++;
            }
            DEBUG5(sprintf(debug_buff,"S/G for data transfer -num segs(%d), req blk cnt(%d)\n\r",seg_cnt,req_cnt));
            DEBUG5(qla2100_print(debug_buff));
        } else if( CMD_XFRLEN(cmd) )  /* If data transfer. */
        {  /* direct data tranfer -- no S/G */
            DEBUG5(printk("Single data transfer (0x%x)\n",cmd->request_bufflen));
            seg_cnt = 1;
        }

        /* Acquire ring specific lock */
        QLA2100_RING_LOCK(ha);

        if( (uint16_t)(req_cnt + 2) >= ha->req_q_cnt ) {
            /* Calculate number of free request entries. */
            cnt = qla2100_debounce_register(&reg->mailbox4);
            if( ha->req_ring_index < cnt )
                ha->req_q_cnt = cnt - ha->req_ring_index;
            else
                ha->req_q_cnt = REQUEST_ENTRY_CNT - (ha->req_ring_index - cnt);
        }

        DEBUG5(sprintf(debug_buff,"Number of free entries = (%d)\n\r",ha->req_q_cnt));
        DEBUG5(qla2100_print(debug_buff));
        /* If room for request in request ring. */
        if( (uint16_t)(req_cnt + 2) < ha->req_q_cnt ) {
            /* Check for room in outstanding command list. */
            for( cnt = 1; cnt < MAX_OUTSTANDING_COMMANDS &&
                (ha->outstanding_cmds[cnt] != 0); cnt++ )
                ;

            if( cnt < MAX_OUTSTANDING_COMMANDS ) {
                ha->outstanding_cmds[cnt] = sp;
                ha->req_q_cnt -= req_cnt;
                /* save the handle -- it help if we have to abort it */
                CMD_HANDLE(sp->cmd) = (unsigned char *) (u_long) cnt;

                /*
                * Build command packet.
                */
                pkt = (cmd_entry_t *)ha->request_ring_ptr;

                /* Zero out packet. */
                memset(pkt, 0, REQUEST_ENTRY_SIZE);

                pkt->entry_type = COMMAND_TYPE;
                pkt->entry_count = (uint8_t)req_cnt;
                pkt->sys_define = (uint8_t)ha->req_ring_index;
                pkt->handle = (uint32_t)cnt;

#if 0
                /* Zero out remaining portion of packet. */
                dword_ptr = (uint32_t *)pkt + 2;
                for( cnt = 2; cnt < REQUEST_ENTRY_SIZE/4; cnt++ )
                    *dword_ptr++ = 0;
#endif

                /*  
                * We subtract 2 sec. from the timeout value to insure 
                * the ISP time-out before the mid-level or the driver.
                */
                timeout = (uint32_t) CMD_TIMEOUT(cmd)/HZ;
                if( timeout > 2 )
                    pkt->timeout = (uint16_t) timeout - 2;
                else
                    pkt->timeout = (uint16_t) timeout;

                /* Set device target ID and LUN */
                pkt->target = TGT_Q(ha, SCSI_BUS_32(cmd), SCSI_TCN_32(cmd))->loop_id;
                pkt->lun = SCSI_LUN_32(cmd);
                
                /* Enable simple tag queuing if device supports it. */
                if ( cmd->device->tagged_queue ) 
                {
		     switch (cmd->tag) {
		     case SIMPLE_QUEUE_TAG:
                         pkt->control_flags = CF_SIMPLE_TAG;
			     break;
		     case HEAD_OF_QUEUE_TAG:
			     pkt->control_flags = CF_HEAD_TAG;
			     break;
		     case ORDERED_QUEUE_TAG:
			     pkt->control_flags = CF_ORDERED_TAG;
			     break;
		     default:
			pkt->control_flags = CF_SIMPLE_TAG;
                    }
		 }
                else
                  pkt->control_flags = CF_SIMPLE_TAG;

                /* Load SCSI command packet. */
                cdb_len = (uint16_t)CMD_CDBLEN(cmd);
                if( cdb_len > MAX_CMDSZ )
                    cdb_len = MAX_CMDSZ;
                data_ptr = (uint8_t *) &(CMD_CDBP(cmd));
                for( cnt = 0; cnt < cdb_len; cnt++ )
                    pkt->scsi_cdb[cnt] = *data_ptr++;
                DEBUG3(sprintf(debug_buff,"qla2100: Packet has command[0]=0x%x, hndl=0x%x\n",pkt->scsi_cdb[0],pkt->handle);)
                DEBUG3(qla2100_print(debug_buff);)
                pkt->byte_count = (uint32_t) CMD_XFRLEN(cmd);

                /*
                * Load data segments.
                */
                if( seg_cnt ) {
                    /* Set transfer direction (READ and WRITE) */
                    /* Linux doesn't tell us                   */

                    /*
                    * 3/10 dg - Normally, we should need this check with our F/W
                    * but because of a small issue with it we do.
                    *
                    * For block devices, cmd->request.cmd has the operation. however,
                    * its not set for readcap, so what good is it.
                    */
                    switch( cmd->data_cmnd[0] ) {
                    case FORMAT_UNIT:
                    case WRITE_6:
                    case MODE_SELECT:
                    case SEND_DIAGNOSTIC:
                    case WRITE_10:
                    case WRITE_BUFFER:
                    case WRITE_LONG:
                    case WRITE_SAME:
                    case MODE_SELECT_10:
                    case WRITE_12:
                    case WRITE_VERIFY_12:
                    case SEND_VOLUME_TAG:
                        pkt->control_flags |= BIT_6;
                        break;
                    default:
                        pkt->control_flags |= BIT_5;
                    }
                    sp->dir = pkt->control_flags & (BIT_5|BIT_6);

                    /* Set total data segment count. */
                    pkt->dseg_count = seg_cnt;

                    /* Setup packet address segment pointer. */
                    dword_ptr = (uint32_t *)&pkt->dseg_0_address;

                    if( cmd->use_sg )     /* If scatter gather */
                    {
                        DEBUG5(qla2100_print("Building S/G data segments..\n\r"));
                        DEBUG5(qla2100_dump_buffer((caddr_t)sg, 4*16));
                        /* Load command entry data segments. */
                        for( cnt = 0; cnt < 3 && seg_cnt; cnt++, seg_cnt-- ) {
                            *dword_ptr++ = (uint32_t) cpu_to_le32(VIRT_TO_BUS(sg->address));
                            *dword_ptr++ = sg->length;
                            sg++;
                        }
#ifdef QL_DEBUG_LEVEL_5
                        qla2100_print(
                            "qla2100_32bit_start_scsi: Scatter/gather command packet data - ");
                        qla2100_output_number((u_long)ha->host_no, 10);
                        qla2100_print(":");
                        qla2100_output_number((u_long)SCSI_BUS_32(cmd), 10);
                        qla2100_print(":");
                        qla2100_output_number((u_long)SCSI_TCN_32(cmd), 10);
                        qla2100_print(":");
                        qla2100_output_number((u_long)SCSI_LUN_32(cmd), 10);
                        qla2100_print("\n");
                        qla2100_dump_buffer((uint8_t *)pkt, REQUEST_ENTRY_SIZE);
#endif
                        /*
                        * Build continuation packets.
                        */
                        while( seg_cnt > 0 ) {
                            /* Adjust ring index. */
                            ha->req_ring_index++;
                            if( ha->req_ring_index == REQUEST_ENTRY_CNT ) {
                                ha->req_ring_index = 0;
                                ha->request_ring_ptr = ha->request_ring;
                            } else
                                ha->request_ring_ptr++;

                            pkt = (cmd_entry_t *)ha->request_ring_ptr;

                            /* Zero out packet. */
                            dword_ptr = (uint32_t *)pkt;
                            for( cnt = 0;cnt < REQUEST_ENTRY_SIZE/4; cnt++ )
                                *dword_ptr++ = 0;

                            /* Load packet defaults. */
                            ((cont_entry_t *)pkt)->entry_type = CONTINUE_TYPE;
                            ((cont_entry_t *)pkt)->entry_count = 1;
                            ((cont_entry_t *)pkt)->sys_define = (uint8_t)
                                ha->req_ring_index;

                            /* Setup packet address segment pointer. */
                            dword_ptr = (uint32_t *)
                                &((cont_entry_t *)pkt)->dseg_0_address;

                            /* Load continuation entry data segments. */
                            for( cnt = 0; cnt < 7 && seg_cnt; cnt++, seg_cnt-- ) {
                                *dword_ptr++ = (u_int) cpu_to_le32(VIRT_TO_BUS(sg->address));
                                *dword_ptr++ = sg->length;
                                sg++;
                            }
#ifdef QL_DEBUG_LEVEL_5
                            qla2100_print(
                                "qla2100_32bit_start_scsi: continuation packet data - ");
                            qla2100_output_number((u_long)ha->host_no, 10);
                            qla2100_print(":");
                            qla2100_output_number((u_long)SCSI_BUS_32(cmd), 10);
                            qla2100_print(":");
                            qla2100_output_number((u_long)SCSI_TCN_32(cmd), 10);
                            qla2100_print(":");
                            qla2100_output_number((u_long)SCSI_LUN_32(cmd), 10);
                            qla2100_print("\n");
                            qla2100_dump_buffer((uint8_t *)pkt,
                                REQUEST_ENTRY_SIZE);
#endif
                        }
                    } else                    /* No scatter gather data transfer */
                    {
                        *dword_ptr++ = (uint32_t) cpu_to_le32(VIRT_TO_BUS(cmd->request_buffer));
                        *dword_ptr = (uint32_t) cmd->request_bufflen;
                        DEBUG5(printk("Single Segment ap=0x%p, len=0x%x\n",cmd->request_buffer,cmd->request_bufflen));

#ifdef QL_DEBUG_LEVEL_5
                        qla2100_print(
                            "qla2100_32bit_start_scsi: No scatter/gather command packet data - ");
                        qla2100_output_number((u_long)ha->host_no, 10);
                        qla2100_print(":");
                        qla2100_output_number((u_long)SCSI_BUS_32(cmd), 10);
                        qla2100_print(":");
                        qla2100_output_number((u_long)SCSI_TCN_32(cmd), 10);
                        qla2100_print(":");
                        qla2100_output_number((u_long)SCSI_LUN_32(cmd), 10);
                        qla2100_print("\n");
                        qla2100_dump_buffer((uint8_t *)pkt, REQUEST_ENTRY_SIZE);
#endif
                    }
                }
#ifdef QL_DEBUG_LEVEL_5
                else                        /* No data transfer */
                {
                    *dword_ptr++ = (uint32_t) 0;
                    *dword_ptr = (uint32_t)  0;

                    qla2100_print(
                        "qla2100_32bit_start_scsi: No data, command packet data - ");
                    qla2100_output_number((u_long)ha->host_no, 10);
                    qla2100_print(":");
                    qla2100_output_number((u_long)SCSI_BUS_32(cmd), 10);
                    qla2100_print(":");
                    qla2100_output_number((u_long)SCSI_TCN_32(cmd), 10);
                    qla2100_print(":");
                    qla2100_output_number((u_long)SCSI_LUN_32(cmd), 10);
                    qla2100_print("\n");
                    qla2100_dump_buffer((uint8_t *)pkt, REQUEST_ENTRY_SIZE);
                }
#endif
                /* Adjust ring index. */
                ha->req_ring_index++;
                if( ha->req_ring_index == REQUEST_ENTRY_CNT ) {
                    ha->req_ring_index = 0;
                    ha->request_ring_ptr = ha->request_ring;
                } else
                    ha->request_ring_ptr++;
                /* Set chip new ring index. */
                DEBUG5(qla2100_print("qla2100_32bit_start_scsi: Wakeup RISC for pending command\n\r"));
                DEBUG5(qla2100_dump_buffer((caddr_t)pkt, 64));
                ha->qthreads--;
                sp->u_start = jiffies;
                sp->flags |= SRB_SENT;
                ha->actthreads++;

#if WATCH_THREADS_SIZE
                DEBUG3(qla2100_output_number((u_long)ha->actthreads, 16)); 
#endif
                temp = CACHE_FLUSH(&reg->mailbox4);
                WRT_REG_WORD(&reg->mailbox4, ha->req_ring_index);
            } else {
                status = 1;
#ifdef QL_DEBUG_LEVEL_8
                qla2100_print(
                    "qla2100_32bit_start_scsi: NO ROOM IN OUTSTANDING ARRAY\n");
#endif
            }
        } else {
            status = 1;
#ifdef QL_DEBUG_LEVEL_8
            qla2100_print("qla2100_32bit_start_scsi: in-ptr=");
            qla2100_output_number((u_long)ha->req_ring_index, 16);
            qla2100_print(" req_q_cnt=");
            qla2100_output_number((u_long)ha->req_q_cnt, 16);
            qla2100_print(" req_cnt=");
            qla2100_output_number((u_long)req_cnt, 16);
            qla2100_print("\n");
#endif
        }

        /* Release ring specific lock */
        QLA2100_RING_UNLOCK(ha);

#if defined(QL_DEBUG_LEVEL_8) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_32bit_start_scsi: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        /* else
        LEAVE("qla2100_32bit_start_scsi"); */
#endif
        COMTRACE('s')
        return(status);
    }

    /*
    * qla2100_req_pkt
    *      Function is responsible for locking ring and
    *      getting a zeroed out request packet.
    *
    * Input:
    *      ha  = adapter block pointer.
    *
    * Returns:
    *      0 = failed to get slot.
    */
    STATIC request_t *
        qla2100_req_pkt(scsi_qla_host_t *ha) {
        device_reg_t *reg = ha->iobase;
        request_t    *pkt = 0;
        uint16_t     cnt;
        uint32_t     *dword_ptr;
        uint32_t     timer;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_req_pkt");
#endif

        /* Wait for 30 seconds for slot. */
        for( timer = 3000000; timer; timer-- ) {
            /* Acquire ring specific lock */
            QLA2100_RING_LOCK(ha);

            if( !ha->req_q_cnt ) {
                /* Calculate number of free request entries. */
                cnt = qla2100_debounce_register(&reg->mailbox4);
                if( ha->req_ring_index < cnt )
                    ha->req_q_cnt = cnt - ha->req_ring_index;
                else
                    ha->req_q_cnt = REQUEST_ENTRY_CNT - (ha->req_ring_index - cnt);
            }

            /* Found empty request ring slot? */
            if( ha->req_q_cnt ) {
                ha->req_q_cnt--;
                pkt = ha->request_ring_ptr;

                /* Zero out packet. */
                dword_ptr = (uint32_t *)pkt;
                for( cnt = 0; cnt < REQUEST_ENTRY_SIZE/4; cnt++ )
                    *dword_ptr++ = 0;

                /* Set system defined field. */
                pkt->sys_define = (uint8_t)ha->req_ring_index;

                /* Set entry count. */
                pkt->entry_count = 1;

                break;
            }

            /* Release ring specific lock */
            QLA2100_RING_UNLOCK(ha);

            SYS_DELAY(2);   /* 10 */ 

            /* Check for pending interrupts. */
            qla2100_poll(ha);
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( !pkt )
            qla2100_print("qla2100_req_pkt: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_req_pkt");
#endif
        return(pkt);
    }

    /*
    * qla2100_isp_cmd
    *      Function is responsible for modifying ISP input pointer.
    *      Releases ring lock.
    *
    * Input:
    *      ha  = adapter block pointer.
    */
    STATIC void
        qla2100_isp_cmd(scsi_qla_host_t *ha) {
        device_reg_t *reg = ha->iobase;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_isp_cmd");
#endif

#ifdef QL_DEBUG_LEVEL_5
        qla2100_print("qla2100_isp_cmd: IOCB data:\n");
        qla2100_dump_buffer((uint8_t *)ha->request_ring_ptr, REQUEST_ENTRY_SIZE);
#endif

        /* Adjust ring index. */
        ha->req_ring_index++;
        if( ha->req_ring_index == REQUEST_ENTRY_CNT ) {
            ha->req_ring_index = 0;
            ha->request_ring_ptr = ha->request_ring;
        } else
            ha->request_ring_ptr++;

        /* Set chip new ring index. */
        WRT_REG_WORD(&reg->mailbox4, ha->req_ring_index);

        /* Release ring specific lock */
        QLA2100_RING_UNLOCK(ha);

#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_isp_cmd");
#endif
    }

    /*
    * qla2100_enable_lun
    *      Issue enable LUN entry IOCB.
    *
    * Input:
    *      ha = adapter block pointer.
    */
    STATIC void
        qla2100_enable_lun(scsi_qla_host_t *ha) {
        elun_entry_t *pkt;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_enable_lun");
#endif

        /* Get request packet. */
        if( (pkt = (elun_entry_t *)qla2100_req_pkt(ha)) != NULL ) {
            pkt->entry_type = ENABLE_LUN_TYPE;
            pkt->command_count = 32;
            pkt->immed_notify_count = 1;
            pkt->timeout = 0xffff;

            /* Issue command to ISP */
            qla2100_isp_cmd(ha);
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( !pkt )
            qla2100_print("qla2100_enable_lun: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_enable_lun");
#endif
    }



#if QL2100_TARGET_MODE_SUPPORT
    /****************************************************************************/
    /*                      Target Mode Support Functions.                      */
    /****************************************************************************/


    /*
    * qla2100_notify_ack
    *      Issue notify acknowledge IOCB.
    *      If sequence ID is zero, acknowledgement of
    *      SCSI bus reset or bus device reset is assumed.
    *
    * Input:
    *      ha      = adapter block pointer.
    *      inotify = immediate notify entry pointer.
    */
    STATIC void
        qla2100_notify_ack(scsi_qla_host_t *ha, notify_entry_t *inotify) {
        nack_entry_t *pkt;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_notify_ack: entered\n");
#endif

        /* Get request packet. */
        if( pkt = (nack_entry_t *)qla2100_req_pkt(ha) ) {
            pkt->entry_type = NOTIFY_ACK_TYPE;
            pkt->initiator_id = inotify->initiator_id;
            pkt->target_id = inotify->target_id;

            if( (pkt->status = inotify->status) == 0xe )
                /* Reset LIP occurred. */
                pkt->flags = OF_RESET;
            else
                /* Increment Immediate Notify Resource Count. */
                pkt->flags = OF_INC_RC;

            pkt->task_flags = inotify->task_flags;
            pkt->seq_id = inotify->seq_id;

            /* Issue command to ISP */
            qla2100_isp_cmd(ha);
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( !pkt )
            qla2100_print("qla2100_notify_ack: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_notify_ack: exiting normally\n");
#endif
    }

    /*
    * qla2100_64bit_continue_io
    *      Issue continue target I/O IOCB.
    *
    * Input:
    *      ha   = adapter block pointer.
    *      atio = atio pointer.
    *      len  = total bytecount.
    *      addr = physical address pointer.
    */
    STATIC void
        qla2100_64bit_continue_io(scsi_qla_host_t *ha, atio_entry_t *atio, uint32_t len,
        u_long    *addr) {
        ctio_a64_entry_t *pkt;
        uint32_t         *dword_ptr;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_64bit_continue_io: entered\n");
#endif

        /* Get request packet. */
        if( pkt = (ctio_a64_entry_t *)qla2100_req_pkt(ha) ) {
            pkt->entry_type = CTIO_A64_TYPE;
            pkt->initiator_id = atio->initiator_id;
            pkt->exchange_id = atio->exchange_id;
            pkt->flags = atio->flags | OF_FAST_POST;
            pkt->scsi_status = atio->scsi_status;

            if( len ) {
                pkt->dseg_count = 1;
                pkt->transfer_length = len;
                pkt->dseg_0_length = len;
                dword_ptr = (uint32_t *)addr;
                pkt->dseg_0_address[0] = *dword_ptr++;
                pkt->dseg_0_address[1] = *dword_ptr;
            }

            /* Issue command to ISP */
            qla2100_isp_cmd(ha);
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( !pkt )
            qla2100_print("qla2100_64bit_continue_io: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_64bit_continue_io: exiting normally\n");
#endif
    }
    /*
    * qla2100_32bit_continue_io
    *      Issue continue target I/O IOCB.
    *
    * Input:
    *      ha   = adapter block pointer.
    *      atio = atio pointer.
    *      len  = total bytecount.
    *      addr = physical address pointer.
    */
    STATIC void
        qla2100_32bit_continue_io(scsi_qla_host_t *ha, atio_entry_t *atio, uint32_t len,
        u_long    *addr) {
        ctio_entry_t *pkt;
        uint32_t     *dword_ptr;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_continue_io: entered\n");
#endif

        /* Get request packet. */
        if( pkt = (ctio_entry_t *)qla2100_req_pkt(ha) ) {
            pkt->entry_type = CONTINUE_TGT_IO_TYPE;
            pkt->initiator_id = atio->initiator_id;
            pkt->exchange_id = atio->exchange_id;
            pkt->flags = atio->flags | OF_FAST_POST;
            pkt->scsi_status = atio->scsi_status;

            if( len ) {
                pkt->dseg_count = 1;
                pkt->transfer_length = len;
                pkt->dseg_0_length = len;
                dword_ptr = (uint32_t *)addr;
                pkt->dseg_0_address = *dword_ptr;
            }

            /* Issue command to ISP */
            qla2100_isp_cmd(ha);
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( !pkt )
            qla2100_print("qla2100_32bit_continue_io: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_32bit_continue_io: exiting normally\n");
#endif
    }
#endif /* QL2100_TARGET_MODE_SUPPORT */

    /****************************************************************************/
    /*                        Interrupt Service Routine.                        */
    /****************************************************************************/

    /*
    *  qla2100_isr
    *      Calls I/O done on command completion.
    *
    * Input:
    *      ha           = adapter block pointer.
    *      done_q_first = done queue first pointer.
    *      done_q_last  = done queue last pointer.
    *      INTR_LOCK must be already obtained.
    */
    STATIC void
        qla2100_isr(scsi_qla_host_t *ha, srb_t **done_q_first, srb_t **done_q_last) {
        device_reg_t *reg = ha->iobase;
        response_t   *pkt, response_entry;
        srb_t        *sp;
        uint16_t     mailbox[MAILBOX_REGISTER_COUNT];
        uint16_t     *wptr;
        uint32_t     index, *dptr1, *dptr2;

#ifdef QL_DEBUG_LEVEL_3
        /* ENTER("qla2100_isr: entered\n"); */
#endif

        /* Check for mailbox interrupt. */
        mailbox[0] = RD_REG_WORD(&reg->semaphore);
        if( mailbox[0] & BIT_0 ) {
            WRT_REG_WORD(&reg->host_cmd, HC_CLR_RISC_INT);

            /* Get mailbox data. */
            wptr = &mailbox[0];
            *wptr++ = qla2100_debounce_register(&reg->mailbox0);
            *wptr++ = RD_REG_WORD(&reg->mailbox1);
            *wptr = RD_REG_WORD(&reg->mailbox2);
            if( mailbox[0] != MBA_SCSI_COMPLETION ) {
#ifdef QL_DEBUG_LEVEL_5
                qla2100_print("qla2100_isr: Saving mailbox data\n");
#endif
                wptr++;
                *wptr++ = RD_REG_WORD(&reg->mailbox3);
                *wptr++ = qla2100_debounce_register(&reg->mailbox4);
                *wptr++ = qla2100_debounce_register(&reg->mailbox5);
                *wptr++ = RD_REG_WORD(&reg->mailbox6);
                *wptr   = RD_REG_WORD(&reg->mailbox7);
            }

            /* Release mailbox registers. */
            WRT_REG_WORD(&reg->semaphore, 0);

#ifdef QL_DEBUG_LEVEL_5
            qla2100_print("qla2100_isr: mailbox interrupt mailbox[0] = ");
            qla2100_output_number((u_long)mailbox[0], 16);
            qla2100_print("\n");
#endif

            /* Handle asynchronous event */

            switch( mailbox[0] ) {
            case MBA_SCSI_COMPLETION:   /* Response completion */
#ifdef QL_DEBUG_LEVEL_5
                qla2100_print("qla2100_isr: mailbox response completion\n");
#endif
                if( ha->flags.online ) {
                    /* Get outstanding command index. */
                    index = (uint32_t)(mailbox[2] << 16 | mailbox[1]);

                    /* Validate handle. */
                    if( index < MAX_OUTSTANDING_COMMANDS )
                        sp = ha->outstanding_cmds[index];
                    else
                        sp = 0;

                    if( sp ) {
                        /* Free outstanding command slot. */
                        ha->outstanding_cmds[index] = 0;

                        /* Save ISP completion status */
                        CMD_RESULT(sp->cmd) = DID_OK;

                        /* Place block on done queue */
                        sp->s_next = NULL;
                        sp->s_prev = *done_q_last;
                        if( !(*done_q_first) )
                            *done_q_first = sp;
                        else
                            (*done_q_last)->s_next = sp;
                        *done_q_last = sp;
                    } else {
#ifdef QL_DEBUG_LEVEL_2
                        qla2100_print("qla2100_isr: ISP invalid handle\n");
#endif
                        printk(KERN_WARNING "qla2100: ISP invalid handle");
                        ha->flags.isp_abort_needed = TRUE;
                    }
                }
                break;
            case MBA_RESET:                 /* Reset */
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print("qla2100_isr: asynchronous RESET\n");
#endif
                ha->flags.reset_marker = TRUE;
                break;
            case MBA_SYSTEM_ERR:        /* System Error */
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print("qla2100_isr: ISP System Error - mbx1=");
                qla2100_output_number((u_long)mailbox[1], 16);
                qla2100_print(", mbx2=");
                qla2100_output_number((u_long)mailbox[2], 16);
                qla2100_print(", mbx3=");
                qla2100_output_number((u_long)mailbox[3], 16);
                qla2100_print("\n");
#endif
                printk(KERN_WARNING
                    "!qla2100_isr: ISP System Error - mbx1=%xh, mbx2=%xh, mbx3=%xh",
                    mailbox[1], mailbox[2], mailbox[3]);
                ha->flags.isp_abort_needed = TRUE;
                break;
            case MBA_REQ_TRANSFER_ERR:  /* Request Transfer Error */
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print("qla2100_isr: ISP Request Transfer Error\n");
#endif
                printk(KERN_WARNING "qla2100: ISP Request Transfer Error\n");
                ha->flags.isp_abort_needed = TRUE;
                break;
            case MBA_RSP_TRANSFER_ERR:  /* Response Transfer Error */
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print("qla2100_isr: ISP Response Transfer Error\n");
#endif
                printk(KERN_WARNING "qla2100: ISP Response Transfer Error\n");
                ha->flags.isp_abort_needed = TRUE;
                break;
            case MBA_WAKEUP_THRES:      /* Request Queue Wake-up */
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print("qla2100_isr: asynchronous WAKEUP_THRES\n");
#endif
                break;
            case MBA_LIP_OCCURRED:      /* Loop Initialization Procedure */
                printk("scsi(%d): LIP occurred.\n",(int)ha->host_no);
                /* occurred. */
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print(
                    "qla2100_isr: asynchronous MBA_LIP_OCCURRED\n");
#endif
                /* Save LIP sequence. */
                ha->lip_seq = mailbox[1];
                if( ha->loop_state != LOOP_DOWN ) {
                    ha->loop_state = LOOP_DOWN;
                    ha->loop_down_timer = LOOP_DOWN_TIME;
                }
                break;
            case MBA_LOOP_UP:
                printk("scsi(%d): LOOP UP detected\n",(int)ha->host_no);
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print("qla2100_isr: asynchronous MBA_LOOP_UP\n");
#endif
#if 0 
                    if( ha->operating_mode == P2P )
                    ha->min_external_loopid = 0;
                else {
                    ha->operating_mode = LOOP;
                    ha->min_external_loopid = SNS_FIRST_LOOP_ID;
                }
#endif

                ha->loop_state = LOOP_UP;
                break;
            case MBA_LOOP_DOWN:
                printk("scsi(%d): LOOP DOWN detected\n",(int)ha->host_no);
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print("qla2100_isr: asynchronous MBA_LOOP_DOWN\n");
#endif
                if( ha->loop_state != LOOP_DOWN ) {
                    ha->loop_state = LOOP_DOWN;
                    ha->loop_down_timer = LOOP_DOWN_TIME;
                }
                break;
            case MBA_LIP_RESET:         /* LIP reset occurred. */
                printk("scsi(%d): LIP reset occurred\n",(int)ha->host_no);
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print(
                    "qla2100_isr: asynchronous MBA_LIP_RESET\n");
#endif
                ha->flags.reset_marker = TRUE;
                ha->loop_down_timer = LOOP_DOWN_TIME;
                ha->loop_state = LOOP_DOWN;
                ha->operating_mode = LOOP;
                break;
            case MBA_LINK_MODE_UP:      /* Link mode up. */
                DEBUG(printk("scsi(%d): Link node is up\n",(int)ha->host_no);)
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print(
                    "qla2100_isr: asynchronous MBA_LINK_MODE_UP\n");
#endif
                break;
            case MBA_UPDATE_CONFIG:      /* Update Configuration. */
                printk("scsi(%d): Configuration change detected: value %d.\n",(int)ha->host_no,mailbox[1]);
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print(
                    "qla2100_isr: asynchronous MBA_UPDATE_CONFIG\n");
#endif
                if( mailbox[1] == FSTATE_P2P_CHOOSE_LOOP ) {
                    printk("scsi(%d): Switch to loop topology\n",(int)ha->host_no);
                    ha->operating_mode = LOOP;
                    ha->min_external_loopid = SNS_FIRST_LOOP_ID;
                }   
                ha->flags.update_config_needed = 1;
                break;
            case MBA_PORT_UPDATE:       /* Port database update occurred. */
                DEBUG(printk("scsi(%d): Port database changed\n",(int)ha->host_no);)
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print(
                    "qla2100_isr: asynchronous MBA_PORT_UPDATE\n");
#endif
                ha->loop_down_timer = 0; 
                ha->flags.loop_resync_needed = TRUE;
                ha->loop_state = LOOP_UPDATE;
                break;
            case MBA_SCR_UPDATE:        /* State Change Registration. */
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print(
                    "qla2100_isr: asynchronous MBA_SCR_UPDATE\n");
#endif
                ha->loop_down_timer = 0;
                ha->flags.loop_resync_needed = TRUE;
                ha->loop_state = LOOP_UPDATE;
                break;
            case MBA_CTIO_COMPLETION:
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print(
                    "qla2100_isr: asynchronous MBA_CTIO_COMPLETION\n");
#endif
                break;
            default:
                if( mailbox[0] < MBA_ASYNC_EVENT ) {
                    wptr = &mailbox[0];
                    ha->mailbox_out[0] = *wptr++;
                    ha->mailbox_out[1] = *wptr++;
                    ha->mailbox_out[2] = *wptr++;
                    ha->mailbox_out[3] = *wptr++;
                    ha->mailbox_out[4] = *wptr++;
                    ha->mailbox_out[5] = *wptr++;
                    ha->mailbox_out[6] = *wptr++;
                    ha->mailbox_out[7] = *wptr;
                    ha->flags.mbox_int = TRUE;
#ifdef QL_DEBUG_LEVEL_5
                    qla2100_print("qla2100_isr: Returning mailbox data\n");
#endif
                }
                break;
            }
        } else {
            mailbox[5] = qla2100_debounce_register(&reg->mailbox5);
            WRT_REG_WORD(&reg->host_cmd, HC_CLR_RISC_INT);

            /*
            * Response ring
            */
            if( ha->flags.online && !ha->flags.mbox_busy ) {
                if( mailbox[5] < RESPONSE_ENTRY_CNT ) {
                    while( ha->rsp_ring_index != mailbox[5] ) {
                        pkt = ha->response_ring_ptr;

#ifdef QL_DEBUG_LEVEL_5
                        qla2100_print("qla2100_isr: ha->rsp_ring_index = ");
                        qla2100_output_number((u_long)ha->rsp_ring_index, 16);
                        qla2100_print(" mailbox[5] = ");
                        qla2100_output_number((u_long)mailbox[5], 16);
                        qla2100_print("\nqla2100_isr: response packet data\n");
                        qla2100_dump_buffer((uint8_t *)pkt, RESPONSE_ENTRY_SIZE);
#endif

#if defined(QL_DEBUG_LEVEL_2) && !defined(QL_DEBUG_LEVEL_5) 
                        if( pkt->entry_type == STATUS_TYPE ) {
                            if( (uint8_t)(pkt->scsi_status) || pkt->comp_status ||
                                pkt->entry_status ) {
                                qla2100_print("Status type:\n\r");
                                qla2100_print(
                                    "qla2100_isr: ha->rsp_ring_index = ");
                                qla2100_output_number((u_long)
                                    ha->rsp_ring_index, 16);
                                qla2100_print(" mailbox[5] = ");
                                qla2100_output_number((u_long)mailbox[5], 16);
                                qla2100_print(
                                    "\nqla2100_isr: response packet data\n");
                                qla2100_dump_buffer((uint8_t *)pkt,
                                    RESPONSE_ENTRY_SIZE);
                            }
                        } else {
                            qla2100_print("qla2100_isr: ha->rsp_ring_index = ");
                            qla2100_output_number((u_long)ha->rsp_ring_index,
                                16);
                            qla2100_print(" mailbox[5] = ");
                            qla2100_output_number((u_long)mailbox[5], 16);
                            qla2100_print(
                                "\nqla2100_isr: response packet data\n");
                            qla2100_dump_buffer((uint8_t *)pkt,
                                RESPONSE_ENTRY_SIZE);
                        }
#endif
                        if( pkt->entry_type == STATUS_TYPE || pkt->entry_status ) {
                            if( pkt->entry_type == STATUS_TYPE )
                                qla2100_status_entry(ha, (sts_entry_t *)pkt,
                                    done_q_first, done_q_last);
                            else
                                qla2100_error_entry(ha, pkt,
                                    done_q_first, done_q_last);

                            /* Adjust ring index. */
                            ha->rsp_ring_index++;
                            if( ha->rsp_ring_index == RESPONSE_ENTRY_CNT ) {
                                ha->rsp_ring_index = 0;
                                ha->response_ring_ptr = ha->response_ring;
                            } else
                                ha->response_ring_ptr++;
                            WRT_REG_WORD(&reg->mailbox5, ha->rsp_ring_index);
                        } else {
                            pkt = &response_entry;

                            /* Copy packet. */
                            dptr1 = (uint32_t *)ha->response_ring_ptr;
                            dptr2 = (uint32_t *)pkt;
                            for( index = 0; index < RESPONSE_ENTRY_SIZE/4;
                                index++ )
                                *dptr2++ = *dptr1++;

                            /* Adjust ring index. */
                            ha->rsp_ring_index++;
                            if( ha->rsp_ring_index == RESPONSE_ENTRY_CNT ) {
                                ha->rsp_ring_index = 0;
                                ha->response_ring_ptr = ha->response_ring;
                            } else
                                ha->response_ring_ptr++;
                            WRT_REG_WORD(&reg->mailbox5, ha->rsp_ring_index);

                            /* Release interrupt specific lock */
                            QLA2100_INTR_UNLOCK(ha);

#if QLA2100_TARGET_MODE_SUPPORT
                            switch( pkt->entry_type ) {
                            case ACCEPT_TGT_IO_TYPE:
                                qla2100_atio_entry(ha, (atio_entry_t *)pkt);
                                break;
                            case IMMED_NOTIFY_TYPE:
                                qla2100_notify_ack(ha, (notify_entry_t *)pkt);
                                break;
                            default:
                                break;
                            }
#endif

                            /* Acquire interrupt specific lock */
                            QLA2100_INTR_LOCK(ha);
                        }
                    }
                } else {
                    ha->flags.isp_abort_needed = TRUE;
#ifdef QL_DEBUG_LEVEL_2
                    qla2100_print("qla2100_isr: Response pointer Error\n");
#endif
                }
            }
        }

#ifdef QL_DEBUG_LEVEL_3
        /* LEAVE("qla2100_isr"); */
#endif
    }



    /*
    *  qla2100_rst_aen
    *      Processes asynchronous reset.
    *
    * Input:
    *      ha  = adapter block pointer.
    */
    STATIC void
        qla2100_rst_aen(scsi_qla_host_t *ha) {
#if QL2100_TARGET_MODE_SUPPORT
        notify_entry_t nentry;
#endif /* QL2100_TARGET_MODE_SUPPORT */

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_rst_aen");
#endif

        if( ha->flags.online && !ha->flags.reset_active &&
            !ha->loop_down_timer && !ha->flags.abort_isp_active ) {
            ha->flags.reset_active = TRUE;
            do {
                ha->flags.reset_marker = FALSE;

                /* Issue marker command. */
                qla2100_marker(ha, 0, 0, 0, MK_SYNC_ALL);

#if QL2100_TARGET_MODE_SUPPORT
                if( !ha->loop_down_timer && !ha->flags.reset_marker ) {
                    /* Issue notify acknowledgement command. */
                    BZERO((caddr_t)&nentry, sizeof(notify_entry_t));
                    nentry.initiator_id = ha->id;
                    /* dg 7/3/99 nentry.target_id = ha->id; */
                    nentry.task_flags = BIT_13;
                    qla2100_notify_ack(ha, &nentry);
                }
#endif /* QL2100_TARGET_MODE_SUPPORT */
            }while( !ha->loop_down_timer && ha->flags.reset_marker );
            ha->flags.reset_active = FALSE;
        }

#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_rst_aen");
#endif
    }

#if  QLA2100_TARGET_MODE_SUPPORT 
    /*
    *  qla2100_atio_entry
    *      Processes received ISP accept target I/O entry.
    *
    * Input:
    *      ha  = adapter block pointer.
    *      pkt = entry pointer.
    */
    STATIC void
        qla2100_atio_entry(scsi_qla_host_t *ha, atio_entry_t *pkt) {
        uint64_t  *a64;
        uint64_t  *end_a64;
        u_long    phy_addr[2];
        u_long    end_addr[2];
        uint32_t  len;
        uint32_t  offset;
        uint8_t   t;
        uint8_t   *sense_ptr;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_atio_entry: entered\n");
#endif

        t = pkt->initiator_id;
        sense_ptr = ha->tsense + t * TARGET_SENSE_SIZE;
        a64 = (uint64_t *)&phy_addr[0];
        end_a64 = (uint64_t *)&end_addr[0];

        switch( pkt->status & ~BIT_7 ) {
        case 7:                         /* Path invalid */
#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
            qla2100_print("qla2100_atio_entry: Path invalid\n");
#endif
            break;
        case 0x16:                  /* Requested Capability Not Available */
#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
            qla2100_print(
                "qla2100_atio_entry: Requested Capability Not Available\n");
#endif
            break;
        case 0x17:                  /* Bus Device Reset Message Received */
#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
            qla2100_print(
                "qla2100_atio_entry: Bus Device Reset Message Received\n");
#endif
            break;
        case 0x3D:                  /* CDB Received */

            /* Check for invalid LUN */
            if( pkt->lun && pkt->cdb[0] != SS_INQUIR &&
                pkt->cdb[0] != SS_REQSEN )
                pkt->cdb[0] = SS_TEST;

            switch( pkt->cdb[0] ) {
            case SS_TEST:
#ifdef QL_DEBUG_LEVEL_3
                qla2100_print("qla2100_atio_entry: SS_TEST\n");
#endif
                BZERO(sense_ptr, TARGET_SENSE_SIZE);
                len = 0;
                if( pkt->lun == 0 )
                    pkt->scsi_status = S_GOOD;
                else {
                    *sense_ptr = 0x70;
                    *(sense_ptr+2) = SD_ILLREQ;
                    *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
                    *(sense_ptr+12) = SC_INVLUN;
                    pkt->scsi_status = S_CKCON;
                }
                pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC | OF_NO_DATA);
                break;
            case SS_REQSEN:
#ifdef QL_DEBUG_LEVEL_3
                qla2100_print("qla2100_atio_entry: SS_REQSEN\n");
#endif
                phy_addr[0] = ha->tsense_dma;
                phy_addr[1] = 0;
                *a64 += t * TARGET_SENSE_SIZE;
                if( pkt->cdb[4] > TARGET_SENSE_SIZE )
                    len = TARGET_SENSE_SIZE;
                else
                    len = pkt->cdb[4];
                pkt->scsi_status = S_GOOD;
                pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC | OF_DATA_IN);
                break;
            case SS_INQUIR:
#ifdef QL_DEBUG_LEVEL_3
                qla2100_print("qla2100_atio_entry: SS_INQUIR\n");
#endif
                BZERO(sense_ptr, TARGET_SENSE_SIZE);
                phy_addr[0] = ha->tbuf_dma;
                phy_addr[1] = 0;
                *a64 += TARGET_INQ_OFFSET;

                if( pkt->lun == 0 ) {
                    ha->tbuf->inq.id_type = ID_PROCESOR;
                    ha->tbuf->inq.id_pqual = ID_QOK;
                } else {
                    ha->tbuf->inq.id_type = ID_NODEV;
                    ha->tbuf->inq.id_pqual = ID_QNOLU;
                }

                if( pkt->cdb[4] > sizeof(struct ident) )
                    len = sizeof(struct ident);
                else
                    len = pkt->cdb[4];
                pkt->scsi_status = S_GOOD;
                pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC | OF_DATA_IN);
                break;
            case SM_WRDB:
                BZERO(sense_ptr, TARGET_SENSE_SIZE);
                offset = pkt->cdb[5];
                offset |= pkt->cdb[4] << 8;
                offset |= pkt->cdb[3] << 16;
                len = pkt->cdb[8];
                len |= pkt->cdb[7] << 8;
                len |= pkt->cdb[6] << 16;
                end_addr[0] = phy_addr[0] = ha->tbuf_dma;
                end_addr[1] = phy_addr[1] = 0;
                *end_a64 += TARGET_DATA_OFFSET + TARGET_DATA_SIZE;
                switch( pkt->cdb[1] & 7 ) {
                case RW_BUF_HDATA:
#ifdef QL_DEBUG_LEVEL_3
                    qla2100_print("qla2100_atio_entry: SM_WRDB, RW_BUF_HDATA\n");
#endif
                    if( len > TARGET_DATA_SIZE + 4 ) {
#ifdef QL_DEBUG_LEVEL_2
                        qla2100_print("qla2100_atio_entry: SM_WRDB, length > buffer size\n");
#endif
                        *sense_ptr = 0x70;
                        *(sense_ptr+2) = SD_ILLREQ;
                        *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
                        *(sense_ptr+12) = SC_ILLCDB;
                        pkt->scsi_status = S_CKCON;
                        pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC |
                            OF_NO_DATA);
                        len = 0;
                    } else if( len ) {
                        pkt->scsi_status = S_GOOD;
                        pkt->flags =(uint16_t)(OF_SSTS | OF_INC_RC |
                            OF_DATA_OUT);
                    } else {
#ifdef QL_DEBUG_LEVEL_2
                        qla2100_print("qla2100_atio_entry: SM_WRDB, zero length\n");
#endif
                        pkt->scsi_status = S_GOOD;
                        pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC |
                            OF_NO_DATA);
                    }

                    break;
                case RW_BUF_DATA:
#ifdef QL_DEBUG_LEVEL_3
                    qla2100_print("qla2100_atio_entry: SM_WRDB, RW_BUF_DATA\n");
#endif
                    *a64 += offset + TARGET_DATA_OFFSET;
                    if( pkt->cdb[2] != 0 || *a64 >= *end_a64 ||
                        *a64 + len > *end_a64 ) {
#ifdef QL_DEBUG_LEVEL_2
                        qla2100_print("qla2100_atio_entry: SM_WRDB, RW_BUF_DATA BAD\n");
                        qla2100_print("buf_id=");
                        qla2100_output_number((u_long)pkt->cdb[2], 16);
                        qla2100_print(", offset=");
                        qla2100_output_number((u_long)offset, 16);
                        qla2100_print(", length=");
                        qla2100_output_number((u_long)len, 16);
                        qla2100_print("\n");
#endif
                        *sense_ptr = 0x70;
                        *(sense_ptr+2) = SD_ILLREQ;
                        *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
                        *(sense_ptr+12) = SC_ILLCDB;
                        len = 0;
                        pkt->scsi_status = S_CKCON;
                        pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC |
                            OF_NO_DATA);
                    } else if( len ) {
                        pkt->scsi_status = S_GOOD;
                        pkt->flags =(uint16_t)(OF_SSTS | OF_INC_RC |
                            OF_DATA_OUT);
                    } else {
#ifdef QL_DEBUG_LEVEL_2
                        qla2100_print("qla2100_atio_entry: SM_WRDB, zero length\n");
#endif
                        pkt->scsi_status = S_GOOD;
                        pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC |
                            OF_NO_DATA);
                    }
                    break;
                default:
#ifdef QL_DEBUG_LEVEL_2
                    qla2100_print("qla2100_atio_entry: SM_WRDB unknown mode\n");
#endif
                    *sense_ptr = 0x70;
                    *(sense_ptr+2) = SD_ILLREQ;
                    *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
                    *(sense_ptr+12) = SC_ILLCDB;
                    len = 0;
                    pkt->scsi_status = S_CKCON;
                    pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC |
                        OF_NO_DATA);
                    break;
                }
                break;
            case SM_RDDB:
                BZERO(sense_ptr, TARGET_SENSE_SIZE);
                offset = pkt->cdb[5];
                offset |= pkt->cdb[4] << 8;
                offset |= pkt->cdb[3] << 16;
                len = pkt->cdb[8];
                len |= pkt->cdb[7] << 8;
                len |= pkt->cdb[6] << 16;
                end_addr[0] = phy_addr[0] = ha->tbuf_dma;
                end_addr[1] = phy_addr[1] = 0;
                *end_a64 += TARGET_DATA_OFFSET + TARGET_DATA_SIZE;
                switch( pkt->cdb[1] & 7 ) {
                case RW_BUF_HDATA:
#ifdef QL_DEBUG_LEVEL_3
                    qla2100_print("qla2100_atio_entry: SM_RDDB, RW_BUF_HDATA\n");
#endif
                    if( len ) {
                        ha->tbuf->hdr[0] = 0;
                        ha->tbuf->hdr[1] =
                            (uint8_t)(TARGET_DATA_SIZE >> 16);
                        ha->tbuf->hdr[2] =
                            (uint8_t)(TARGET_DATA_SIZE >> 8);
                        ha->tbuf->hdr[3] = (uint8_t)TARGET_DATA_SIZE;
                        if( len > TARGET_DATA_SIZE + 4 )
                            len = TARGET_DATA_SIZE + 4;
                        pkt->scsi_status = S_GOOD;
                        pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC |
                            OF_DATA_IN);
                    } else {
#ifdef QL_DEBUG_LEVEL_2
                        qla2100_print("qla2100_atio_entry: SM_RDDB, zero length\n");
#endif
                        pkt->scsi_status = S_GOOD;
                        pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC |
                            OF_NO_DATA);
                    }
                    break;
                case RW_BUF_DATA:
#ifdef QL_DEBUG_LEVEL_3
                    qla2100_print("qla2100_atio_entry: SM_RDDB, RW_BUF_DATA\n");
#endif
                    *a64 += offset + TARGET_DATA_OFFSET;
                    if( pkt->cdb[2] != 0 || *a64 >= *end_a64 ) {
#ifdef QL_DEBUG_LEVEL_2
                        qla2100_print("qla2100_atio_entry: SM_RDDB, RW_BUF_DATA BAD\n");
                        qla2100_print("buf_id=");
                        qla2100_output_number((u_long)pkt->cdb[2], 16);
                        qla2100_print(", offset=");
                        qla2100_output_number((u_long)offset, 16);
                        qla2100_print("\n");
#endif
                        *sense_ptr = 0x70;
                        *(sense_ptr+2) = SD_ILLREQ;
                        *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
                        *(sense_ptr+12) = SC_ILLCDB;
                        len = 0;
                        pkt->scsi_status = S_CKCON;
                        pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC |
                            OF_NO_DATA);
                    } else {
                        if( *a64 + len > *end_a64 )
                            len = *end_a64 - *a64;
                        if( len ) {
                            pkt->scsi_status = S_GOOD;
                            pkt->flags = (uint16_t)(OF_SSTS |
                                OF_INC_RC | OF_DATA_IN);
                        } else {
#ifdef QL_DEBUG_LEVEL_2
                            qla2100_print("qla2100_atio_entry: SM_RDDB, zero length\n");
#endif
                            pkt->scsi_status = S_GOOD;
                            pkt->flags = (uint16_t)(OF_SSTS |
                                OF_INC_RC | OF_NO_DATA);
                        }
                    }
                    break;
                case RW_BUF_DESC:
#ifdef QL_DEBUG_LEVEL_3
                    qla2100_print("qla2100_atio_entry: SM_RDDB, RW_BUF_DESC\n");
#endif
                    if( len ) {
                        if( len > 4 )
                            len = 4;

                        ha->tbuf->hdr[0] = 0;
                        if( pkt->cdb[2] != 0 ) {
                            ha->tbuf->hdr[1] = 0;
                            ha->tbuf->hdr[2] = 0;
                            ha->tbuf->hdr[3] = 0;
                        } else {
                            ha->tbuf->hdr[1] =
                                (uint8_t)(TARGET_DATA_SIZE >> 16);
                            ha->tbuf->hdr[2] =
                                (uint8_t)(TARGET_DATA_SIZE >> 8);
                            ha->tbuf->hdr[3] =
                                (uint8_t)TARGET_DATA_SIZE;
                        }
                        pkt->scsi_status = S_GOOD;
                        pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC |
                            OF_DATA_IN);
                    } else {
#ifdef QL_DEBUG_LEVEL_2
                        qla2100_print("qla2100_atio_entry: SM_RDDB, zero length\n");
#endif
                        pkt->scsi_status = S_GOOD;
                        pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC |
                            OF_NO_DATA);
                    }
                    break;
                default:
#ifdef QL_DEBUG_LEVEL_2
                    qla2100_print("qla2100_atio_entry: SM_RDDB unknown mode\n");
#endif
                    *sense_ptr = 0x70;
                    *(sense_ptr+2) = SD_ILLREQ;
                    *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
                    *(sense_ptr+12) = SC_ILLCDB;
                    len = 0;
                    pkt->scsi_status = S_CKCON;
                    pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC |
                        OF_NO_DATA);
                    break;
                }
                break;
            default:
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print("qla2100_atio_entry: Unknown SCSI command\n");
                qla2100_dump_buffer((uint8_t *)&pkt->cdb[0], MAX_CMDSZ);
#endif
                BZERO(sense_ptr, TARGET_SENSE_SIZE);
                *sense_ptr = 0x70;
                *(sense_ptr+2) = SD_ILLREQ;
                *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
                *(sense_ptr+12) = SC_INVOPCODE;
                len = 0;
                pkt->scsi_status = S_CKCON;
                pkt->flags = (uint16_t)(OF_SSTS | OF_INC_RC | OF_NO_DATA);
                break;
            }
            if( ha->flags.enable_64bit_addressing )
                qla2100_64bit_continue_io(ha, pkt, len, &phy_addr);
            else
                qla2100_32bit_continue_io(ha, pkt, len, &phy_addr);
            break;
        default:
            break;
        }

#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_atio_entry: exiting normally\n");
#endif
    }
#endif  /* QLA2100_TARGET_MODE_SUPPORT */

    /*
    *  qla2100_status_entry
    *      Processes received ISP status entry.
    *
    * Input:
    *      ha           = adapter block pointer.
    *      pkt          = entry pointer.
    *      done_q_first = done queue first pointer.
    *      done_q_last  = done queue last pointer.
    */
    STATIC void
        qla2100_status_entry(scsi_qla_host_t *ha, sts_entry_t *pkt, srb_t **done_q_first,
        srb_t **done_q_last) {
        uint32_t       b, t, l;
        uint8_t        sense_sz = 0;
        srb_t          *sp, *sp2;
        scsi_lu_t      *q;
        Scsi_Cmnd       *cp;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_status_entry");
#endif

        /* Validate handle. */
        if( pkt->handle < MAX_OUTSTANDING_COMMANDS )
            sp = ha->outstanding_cmds[pkt->handle];
        else
            sp = 0;

        if( sp ) {
            /* Free outstanding command slot. */
            ha->outstanding_cmds[pkt->handle] = 0;
            cp = sp->cmd;
            sp->ccode = pkt->comp_status;

            /* Generate LU queue on cntrl, target, LUN */
            b = SCSI_BUS_32(cp);
            t = SCSI_TCN_32(cp);
            l = SCSI_LUN_32(cp);
            q = GET_LU_Q(ha, b, t, l);

            /* Target busy */
            if( pkt->scsi_status & SS_BUSY_CONDITION &&
                (uint8_t)pkt->scsi_status != SS_RESERVE_CONFLICT ) {
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print("qla2100_status_entry: SCSI busy status, scsi(");
                qla2100_output_number((u_long)ha->host_no, 10);
                qla2100_print(":");
                qla2100_output_number((u_long)b, 10);
                qla2100_print(":");
                qla2100_output_number((u_long)t, 10);
                qla2100_print(":");
                qla2100_output_number((u_long)l, 10);
                qla2100_print(")\n");
#endif
                sp->retry_count--;
                CMD_RESULT(cp) = (int) (DID_BUS_BUSY << 16) |
                    (pkt->scsi_status & 0xff);

            } else if( ha->loop_down_timer ) {
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print("scsi(");
                qla2100_output_number((u_long)ha->host_no, 10);
                qla2100_print(":");
                qla2100_output_number((u_long)b, 10);
                qla2100_print(":");
                qla2100_output_number((u_long)t, 10);
                qla2100_print(":");
                qla2100_output_number((u_long)l, 10);
                qla2100_print("): Loop Not ready - pid =");
                qla2100_output_number((u_long)sp->cmd->pid, 16);
                qla2100_print("\n");
#endif
                /* Set retry status. */
                /* sp->retry_count--; */
                CMD_RESULT(cp) = (int) (DID_BUS_BUSY << 16);
            } else if( sp->port_down_retry_count > 1 &&
                (pkt->comp_status == CS_PORT_UNAVAILABLE ||
                pkt->comp_status == CS_PORT_LOGGED_OUT ||
                pkt->comp_status == CS_PORT_CONFIG_CHG ||
                pkt->comp_status == CS_PORT_BUSY) ) {   
                /* if the port is unavaliable and we haven't exceeded the port down count */
                /* then send command back to the mid-level. */
#ifdef QL_DEBUG_LEVEL_2
                qla2100_print("scsi(");
                qla2100_output_number((u_long)ha->host_no, 10);
                qla2100_print(":");
                qla2100_output_number((u_long)b, 10);
                qla2100_print(":");
                qla2100_output_number((u_long)t, 10);
                qla2100_print(":");
                qla2100_output_number((u_long)l, 10);
                qla2100_print("): Port Down Retry (");
                qla2100_output_number((u_long)sp->port_down_retry_count, 10);
                qla2100_print("): , pid =");
                qla2100_output_number((u_long)sp->cmd->pid, 16);
                qla2100_print(", status =");
                qla2100_output_number((u_long)pkt->comp_status, 16);
                qla2100_print("\n");
#endif
                sp->port_down_retry_count--;

                /* Set retry status. */
                /* dg 08/17/99 
                * Force the SCSI layer to keep retrying until our
                * port_down_retry_count expire. They will normally
                * try and reset the bus after half the retries 
                * have completed, so double the count.
                */
                sp->cmd->allowed = ha->port_down_retry_count * 2;
                CMD_RESULT(sp->cmd) = DID_RETRY << 16;
                /* delete 8/17 CMD_RESULT(cp) = (int) (DID_BUS_BUSY << 16); */

                /* Acquire target queue lock */

                if( !(q->q_flag & QLA2100_QSUSP) ) {
                    q->q_flag |= QLA2100_QSUSP;  /* suspend starting new commands */

                    /* Decrement port down count on all pending commands. */
                    /* and return them back to OS.                        */
                    for( sp2 = q->q_first; sp2; sp2 = sp2->s_next ) {
                        if( sp2->port_down_retry_count )
                            sp2->port_down_retry_count--;
                        /* dg 08/17/99  */
                        CMD_RESULT(sp2->cmd) = DID_RETRY << 16;
                        qla2100_callback(ha,sp2, TRUE);
                    }
                    q->q_first = q->q_last = NULL;

                    /* if port timer is not active then start it */
                    if( !ha->queue_restart_timer ) {
                        ha->queue_restart_timer = PORT_RETRY_TIME;
                    }
                }

                /* Release LU queue specific lock */
            } else {
#ifdef QL_DEBUG_LEVEL_2
                if( pkt->comp_status ) {
                    qla2100_print(
                        "qla2100_status_entry: Compl error = ");
                    qla2100_output_number((u_long)pkt->comp_status, 16);
                    qla2100_print(", scsi(");
                    qla2100_output_number((u_long)ha->host_no, 10);
                    qla2100_print(":");
                    qla2100_output_number((u_long)b, 10);
                    qla2100_print(":");
                    qla2100_output_number((u_long)t, 10);
                    qla2100_print(":");
                    qla2100_output_number((u_long)l, 10);
                    qla2100_print("), retry count= ");
                    qla2100_output_number((u_long)sp->port_down_retry_count, 10);
                    qla2100_print(", pid = ");
                    qla2100_output_number((u_long)cp->pid, 16);
                    qla2100_print("\n");
                }
#endif
                /* Set ISP completion status and arget status byte. */
                CMD_RESULT(cp) = qla2100_return_status(pkt, cp);

                memset((caddr_t)cp->sense_buffer, 0,sizeof(cp->sense_buffer));
                if( pkt->scsi_status & SS_CHECK_CONDITION ) {
                    /* Mid-level always zero sense buffer before giving it to us */
                    if( pkt->scsi_status & SS_SENSE_LEN_VALID ) {
                        if( pkt->req_sense_length < CMD_SNSLEN(cp) )
                            sense_sz = pkt->req_sense_length;
                        else
                            sense_sz = CMD_SNSLEN(cp) - 1;

                        BCOPY((caddr_t)&pkt->req_sense_data, cp->sense_buffer, sense_sz);

                    }

#ifdef QL_DEBUG_LEVEL_2
                    qla2100_print(
                        "qla2100_status_entry: Check condition Sense data, scsi(");
                    qla2100_output_number((u_long)ha->host_no, 10);
                    qla2100_print(":");
                    qla2100_output_number((u_long)b, 10);
                    qla2100_print(":");
                    qla2100_output_number((u_long)t, 10);
                    qla2100_print(":");
                    qla2100_output_number((u_long)l, 10);
                    qla2100_print(")\n");
                    if( sense_sz )
                        qla2100_dump_buffer(cp->sense_buffer, sense_sz);
#endif
                }
            }
            /* Place command on done queue. */
            qla2100_done_q_put(sp, done_q_first, done_q_last);
        } else {
#ifdef QL_DEBUG_LEVEL_2
            qla2100_print("qla2100_status_entry: ISP Invalid handle\n");
#endif
            printk(KERN_WARNING "!qla2100: Status Entry invalid handle");
            ha->flags.isp_abort_needed = TRUE;
        }
#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_status_entry");
#endif
    }

    /*
    *  qla2100_error_entry
    *      Processes error entry.
    *
    * Input:
    *      ha           = adapter block pointer.
    *      pkt          = entry pointer.
    *      done_q_first = done queue first pointer.
    *      done_q_last  = done queue last pointer.
    */
    STATIC void
        qla2100_error_entry(scsi_qla_host_t *ha, response_t *pkt, srb_t **done_q_first,
        srb_t **done_q_last) {
        srb_t *sp;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_error_entry");
#endif

#ifdef QL_DEBUG_LEVEL_2
        if( pkt->entry_status & BIT_5 )
            qla2100_print("qla2100_error_entry: Invalid Entry Order\n");
        else if( pkt->entry_status & BIT_4 )
            qla2100_print("qla2100_error_entry: Invalid Entry Count\n");
        else if( pkt->entry_status & BIT_3 )
            qla2100_print("qla2100_error_entry: Invalid Entry Parameter\n");
        else if( pkt->entry_status & BIT_2 )
            qla2100_print("qla2100_error_entry: Invalid Entry Type\n");
        else if( pkt->entry_status & BIT_1 )
            qla2100_print("qla2100_error_entry: Busy\n");
        else
            qla2100_print("qla2100_error_entry: UNKNOWN flag error\n");
#endif

        /* Validate handle. */
        if( pkt->handle < MAX_OUTSTANDING_COMMANDS )
            sp = ha->outstanding_cmds[pkt->handle];
        else
            sp = 0;

        if( sp ) {
            /* Free outstanding command slot. */
            ha->outstanding_cmds[pkt->handle] = 0;

            /* Bad payload or header */
            if( pkt->entry_status & (BIT_5 + BIT_4 + BIT_3 + BIT_2) ) {
                /* Bad payload or header, set error status. */
                CMD_RESULT(sp->cmd) = (int) DID_ERROR << 16;

            } else if( pkt->entry_status & BIT_1 && sp->retry_count ) /* FULL flag */
            {
                sp->retry_count--;
                CMD_RESULT(sp->cmd) = (int) DID_BUS_BUSY << 16;
            } else {
                /* Set error status. */
                CMD_RESULT(sp->cmd) =(int)  DID_ERROR << 16;
            }
            /* Place command on done queue. */
            qla2100_done_q_put(sp, done_q_first, done_q_last);
        } else if( pkt->entry_type == COMMAND_A64_TYPE ||
            pkt->entry_type == COMMAND_TYPE ) {
#ifdef QL_DEBUG_LEVEL_2
            qla2100_print("qla2100_error_entry: ISP Invalid handle\n");
#endif
            printk(KERN_WARNING "!qla2100: Error Entry invalid handle");
            ha->flags.isp_abort_needed = TRUE;
        }

#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_error_entry");
#endif
    }

    /*
    *  qla2100_abort_isp
    *      Resets ISP and aborts all outstanding commands.
    *
    * Input:
    *      ha           = adapter block pointer.
    *
    * Returns:
    *      0 = success
    */
    STATIC uint8_t
    qla2100_abort_isp(scsi_qla_host_t *ha) {
        uint16_t       cnt;
        srb_t          *sp;
        scsi_lu_t      *q;
        uint32_t       b, t, l;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
        unsigned long cpu_flags = 0;
#endif
        uint8_t        status = 0;

        ENTER("qla2100_abort_isp");

        DRIVER_LOCK
            ha->flags.isp_abort_needed = FALSE;
        if( !ha->flags.abort_isp_active && ha->flags.online ) {
            ha->flags.abort_isp_active = TRUE;
            ha->flags.online = FALSE;

            qla2100_reset_chip(ha); 

            if( ha->loop_state != LOOP_DOWN ) {
                ha->loop_state = LOOP_DOWN;
                ha->loop_down_timer = LOOP_DOWN_TIME;
            }

            /* Requeue all commands in outstanding command list. */
            for( cnt = 1; cnt < MAX_OUTSTANDING_COMMANDS; cnt++ ) {
                sp = ha->outstanding_cmds[cnt];
                if( sp ) {
                    ha->outstanding_cmds[cnt] = 0;
                    /* Generate LU queue on controller, target, LUN */
                    b = SCSI_BUS_32(sp->cmd);
                    t = SCSI_TCN_32(sp->cmd);
                    l = SCSI_LUN_32(sp->cmd);
                    if ( (q = (scsi_lu_t       *)GET_LU_Q(ha, b, t, l)) )
                    {
                        /* Reset outstanding command count. */
                        q->q_outcnt = 0;
                        q->q_flag &= ~QLA2100_QBUSY;
                    }
                    /* sp->flags &= ~(SRB_SENT | SRB_TIMEOUT); */
                    sp->flags = 0;
#if QLA2100_OS_TIMER
                    /* we need to send the command back to OS */
                    CMD_RESULT(sp->cmd) = DID_BUS_BUSY << 16;
                    CMD_HANDLE(sp->cmd) = (unsigned char *) NULL;
                    qla2100_done_q_put(sp, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
#else
                    /* Adjust watchdog timer for command. */
                    /* Place request back on top of device queue. */
                    qla2100_putq_t(q, sp);
#endif
                }
            }

            if( ha->device_id == QLA2100_DEVICE_ID )  
                qla2100_nvram_config(ha);
            else
                qla2200_nvram_config(ha);

            if( !qla2100_configure_loop(ha, TRUE) ) {
                ha->flags.reset_marker = FALSE;

                if( !ha->loop_down_timer )
                    qla2100_marker(ha, 0, 0, 0, MK_SYNC_ALL);

                ha->flags.online = TRUE;

                /* Enable target response to SCSI bus. */
                if( ha->flags.enable_target_mode )
                    qla2100_enable_lun(ha);

                /* Enable ISP interrupts. */
                qla2100_enable_intrs(ha);

                /* Restart queues that may have been stopped. */
                ha->flags.abort_isp_active = FALSE;
                if( !ha->loop_down_timer )
                    qla2100_restart_queues(ha,TRUE);
            } else {
                printk(KERN_WARNING
                    "qla2100: ISP error recovery failed, board disabled");
                qla2100_reset_adapter(ha);
                qla2100_abort_queues(ha, FALSE);
            }
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_abort_isp: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_abort_isp");
#endif
        return(status);
    }
    /*
    *  qla2100_restart_queues
    *      Restart device queues.
    *
    * Input:
    *      ha = adapter block pointer.
    */
    STATIC void
        qla2100_restart_watchdog_queue(scsi_qla_host_t *ha) {
        srb_t  *sp, *sp_next;

        for( sp = ha->retry_q_first; (sp); sp = sp_next ) {
             sp_next = sp->s_next;
             /* when time expire return request back to OS as BUSY */
            qla2100_timeout_remove(ha, sp);
            CMD_RESULT(sp->cmd) = DID_BUS_BUSY << 16;
            CMD_HANDLE(sp->cmd) = (unsigned char *) NULL;
           qla2100_done_q_put(sp, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
        }

   }

    /*
    *  qla2100_restart_queues
    *      Restart device queues.
    *
    * Input:
    *      ha = adapter block pointer.
    */
    STATIC void
        qla2100_restart_queues(scsi_qla_host_t *ha, uint8_t flush) {
        scsi_lu_t *q;
        uint32_t  b, t, l;
        srb_t  *sp, *sp_next;
        srb_t        *done_q_first = (srb_t *) NULL;
        srb_t        *done_q_last = (srb_t *) NULL;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_restart_queues");
#endif

        ha->flags.restart_queues_needed = FALSE;

        /*
        * start all queues working again.
        */
        for( b = 0; b < MAX_BUSES; b++ )
            for( t = 0; t < ha->max_targets; t++ ) {
                if( TGT_Q(ha, b, t)  == NULL )
                    continue;
                for( l = 0; l < ha->max_luns; l++ ) {
                    q = (scsi_lu_t *) GET_LU_Q(ha, b, t, l);
                    if( q != NULL ) {
                        /* Acquire LU queue specific lock */

                        q->q_flag &= ~QLA2100_QSUSP;
                        if( q->q_first )
                            qla2100_next(ha, q);
                        /* else */
                        /* Release LU queue specific lock */
                    }
                }
            }

#if 1
        /*
        * Clear out our retry queue 
        */
            if( flush )
                for( sp = ha->retry_q_first; (sp); sp = sp_next ) {
                    sp_next = sp->s_next;
                    /* when time expire return request back to OS as BUSY */
                    qla2100_timeout_remove(ha, sp);
                    CMD_RESULT(sp->cmd) = DID_BUS_BUSY << 16;
                    CMD_HANDLE(sp->cmd) = (unsigned char *) NULL;
                    qla2100_done_q_put(sp, (srb_t **)&done_q_first, (srb_t **)&done_q_last);
                }

         /* Callback everything in done queue */
          while( done_q_first ) {
              /* remove command from done list */
               sp = done_q_first;
               if( !(done_q_first = sp->s_next) )
                     done_q_last = NULL;
               else
                    (done_q_first)->s_prev = NULL;
                 DEBUG(sprintf(debug_buff,"qla2100_restart_queues: callback pid %d\n",sp->cmd->pid);)
                 DEBUG(qla2100_print(debug_buff);)
                 qla2100_callback(ha,sp,FALSE);
           }
#endif

#ifdef QL_DEBUG_LEVEL_3
                LEAVE("qla2100_restart_queues");
#endif
    }

    /*
    *  qla2100_abort_queues
    *      Abort all commands on device queues.
    *
    * Input:
    *      ha = adapter block pointer.
    */
    STATIC void
        qla2100_abort_queues(scsi_qla_host_t *ha, uint8_t doneqflg) {
        scsi_lu_t   *q;
        uint32_t    b, t, l;
        srb_t       *sp, *sp_next;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_abort_queues");
#endif
        ha->flags.abort_queue_needed = FALSE;

        for( b = 0; b < MAX_BUSES; b++ )
            for( t = 0; t < ha->max_targets; t++ ) {
                if( TGT_Q(ha, b, t) == NULL )
                    continue;
                for( l = 0; l < MAX_LUNS; l++ ) {
                    q = GET_LU_Q(ha, b, t, l);
                    if( q != NULL ) {
                        /* Try to acquire LU queue specific lock */
                        /* if( queue is not busy ) 
                        { */
                        sp = q->q_first;
                        q->q_first = q->q_last = NULL;

                        while( sp ) {
                            sp_next = sp->s_next;
                            CMD_RESULT(sp->cmd) = DID_BUS_BUSY << 16;
                            if ( doneqflg ) {
                              CMD_HANDLE(sp->cmd) = (unsigned char *) NULL;
                              qla2100_done_q_put(sp, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
                            }
                            else
                            qla2100_callback(ha,sp,FALSE);
                            sp = sp_next;
                        }
                        /* }
                        else
                        ha->flags.abort_queue_needed = TRUE;
                        */
                    }
                }
            }

#ifdef QL_DEBUG_LEVEL_3
            LEAVE("qla2100_abort_queues");
#endif
    }

    /*
    *  qla2100_update_config
    *      Restart RISC in order to update the connection mode.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success
    */
    uint8_t
    qla2100_update_config(scsi_qla_host_t *ha) {
        uint8_t   status = 0;

#ifdef QL_DEBUG_LEVEL_3
        qla2100_print("qla2100_update_config: entered\n");
#endif
        /* Turn-off flag, so we don't get called again */
        ha->flags.update_config_needed = FALSE;

        /* get the new topology */
        qla2100_configure_hba(ha);

        ha->init_cb->additional_firmware_options.connection_options = ha->operating_mode;
        DEBUG(printk("qla2100_update_config: Setting new topology to %d\n" , ha->operating_mode);)

        qla2100_reset_chip(ha);

        if( ha->loop_state != LOOP_DOWN ) {
            ha->loop_state = LOOP_DOWN;
            ha->loop_down_timer = LOOP_DOWN_TIME;
        }

        if( !(status = qla2100_configure_loop(ha, TRUE)) ) {
            ha->flags.reset_marker = FALSE;
            if( !ha->loop_down_timer )
                qla2100_marker(ha, 0, 0, 0, MK_SYNC_ALL);

            ha->flags.online = TRUE;

            /* Enable target response to SCSI bus. */
            if( ha->flags.enable_target_mode )
                qla2100_enable_lun(ha);

        }

        /* Enable ISP interrupts. */
        qla2100_enable_intrs(ha);
        /* WRT_REG_WORD(&reg->ictrl, ISP_EN_INT + ISP_EN_RISC); */
#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_update_config: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            qla2100_print("qla2100_update_config: exiting normally\n");
#endif
        return(status);
    }

    /*
    *  qla2100_loop_resync
    *      Resync with fibre channel devices.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success
    */
    STATIC uint8_t
    qla2100_loop_resync(scsi_qla_host_t *ha) {
        uint8_t   status;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_loop_resync");
#endif

        if( ha->flags.online && !ha->flags.loop_resync_active &&
            !ha->flags.abort_isp_active ) {
            ha->flags.loop_resync_active = TRUE;
            if( !(status = qla2100_fw_ready(ha)) ) {
                do {
                    ha->flags.loop_resync_needed = FALSE;

                    /* Issue marker command. */
                    qla2100_marker(ha, 0, 0, 0, MK_SYNC_ALL);

                    /* Remap devices on Loop. */
                    qla2100_update_fc_db(ha, TRUE);

                }while( !ha->loop_down_timer && ha->flags.loop_resync_needed );
            }
            ha->flags.loop_resync_active = FALSE;
        } else
            status = 0;

        /* Restart queues that may have been stopped. */
        if( !ha->loop_down_timer ) {
            qla2100_restart_queues(ha,TRUE);
        }

#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
        if( status )
            qla2100_print("qla2100_loop_resync: **** FAILED ****\n");
#endif
#ifdef QL_DEBUG_LEVEL_3
        else
            LEAVE("qla2100_loop_resync");
#endif
        return(status);
    }

    /*
    * qla2100_debounce_register
    *      Debounce register.
    *
    * Input:
    *      port = register address.
    *
    * Returns:
    *      register value.
    */
    STATIC uint16_t
    qla2100_debounce_register(volatile uint16_t *addr) {
        volatile uint16_t ret;
        volatile uint16_t ret2;

        do {
            ret = RD_REG_WORD(addr);
            ret2 = RD_REG_WORD(addr);
        }while( ret != ret2 );

        return(ret);
    }

    /*
    * qla2100_reset_chip
    *      Reset ISP chip.
    *
    * Input:
    *      ha = adapter block pointer.
    */
    STATIC void
        qla2100_reset_chip(scsi_qla_host_t *ha) {
        uint32_t     cnt;
        device_reg_t *reg = ha->iobase;

#ifdef QL_DEBUG_LEVEL_3
        ENTER("qla2100_reset_chip");
#endif

        /* Disable ISP interrupts. */
        qla2100_disable_intrs(ha);
        /* WRT_REG_WORD(&reg->ictrl, 0); */

        /* Insure mailbox registers are free. */
        WRT_REG_WORD(&reg->semaphore, 0);
        WRT_REG_WORD(&reg->host_cmd, HC_CLR_RISC_INT);
        WRT_REG_WORD(&reg->host_cmd, HC_CLR_HOST_INT);

        /* clear mailbox busy */
        ha->flags.mbox_busy = FALSE;

        /* Reset ISP chip. */
        WRT_REG_WORD(&reg->ctrl_status, ISP_RESET);

        /*
        * Delay after reset, for chip to recover.
        * Otherwise causes system PANIC
        */
        mdelay(2);

        for( cnt = 30000; cnt; cnt-- ) {
            if( !(RD_REG_WORD(&reg->ctrl_status) & ISP_RESET) )
                break;
            SYS_DELAY(100);
        }

        /* Reset RISC processor. */
        WRT_REG_WORD(&reg->host_cmd, HC_RESET_RISC);
        WRT_REG_WORD(&reg->host_cmd, HC_RELEASE_RISC);
        for( cnt = 30000; cnt; cnt-- ) {
            if( RD_REG_WORD(&reg->mailbox0) != MBS_BUSY )
                break;
            SYS_DELAY(100);
        }

#ifdef QL_DEBUG_LEVEL_3
        LEAVE("qla2100_reset_chip");
#endif
    }
    /*
    *  qla2100_configure_loop
    *      Resync with fibre channel devices.
    *
    * Input:
    *      ha = adapter block pointer.
    *
    * Returns:
    *      0 = success
    */

    STATIC uint8_t qla2100_configure_loop(scsi_qla_host_t *ha, uint8_t reuse) {
        uint8_t status = 0;

        /* If firmware needs to be loaded */
        if( qla2100_isp_firmware(ha) ) {
            ha->flags.online = FALSE;
            if( !(status = qla2100_chip_diag(ha)) )
                status = qla2100_setup_chip(ha);
        }

        if( !status && !(status = qla2100_init_rings(ha)) ) {
            if( !qla2100_fw_ready(ha) ) {
                ha->flags.reset_marker = FALSE;
                do {
                    ha->flags.loop_resync_needed = FALSE;
                    /* remap devices on loop */
                    qla2100_update_fc_db(ha, reuse);
                }while( !ha->loop_down_timer && ha->flags.loop_resync_needed );
            }
        }
        return(status);
    }
    

    /*
    * Declarations for load module
    */
#ifdef MODULE
    Scsi_Host_Template driver_template = QLA2100_LINUX_TEMPLATE;

#include "scsi_module.c"
#endif

#ifdef QL_DEBUG_ROUTINES
        /****************************************************************************/
        /*                         Driver Debug Functions.                          */
        /****************************************************************************/

        /*
    *  Get byte from I/O port
    */
        STATIC uint8_t
        qla2100_getbyte(uint8_t *port) {
        uint8_t ret;

#ifdef MEMORY_MAPPED_IO
        ret = *port;
#else
        ret = inb((int)port);
#endif

        if( ql_debug_print ) {
            qla2100_print("qla2100_getbyte: address = ");
            qla2100_output_number((u_long)port, 16);
            qla2100_print(" data = 0x");
            qla2100_output_number((u_long)ret, 16);
            qla2100_print("\n");
        }

        return(ret);
    }

    /*
    *  Get word from I/O port
    */
    STATIC uint16_t
    qla2100_getword(uint16_t *port) {
        uint16_t ret;

#ifdef MEMORY_MAPPED_IO
        ret = *port;
#else
        ret = inw((int)port);
#endif

        if( ql_debug_print ) {
            qla2100_print("qla2100_getword: address = ");
            qla2100_output_number((u_long)port, 16);
            qla2100_print(" data = 0x");
            qla2100_output_number((u_long)ret, 16);
            qla2100_print("\n");
        }

        return(ret);
    }

    /*
    *  Get double word from I/O port
    */
    STATIC uint32_t
    qla2100_getdword(uint32_t *port) {
        uint32_t ret;

#ifdef MEMORY_MAPPED_IO
        ret = *port;
#else
        ret = inl((int)port);
#endif

        if( ql_debug_print ) {
            qla2100_print("qla2100_getdword: address = ");
            qla2100_output_number((u_long)port, 16);
            qla2100_print(" data = 0x");
            qla2100_output_number((u_long)ret, 16);
            qla2100_print("\n");
        }

        return(ret);
    }

    /*
    *  Send byte to I/O port
    */
    STATIC void
        qla2100_putbyte(uint8_t *port, uint8_t data) {
#ifdef MEMORY_MAPPED_IO
        *port = data;
#else
        outb(data, (int)port);
#endif

        if( ql_debug_print ) {
            qla2100_print("qla2100_putbyte: address = ");
            qla2100_output_number((u_long)port, 16);
            qla2100_print(" data = 0x");
            qla2100_output_number((u_long)data, 16);
            qla2100_print("\n");
        }
    }

    /*
    *  Send word to I/O port
    */
    STATIC void
        qla2100_putword(uint16_t *port, uint16_t data) {
#ifdef MEMORY_MAPPED_IO
        *port = data;
#else
#ifdef _LINUX_IOPORTS
        outw(data, (int)port);
#else
        outw((int)port, data);
#endif
#endif

        if( ql_debug_print ) {
            qla2100_print("qla2100_putword: address = ");
            qla2100_output_number((u_long)port, 16);
            qla2100_print(" data = 0x");
            qla2100_output_number((u_long)data, 16);
            qla2100_print("\n");
        }
    }

    /*
    *  Send double word to I/O port
    */
    STATIC void
        qla2100_putdword(uint32_t *port, uint32_t data) {
#ifdef MEMORY_MAPPED_IO
        *port = data;
#else
#ifdef _LINUX_IOPORTS
        outl(data,(int)port);
#else
        outl((int)port, data);
#endif
#endif

        if( ql_debug_print ) {
            qla2100_print("qla2100_putdword: address = ");
            qla2100_output_number((u_long)port, 16);
            qla2100_print(" data = 0x");
            qla2100_output_number((u_long)data, 16);
            qla2100_print("\n");
        }
    }

    /*
    * Dummy function to prevent warnings for
    * declared and unused debug functions
    */
    void
        qla2100_debug(void) {
        qla2100_getbyte(0);
        qla2100_getword(0);
        qla2100_getdword(0);
        qla2100_putbyte(0, 0);
        qla2100_putword(0, 0);
        qla2100_putdword(0, 0);
    }

    /*
    *  Out character to COM2 port.
    *      PORT must be at standard address for COM2 = 0x2F8,
    *      or COM1 = 0x3F8
    */
#define OUTB(addr,data)   outb((data),(addr))
    STATIC void
        qla2100_putc(int8_t c) {
#ifdef QL_DEBUG_CONSOLE

        printk("%c",c);

#else /* QL_DEBUG_CONSOLE */

        uint8_t data;
        int     com_addr              = 0x3f8;
        int     hardware_flow_control = 1;
        int     software_flow_control = 0;
        uint8_t loop                  = TRUE;

        do {

            /* Wait for transmitter holding and shift registers for empty. */
            do {
                data = inb(com_addr+5);
            }while( !(data & BIT_6) );

            /*
            * Set BAUD rate for COM2 to 19200
            */

            /* Select rate divisor. */
            outb(com_addr+3, 0x83);

            /* BAUD rate divisor LSB. */
            OUTB(com_addr+3, 0x83); 

            /* BAUD rate divisor MSB. */
            OUTB(com_addr, 0xc);                    /* 0xC = 9600 baud */

            /* Set No parity, 8 bits, 1 stop bit and
            select interrupt enable register. */
            OUTB(com_addr+3, 3);

            /* Disable interrupts. */
            OUTB(com_addr+1, 0);

            /* Set data terminal ready and request to send */
            OUTB(com_addr+1, 0);

            if( hardware_flow_control ) {
                /* Wait for clear-to-send and data-set-ready */
                do {
                    data = inb(com_addr+6) & (BIT_5 + BIT_4);
                }while( data != (BIT_5 + BIT_4) );
            } else if( software_flow_control ) {
                /* Test for data ready. */
                data = inb(com_addr+5);
                if( data & BIT_0 ) {
                    /* If XOFF */
                    data = inb(com_addr);
                    if( data == '\023' ) {
                        /* Wait for XON */
                        do {
                            /* Wait for int8_t */
                            do {
                                data = inb(com_addr+5);
                            }while( !(data & BIT_0) );
                            data = inb(com_addr);
                        }while( data != '\021' );
                    }
                }
            }

            /* Output character. */
            OUTB(com_addr, c);

            /* Add return. */
            if( c == '\n' )
                c = '\r';
            else
                loop = FALSE;

        }while( loop );
#endif  /* QL_DEBUG_CONSOLE */
    }

    /*
    *  Out NULL terminated string to COM port.
    */
    STATIC void
        qla2100_print(int8_t *s) {
        if( ql_debug_print ) {
#ifdef QL_DEBUG_CONSOLE
            printk("%s",s);
#else
            /* Output string. */
            while( *s )
                qla2100_putc(*s++);
#endif
        }
    }

    /*
    *  Output long number to COM port.
    */
    STATIC void
        qla2100_output_number(u_long n, uint8_t base) {
        int8_t str[12];
        int8_t *s      = &str[11];
        uint8_t output = 0;
        uint8_t hex    = FALSE;

        if( ql_debug_print ) {
            if( base == 10 || base == 16 ) {
                if( base == 16 && n > 9 )
                    hex = TRUE;

                *s = 0;
                do {
                    s--;
                    *s = n % base;
                    if( *s > 9 )
                        *s += 55;
                    else
                        *s += '0';
                    n /= base;
                }while( n );

                for( ; *s; s++ ) {
                    if( *s != '0' )
                        output = 1;
                    if( output )
                        qla2100_putc(*s);
                }
                if( !output )
                    qla2100_putc(*--s);

                if( hex )
                    qla2100_putc('h');
            }
        }
    }

    STATIC void
        qla2100_dump_buffer(uint8_t *b, uint32_t size) {
        uint32_t cnt;
        uint8_t c;

        if( ql_debug_print ) {
            qla2100_print(
                " 0   1   2   3   4   5   6   7   8   9   Ah  Bh  Ch  Dh  Eh  Fh\n");
            qla2100_print(
                "---------------------------------------------------------------\n");

            for( cnt = 0; cnt < size; ) {
                c = *b++;
                if( c < 16 )
                    qla2100_putc(' ');
                qla2100_output_number((uint32_t)c, 16);
                cnt++;
                if( !(cnt % 16) )
                    qla2100_print("\n");
                else if( c < 10 )
                    qla2100_print("  ");
                else
                    qla2100_putc(' ');
            }
            if( cnt % 16 )
                qla2100_print("\n");
        }
    }
    /**************************************************************************
    *   ql2100_print_scsi_cmd
    *
    **************************************************************************/
    void qla2100_print_scsi_cmd(Scsi_Cmnd *cmd) {
        scsi_qla_host_t *ha;
        struct Scsi_Host  *host = cmd->host;
        srb_t           *sp;
#ifdef QLA2100_UNUSED
        struct scatterlist *sg;
#endif

        int i;
        ha = (scsi_qla_host_t *) host->hostdata;

        ql_debug_print = 1;
        sp = (srb_t *) CMD_SP(cmd);
        sprintf(debug_buff,"SCSI Command @= 0x%p, Handle=0x%08lx\n\r", cmd, (u_long)CMD_HANDLE(cmd));
        qla2100_print(debug_buff);
        sprintf(debug_buff,"  chan=%d, target = 0x%02x, lun = 0x%02x, cmd_len = 0x%02x\n\r",
            cmd->channel, cmd->target, cmd->lun, cmd->cmd_len);
        qla2100_print(debug_buff);
        qla2100_print(" CDB = ");
        for( i = 0; i < cmd->cmd_len; i++ ) {
            sprintf(debug_buff,"0x%02x ", cmd->cmnd[i]);
            qla2100_print(debug_buff);
        }
        sprintf(debug_buff,"\n\r  seg_cnt =%d, retries=%d, serial_number_at_timeout=0x%lx\n\r",cmd->use_sg,cmd->retries,cmd->serial_number_at_timeout);
        qla2100_print(debug_buff);
        sprintf(debug_buff,"  request buffer=0x%p, request buffer len=0x%x\n\r",cmd->request_buffer,cmd->request_bufflen);
        qla2100_print(debug_buff);
#ifdef QLA2100_UNUSED
        if( cmd->use_sg ) {
            sg = (struct scatterlist *) cmd->request_buffer;
            qla2100_print("  SG buffer: \n\r");
            qla2100_dump_buffer((caddr_t)sg, (cmd->use_sg*sizeof(struct scatterlist)));
        } 
#endif
        sprintf(debug_buff,"  tag=%d, flags=0x%x, transfersize=0x%x \n\r", 
            cmd->tag, cmd->flags,cmd->transfersize);
        qla2100_print(debug_buff);
        sprintf(debug_buff,"  Pid=%ld, SP=0x%p\n\r", cmd->pid, sp);
        qla2100_print(debug_buff);
        sprintf(debug_buff,"  r_start=0x%lx, u_start=0x%lx\n\r",sp->r_start,sp->u_start);
        qla2100_print(debug_buff);
        sprintf(debug_buff,"  sp flags=0x%x, wdgtime=%d\n\r",sp->flags,sp->wdg_time);
        qla2100_print(debug_buff);
    }

        
    void qla2100_print_q_info(scsi_lu_t *q) 
    {
            sprintf(debug_buff,"Queue info: queue in =%ld, queue out= %d, flags=0x%x\n\r", q->q_incnt, q->q_outcnt, q->q_flag);
            qla2100_print(debug_buff);
    }

    /**************************************************************************
    *   ql2100_dump_device
    *
    **************************************************************************/
    void
        ql2100_dump_device(scsi_qla_host_t *ha) {

        Scsi_Cmnd       *cp;
        srb_t           *sp;
        int i;
        qla2100_print("Outstanding Commands on controller:\n\r");   
        for( i=0; i < MAX_OUTSTANDING_COMMANDS; i++ ) {
            if( (sp = ha->outstanding_cmds[i]) == NULL )
                continue;
            if( (cp = sp->cmd) == NULL )
                continue;
            sprintf(debug_buff,"(%d): Pid=%ld, sp flags=0x%x, SP=0x%lx\n\r", i, sp->cmd->pid, sp->flags,(u_long)CMD_SP(sp->cmd));
            qla2100_print(debug_buff);
        }

    }
#endif




    /**************************************************************************
    *   ql2100_dump_regs
    *
    **************************************************************************/
    static void qla2100_dump_regs(struct Scsi_Host *host) {
        printk("Mailbox registers:\n");
        printk("qla2100 : mbox 0 0x%04x \n", inw(host->io_port + 0x10));
        printk("qla2100 : mbox 1 0x%04x \n", inw(host->io_port + 0x12));
        printk("qla2100 : mbox 2 0x%04x \n", inw(host->io_port + 0x14));
        printk("qla2100 : mbox 3 0x%04x \n", inw(host->io_port + 0x16));
        printk("qla2100 : mbox 4 0x%04x \n", inw(host->io_port + 0x18));
        printk("qla2100 : mbox 5 0x%04x \n", inw(host->io_port + 0x1a));
#ifdef TRACECODE
        sprintf(debug_buff,"qla2100 : mbox 0 0x%04x \n\r", inw(host->io_port + 0x10));
        qla2100_print(debug_buff);
        sprintf(debug_buff,"qla2100 : mbox 1 0x%04x \n\r", inw(host->io_port + 0x12));
        qla2100_print(debug_buff);
        sprintf(debug_buff,"qla2100 : mbox 2 0x%04x \n\r", inw(host->io_port + 0x14));
        qla2100_print(debug_buff);
        sprintf(debug_buff,"qla2100 : mbox 3 0x%04x \n\r", inw(host->io_port + 0x16));
        qla2100_print(debug_buff);
        sprintf(debug_buff,"qla2100 : mbox 4 0x%04x \n\r", inw(host->io_port + 0x18));
        qla2100_print(debug_buff);
        sprintf(debug_buff,"qla2100 : mbox 5 0x%04x \n\r", inw(host->io_port + 0x1a));
        qla2100_print(debug_buff);
#endif
    }


#if  STOP_ON_ERROR 
    /**************************************************************************
    *   ql2100_panic
    *
    **************************************************************************/
    static void qla2100_panic(char *cp, struct Scsi_Host *host) {
        scsi_qla_host_t *ha;
        long  *fp;

        ha = (scsi_qla_host_t *) host->hostdata;
        DEBUG2(ql_debug_print = 1;)
        sprintf(debug_buff,"qla2100 - PANIC:  %s\n",cp);
        qla2100_print(debug_buff);
        sprintf(debug_buff,"Current time=0x%lx\n", jiffies);
        qla2100_print(debug_buff);
        sprintf(debug_buff,"Number of pending commands =0x%lx\n", ha->actthreads);
        qla2100_print(debug_buff);
        sprintf(debug_buff,"Number of queued commands =0x%lx\n", ha->qthreads);
        qla2100_print(debug_buff);
        sprintf(debug_buff,"Number of free entries = (%d)\n",ha->req_q_cnt);
        qla2100_print(debug_buff);
        sprintf(debug_buff,"Request Queue @ 0x%lx, Response Queue @ 0x%lx\n",
            ha->request_dma,
            ha->response_dma);
        qla2100_print(debug_buff);
        sprintf(debug_buff,"Request In Ptr %d\n", ha->req_ring_index);
        qla2100_print(debug_buff);
        fp = (long *) &ha->flags;
        sprintf(debug_buff,"HA flags =0x%lx\n", *fp);
        qla2100_print(debug_buff);
        ql2100_dump_device(ha); 
        qla2100_dump_regs(host);
        cli(); 
        for( ;; ) { 
            QLA2100_DELAY(2); barrier();
        }
        sti();  
    }
#endif

    static void qla2100_set_flags(int flag) {

        switch( flag ) {
        case 0x1:
            qla2100_verbose = 1L;

        }

    }

    /**************************************************************************
    *   qla2100_setup
    *
    *   Handle Linux boot parameters. This routine allows for assigning a value
    *   to a parameter with a ':' between the parameter and the value.
    *   ie. qla2x00smp=max_reqs:0x0A,verbose
    **************************************************************************/
#define NUM_OF_OPTIONS  3
    void
        qla2100_setup(char *s, int *dummy) {
        char *end, *str, *cp;
        int    i;

        static struct {
            const char *name;
            int      siz;
            void  (*func)(int);
            int   arg1;
        } options[] = {
            /* Name ,    size,  routine, arg1       */
            /*	   { "dump_regs", 9,  &qla2100_dump_regs, 99}, */
            { "verbose", 7, &qla2100_set_flags, 0x1 
            },
        };

        printk("scsi: Processing Option str = %s\n", s);
        end = strchr(s, '\0');
        /* locate command */
        str = s;
        for( cp = s; (*cp) && cp != end; cp++ ) {
            cp = qla2100_get_token(cp, str);
            printk("scsi: token str = %s\n", str);
            /* if found execute routine */
            for( i = 0; *options[i].name != '\0' && i < NUM_OF_OPTIONS ; i++ ) {
                /* found a match */
                if( strncmp(str, options[i].name, 6) == 0 ) {
                    options[i].func(options[i].arg1);
                    break;
                }
            }
        }


    }
    static char	*qla2100_get_token(char *cmdline, char *str) {
        register	char 	*cp = cmdline;

        /* skip preceeding spaces */
        while( strchr(cp,' ') )
            ++cp;
        /* symbol starts here */
        str = cp;
        /* skip char if not a space or : */
        while( *cp && !( strchr(cp,' ') || strchr(cp,':')) )
            cp++;
        *cp = '\0';
        return(cp);
    }

    /*
    * Overrides for Emacs so that we almost follow Linus's tabbing style.
    * Emacs will notice this stuff at the end of the file and automatically
    * adjust the settings for this buffer only.  This must remain at the end
    * of the file.
    * ---------------------------------------------------------------------------
    * Local variables:
    * c-indent-level: 2
    * c-brace-imaginary-offset: 0
    * c-brace-offset: -2
    * c-argdecl-indent: 2
    * c-label-offset: -2
    * c-continued-statement-offset: 2
    * c-continued-brace-offset: 0
    * indent-tabs-mode: nil
    * tab-width: 8
    * End:
    */




